// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type AbandonInstancesRequest struct {

    core.JDCloudRequest

    /* 地域  */
    RegionId string `json:"regionId"`

    /* 高可用组 ID  */
    AgId string `json:"agId"`

    /* 准备剔除出高可用组的实例 id  */
    InstanceIds []string `json:"instanceIds"`
}

/*
 * param regionId: 地域 (Required)
 * param agId: 高可用组 ID (Required)
 * param instanceIds: 准备剔除出高可用组的实例 id (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewAbandonInstancesRequest(
    regionId string,
    agId string,
    instanceIds []string,
) *AbandonInstancesRequest {

	return &AbandonInstancesRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/availabilityGroups/{agId}:abandonInstances",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        AgId: agId,
        InstanceIds: instanceIds,
	}
}

/*
 * param regionId: 地域 (Required)
 * param agId: 高可用组 ID (Required)
 * param instanceIds: 准备剔除出高可用组的实例 id (Required)
 */
func NewAbandonInstancesRequestWithAllParams(
    regionId string,
    agId string,
    instanceIds []string,
) *AbandonInstancesRequest {

    return &AbandonInstancesRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/availabilityGroups/{agId}:abandonInstances",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        AgId: agId,
        InstanceIds: instanceIds,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewAbandonInstancesRequestWithoutParam() *AbandonInstancesRequest {

    return &AbandonInstancesRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/availabilityGroups/{agId}:abandonInstances",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域(Required) */
func (r *AbandonInstancesRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param agId: 高可用组 ID(Required) */
func (r *AbandonInstancesRequest) SetAgId(agId string) {
    r.AgId = agId
}

/* param instanceIds: 准备剔除出高可用组的实例 id(Required) */
func (r *AbandonInstancesRequest) SetInstanceIds(instanceIds []string) {
    r.InstanceIds = instanceIds
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r AbandonInstancesRequest) GetRegionId() string {
    return r.RegionId
}

type AbandonInstancesResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result AbandonInstancesResult `json:"result"`
}

type AbandonInstancesResult struct {
}