// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type CreateAgRequest struct {

    core.JDCloudRequest

    /* 地域  */
    RegionId string `json:"regionId"`

    /* 支持的可用区，最少一个  */
    Azs []string `json:"azs"`

    /* 高可用组名称，只支持中文、数字、大小写字母、英文下划线 “_” 及中划线 “-”，且不能超过 32 字符  */
    AgName string `json:"agName"`

    /* 高可用组类型，支持vm (Optional) */
    AgType *string `json:"agType"`

    /* 实例模板的Id  */
    InstanceTemplateId string `json:"instanceTemplateId"`

    /* 描述，长度不超过 256 字符 (Optional) */
    Description *string `json:"description"`
}

/*
 * param regionId: 地域 (Required)
 * param azs: 支持的可用区，最少一个 (Required)
 * param agName: 高可用组名称，只支持中文、数字、大小写字母、英文下划线 “_” 及中划线 “-”，且不能超过 32 字符 (Required)
 * param instanceTemplateId: 实例模板的Id (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCreateAgRequest(
    regionId string,
    azs []string,
    agName string,
    instanceTemplateId string,
) *CreateAgRequest {

	return &CreateAgRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/availabilityGroups",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Azs: azs,
        AgName: agName,
        InstanceTemplateId: instanceTemplateId,
	}
}

/*
 * param regionId: 地域 (Required)
 * param azs: 支持的可用区，最少一个 (Required)
 * param agName: 高可用组名称，只支持中文、数字、大小写字母、英文下划线 “_” 及中划线 “-”，且不能超过 32 字符 (Required)
 * param agType: 高可用组类型，支持vm (Optional)
 * param instanceTemplateId: 实例模板的Id (Required)
 * param description: 描述，长度不超过 256 字符 (Optional)
 */
func NewCreateAgRequestWithAllParams(
    regionId string,
    azs []string,
    agName string,
    agType *string,
    instanceTemplateId string,
    description *string,
) *CreateAgRequest {

    return &CreateAgRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/availabilityGroups",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Azs: azs,
        AgName: agName,
        AgType: agType,
        InstanceTemplateId: instanceTemplateId,
        Description: description,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCreateAgRequestWithoutParam() *CreateAgRequest {

    return &CreateAgRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/availabilityGroups",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域(Required) */
func (r *CreateAgRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param azs: 支持的可用区，最少一个(Required) */
func (r *CreateAgRequest) SetAzs(azs []string) {
    r.Azs = azs
}

/* param agName: 高可用组名称，只支持中文、数字、大小写字母、英文下划线 “_” 及中划线 “-”，且不能超过 32 字符(Required) */
func (r *CreateAgRequest) SetAgName(agName string) {
    r.AgName = agName
}

/* param agType: 高可用组类型，支持vm(Optional) */
func (r *CreateAgRequest) SetAgType(agType string) {
    r.AgType = &agType
}

/* param instanceTemplateId: 实例模板的Id(Required) */
func (r *CreateAgRequest) SetInstanceTemplateId(instanceTemplateId string) {
    r.InstanceTemplateId = instanceTemplateId
}

/* param description: 描述，长度不超过 256 字符(Optional) */
func (r *CreateAgRequest) SetDescription(description string) {
    r.Description = &description
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CreateAgRequest) GetRegionId() string {
    return r.RegionId
}

type CreateAgResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CreateAgResult `json:"result"`
}

type CreateAgResult struct {
    AgId string `json:"agId"`
}