// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    antipro "github.com/jdcloud-api/jdcloud-sdk-go/services/antipro/models"
)

type DeleteProtectedIpRequest struct {

    core.JDCloudRequest

    /* 地域编码  */
    RegionId string `json:"regionId"`

    /* 防护包实例 Id  */
    InstanceId string `json:"instanceId"`

    /* 删除防护包防护 IP 请求参数  */
    ProtectedIpSpec *antipro.ProtectedIpSpec `json:"protectedIpSpec"`
}

/*
 * param regionId: 地域编码 (Required)
 * param instanceId: 防护包实例 Id (Required)
 * param protectedIpSpec: 删除防护包防护 IP 请求参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDeleteProtectedIpRequest(
    regionId string,
    instanceId string,
    protectedIpSpec *antipro.ProtectedIpSpec,
) *DeleteProtectedIpRequest {

	return &DeleteProtectedIpRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/instances/{instanceId}:deleteProtectedIp",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        InstanceId: instanceId,
        ProtectedIpSpec: protectedIpSpec,
	}
}

/*
 * param regionId: 地域编码 (Required)
 * param instanceId: 防护包实例 Id (Required)
 * param protectedIpSpec: 删除防护包防护 IP 请求参数 (Required)
 */
func NewDeleteProtectedIpRequestWithAllParams(
    regionId string,
    instanceId string,
    protectedIpSpec *antipro.ProtectedIpSpec,
) *DeleteProtectedIpRequest {

    return &DeleteProtectedIpRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}:deleteProtectedIp",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        InstanceId: instanceId,
        ProtectedIpSpec: protectedIpSpec,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDeleteProtectedIpRequestWithoutParam() *DeleteProtectedIpRequest {

    return &DeleteProtectedIpRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}:deleteProtectedIp",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域编码(Required) */
func (r *DeleteProtectedIpRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param instanceId: 防护包实例 Id(Required) */
func (r *DeleteProtectedIpRequest) SetInstanceId(instanceId string) {
    r.InstanceId = instanceId
}

/* param protectedIpSpec: 删除防护包防护 IP 请求参数(Required) */
func (r *DeleteProtectedIpRequest) SetProtectedIpSpec(protectedIpSpec *antipro.ProtectedIpSpec) {
    r.ProtectedIpSpec = protectedIpSpec
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DeleteProtectedIpRequest) GetRegionId() string {
    return r.RegionId
}

type DeleteProtectedIpResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DeleteProtectedIpResult `json:"result"`
}

type DeleteProtectedIpResult struct {
    Code int `json:"code"`
    Message string `json:"message"`
}