// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    antipro "github.com/jdcloud-api/jdcloud-sdk-go/services/antipro/models"
)

type ModifyInstanceNameRequest struct {

    core.JDCloudRequest

    /* 地域编码  */
    RegionId string `json:"regionId"`

    /* 防护包实例 Id  */
    InstanceId string `json:"instanceId"`

    /* 修改防护包实例名称请求参数  */
    ModifyInstanceNameSpec *antipro.ModifyInstanceNameSpec `json:"modifyInstanceNameSpec"`
}

/*
 * param regionId: 地域编码 (Required)
 * param instanceId: 防护包实例 Id (Required)
 * param modifyInstanceNameSpec: 修改防护包实例名称请求参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewModifyInstanceNameRequest(
    regionId string,
    instanceId string,
    modifyInstanceNameSpec *antipro.ModifyInstanceNameSpec,
) *ModifyInstanceNameRequest {

	return &ModifyInstanceNameRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/instances/{instanceId}:modifyInstanceName",
			Method:  "PATCH",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        InstanceId: instanceId,
        ModifyInstanceNameSpec: modifyInstanceNameSpec,
	}
}

/*
 * param regionId: 地域编码 (Required)
 * param instanceId: 防护包实例 Id (Required)
 * param modifyInstanceNameSpec: 修改防护包实例名称请求参数 (Required)
 */
func NewModifyInstanceNameRequestWithAllParams(
    regionId string,
    instanceId string,
    modifyInstanceNameSpec *antipro.ModifyInstanceNameSpec,
) *ModifyInstanceNameRequest {

    return &ModifyInstanceNameRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}:modifyInstanceName",
            Method:  "PATCH",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        InstanceId: instanceId,
        ModifyInstanceNameSpec: modifyInstanceNameSpec,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewModifyInstanceNameRequestWithoutParam() *ModifyInstanceNameRequest {

    return &ModifyInstanceNameRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}:modifyInstanceName",
            Method:  "PATCH",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域编码(Required) */
func (r *ModifyInstanceNameRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param instanceId: 防护包实例 Id(Required) */
func (r *ModifyInstanceNameRequest) SetInstanceId(instanceId string) {
    r.InstanceId = instanceId
}

/* param modifyInstanceNameSpec: 修改防护包实例名称请求参数(Required) */
func (r *ModifyInstanceNameRequest) SetModifyInstanceNameSpec(modifyInstanceNameSpec *antipro.ModifyInstanceNameSpec) {
    r.ModifyInstanceNameSpec = modifyInstanceNameSpec
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ModifyInstanceNameRequest) GetRegionId() string {
    return r.RegionId
}

type ModifyInstanceNameResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ModifyInstanceNameResult `json:"result"`
}

type ModifyInstanceNameResult struct {
    Code int `json:"code"`
    Message string `json:"message"`
}