// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    baseanti "github.com/jdcloud-api/jdcloud-sdk-go/services/baseanti/models"
)

type DescribeIpResourceProtectInfoRequest struct {

    core.JDCloudRequest

    /* 地域编码. 基础防护已支持华北-北京, 华东-宿迁, 华东-上海, 华南-广州
  */
    RegionId string `json:"regionId"`

    /* 基础防护已防护的公网 IP, 仅支持 ipv4 格式
- 使用 <a href="http://docs.jdcloud.com/anti-ddos-basic/api/describeelasticipresources">describeElasticIpResources</a> 接口查询基础防护已防护的私有网络弹性公网 IP
- 使用 <a href="http://docs.jdcloud.com/anti-ddos-basic/api/describecpsipresources">describeCpsIpResources</a> 接口查询基础防护已防护的云物理服务器公网IP 和 弹性公网 IP
  */
    Ip string `json:"ip"`

    /* 限制查询的开始范围 (Optional) */
    Start *int `json:"start"`

    /* 限制查询的记录数 (Optional) */
    Limit *int `json:"limit"`
}

/*
 * param regionId: 地域编码. 基础防护已支持华北-北京, 华东-宿迁, 华东-上海, 华南-广州
 (Required)
 * param ip: 基础防护已防护的公网 IP, 仅支持 ipv4 格式
- 使用 <a href="http://docs.jdcloud.com/anti-ddos-basic/api/describeelasticipresources">describeElasticIpResources</a> 接口查询基础防护已防护的私有网络弹性公网 IP
- 使用 <a href="http://docs.jdcloud.com/anti-ddos-basic/api/describecpsipresources">describeCpsIpResources</a> 接口查询基础防护已防护的云物理服务器公网IP 和 弹性公网 IP
 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeIpResourceProtectInfoRequest(
    regionId string,
    ip string,
) *DescribeIpResourceProtectInfoRequest {

	return &DescribeIpResourceProtectInfoRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/ipResources/{ip}/protectInfo",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Ip: ip,
	}
}

/*
 * param regionId: 地域编码. 基础防护已支持华北-北京, 华东-宿迁, 华东-上海, 华南-广州
 (Required)
 * param ip: 基础防护已防护的公网 IP, 仅支持 ipv4 格式
- 使用 <a href="http://docs.jdcloud.com/anti-ddos-basic/api/describeelasticipresources">describeElasticIpResources</a> 接口查询基础防护已防护的私有网络弹性公网 IP
- 使用 <a href="http://docs.jdcloud.com/anti-ddos-basic/api/describecpsipresources">describeCpsIpResources</a> 接口查询基础防护已防护的云物理服务器公网IP 和 弹性公网 IP
 (Required)
 * param start: 限制查询的开始范围 (Optional)
 * param limit: 限制查询的记录数 (Optional)
 */
func NewDescribeIpResourceProtectInfoRequestWithAllParams(
    regionId string,
    ip string,
    start *int,
    limit *int,
) *DescribeIpResourceProtectInfoRequest {

    return &DescribeIpResourceProtectInfoRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/ipResources/{ip}/protectInfo",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Ip: ip,
        Start: start,
        Limit: limit,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeIpResourceProtectInfoRequestWithoutParam() *DescribeIpResourceProtectInfoRequest {

    return &DescribeIpResourceProtectInfoRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/ipResources/{ip}/protectInfo",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域编码. 基础防护已支持华北-北京, 华东-宿迁, 华东-上海, 华南-广州
(Required) */
func (r *DescribeIpResourceProtectInfoRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param ip: 基础防护已防护的公网 IP, 仅支持 ipv4 格式
- 使用 <a href="http://docs.jdcloud.com/anti-ddos-basic/api/describeelasticipresources">describeElasticIpResources</a> 接口查询基础防护已防护的私有网络弹性公网 IP
- 使用 <a href="http://docs.jdcloud.com/anti-ddos-basic/api/describecpsipresources">describeCpsIpResources</a> 接口查询基础防护已防护的云物理服务器公网IP 和 弹性公网 IP
(Required) */
func (r *DescribeIpResourceProtectInfoRequest) SetIp(ip string) {
    r.Ip = ip
}

/* param start: 限制查询的开始范围(Optional) */
func (r *DescribeIpResourceProtectInfoRequest) SetStart(start int) {
    r.Start = &start
}

/* param limit: 限制查询的记录数(Optional) */
func (r *DescribeIpResourceProtectInfoRequest) SetLimit(limit int) {
    r.Limit = &limit
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeIpResourceProtectInfoRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeIpResourceProtectInfoResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeIpResourceProtectInfoResult `json:"result"`
}

type DescribeIpResourceProtectInfoResult struct {
    DataList []baseanti.IpResourceProtectInfo `json:"dataList"`
}