// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package models


type ResourceOrderQueryCondition struct {

    /* 主键id (Optional) */
    Id int `json:"id"`

    /* 用户pin (Optional) */
    Pin string `json:"pin"`

    /* 资源id (Optional) */
    ResourceId string `json:"resourceId"`

    /* appCode (Optional) */
    AppCode string `json:"appCode"`

    /* 产品码列表 (Optional) */
    ServiceCodeList []string `json:"serviceCodeList"`

    /* 地域 (Optional) */
    Region string `json:"region"`

    /* 网络类型 0: non-BGP, 1: BGP (Optional) */
    NetworkOperator int `json:"networkOperator"`

    /* 计费类型 1:按配置 2:按用量 3:包年包月 (Optional) */
    BillingType int `json:"billingType"`

    /* resourceIdList (Optional) */
    ResourceIdList []string `json:"resourceIdList"`

    /* >0: 订单还有几天到期; ==0: 订单已经到期; <0: 不管是否到期 (Optional) */
    ExpireInDays int `json:"expireInDays"`

    /* isOnTrial (Optional) */
    IsOnTrial int `json:"isOnTrial"`

    /* 站点信息 0:中国 1:国际 (Optional) */
    Site int `json:"site"`

    /* 资源状态 1:正常 2:停服 3:删除 (Optional) */
    Status int `json:"status"`

    /* 计费状态 0:停止计费 1:计费中 (Optional) */
    BillingStatus int `json:"billingStatus"`

    /* 1、内部计算，使用getExpiringOrderCount时使用，不用传值 默认为-1mybatis筛选时不会关注 2、selectResourceOrderForTask定时任务查询列表时使用，停服天数，必须大于0 (Optional) */
    ExpiringInDays int `json:"expiringInDays"`

    /* billingTypeList (Optional) */
    BillingTypeList []int `json:"billingTypeList"`

    /* 交易单号列表 (Optional) */
    TransactionNos []string `json:"transactionNos"`

    /*  (Optional) */
    OpTypes []int `json:"opTypes"`

    /* 开始时间 (Optional) */
    StartTime string `json:"startTime"`

    /* 结束时间 (Optional) */
    EndTime string `json:"endTime"`

    /* 服务编码 (Optional) */
    ServiceCode string `json:"serviceCode"`

    /* statusList (Optional) */
    StatusList []int `json:"statusList"`

    /* excludeResources (Optional) */
    ExcludeResources []string `json:"excludeResources"`

    /* orderByClaus (Optional) */
    OrderByClaus string `json:"orderByClaus"`

    /* 专有云节点的code（节点云查询使用） (Optional) */
    Node string `json:"node"`

    /* 部门（节点云查询使用） (Optional) */
    DepartmentId int `json:"departmentId"`

    /*  (Optional) */
    PinList []string `json:"pinList"`

    /* 是否是专有云 1:是  其他不是 (Optional) */
    IsSpecial int `json:"isSpecial"`

    /* 节点信息 (Optional) */
    NodeCode string `json:"nodeCode"`

    /* 超时时间，暂时不用 (Optional) */
    Timeout int `json:"timeout"`

    /* 当前页序号 (Optional) */
    PageIndex int `json:"pageIndex"`

    /* 每页结果数量 (Optional) */
    PageSize int `json:"pageSize"`

    /*  (Optional) */
    Offset int `json:"offset"`
}
