// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package models


type ResourceOrderVo struct {

    /* 主键id (Optional) */
    Id int `json:"id"`

    /* 交易单唯一标识 (Optional) */
    TransactionNo string `json:"transactionNo"`

    /* 资源id (Optional) */
    ResourceId string `json:"resourceId"`

    /* 计费类型 1:按配置 2:按用量 3:包年包月 4:一次性 (Optional) */
    BillingType int `json:"billingType"`

    /* 时长类型 1:小时 2:天 3:月 4:年 (Optional) */
    TimeUnit int `json:"timeUnit"`

    /* 时长字段，与timeUnit字段构成具体时长 (Optional) */
    TimeSpan int `json:"timeSpan"`

    /* 资源状态 1:正常 2:停服 3:删除 (Optional) */
    Status int `json:"status"`

    /* 计费状态 0:停止计费 1:计费中 (Optional) */
    BillingStatus int `json:"billingStatus"`

    /* 网络类型0:无 1: non-BGP, 2: BGP (Optional) */
    NetworkOperator int `json:"networkOperator"`

    /* 用户pin (Optional) */
    Pin string `json:"pin"`

    /* 应用码 (Optional) */
    AppCode string `json:"appCode"`

    /* 服务码 (Optional) */
    ServiceCode string `json:"serviceCode"`

    /* 站点标识0:中国 1:国际 (Optional) */
    Site int `json:"site"`

    /* 资源区域 (Optional) */
    Region string `json:"region"`

    /* 配置信息 (Optional) */
    Formula []Formula `json:"formula"`

    /* 否为试用资源 0:非试用 1:试用 (Optional) */
    IsOnTrial int `json:"isOnTrial"`

    /* 开始时间 (Optional) */
    StartTime string `json:"startTime"`

    /* 结束时间 (Optional) */
    EndTime string `json:"endTime"`

    /* 创建时间 (Optional) */
    CreateTime string `json:"createTime"`

    /* 支付时间 (Optional) */
    PayTime string `json:"payTime"`

    /* formula转换成字符串 (Optional) */
    FormulaStr string `json:"formulaStr"`

    /* billingType兼容交易系统字段 (Optional) */
    ChargeMode int `json:"chargeMode"`

    /* timeSpan兼容交易系统字段 (Optional) */
    ChargeDuration int `json:"chargeDuration"`

    /* timeUnit兼容交易系统字段 (Optional) */
    ChargeUnit int `json:"chargeUnit"`

    /* 欠费过期状态 (Optional) */
    AeStatus int `json:"aeStatus"`

    /* 欠费、过期资源释放时间 (Optional) */
    ReleasingTime string `json:"releasingTime"`

    /* 交易单模块sourceId 计费不关心 (Optional) */
    SourceId string `json:"sourceId"`

    /* 计费开始时间 续费时本次续费周期开始时间 (Optional) */
    BillingStartTime string `json:"billingStartTime"`

    /* 最新价格map (Optional) */
    PriceMap interface{} `json:"priceMap"`

    /* 价格快照 (Optional) */
    PriceSnapshot string `json:"priceSnapshot"`

    /* 订单折扣前总价 (Optional) */
    Price int `json:"price"`

    /* 折扣后订单价格 (Optional) */
    DiscountedPrice int `json:"discountedPrice"`

    /* 即将到期天数 (Optional) */
    ExpiringDays int `json:"expiringDays"`

    /* 计费类型描述 例如:按配置、包年包月 (Optional) */
    BillingCategoryDescription string `json:"billingCategoryDescription"`

    /* 计费详情描述 例如:按配置、包年包月（一年） (Optional) */
    Description string `json:"description"`

    /* refundNo (Optional) */
    RefundNo string `json:"refundNo"`

    /* 计费类型单号 (Optional) */
    BillingTypeName string `json:"billingTypeName"`

    /* 促销明细 (Optional) */
    FavorableInfo string `json:"favorableInfo"`

    /* 资源名 (Optional) */
    ResourceName string `json:"resourceName"`

    /* 变配明细（1-升配，2-降配，3-调整配置,4-续费,5-续费升配,6-续费降配,7-配置转包年包月） (Optional) */
    ProcessType int `json:"processType"`

    /* 资源申请人 (Optional) */
    Applicant string `json:"applicant"`

    /* 计费模式  1.停服停止计费  2.关机停止计费 (Optional) */
    BillingMode int `json:"billingMode"`

    /* 启服、停服、停止计费时间 (Optional) */
    OperateTime string `json:"operateTime"`
}
