// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DeleteCacheRuleRequest struct {

    core.JDCloudRequest

    /* 用户域名  */
    Domain string `json:"domain"`

    /* 缓存规则id (Optional) */
    ConfigId *int64 `json:"configId"`
}

/*
 * param domain: 用户域名 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDeleteCacheRuleRequest(
    domain string,
) *DeleteCacheRuleRequest {

	return &DeleteCacheRuleRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/domain/{domain}/cacheRule",
			Method:  "DELETE",
			Header:  nil,
			Version: "v1",
		},
        Domain: domain,
	}
}

/*
 * param domain: 用户域名 (Required)
 * param configId: 缓存规则id (Optional)
 */
func NewDeleteCacheRuleRequestWithAllParams(
    domain string,
    configId *int64,
) *DeleteCacheRuleRequest {

    return &DeleteCacheRuleRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/domain/{domain}/cacheRule",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
        Domain: domain,
        ConfigId: configId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDeleteCacheRuleRequestWithoutParam() *DeleteCacheRuleRequest {

    return &DeleteCacheRuleRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/domain/{domain}/cacheRule",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param domain: 用户域名(Required) */
func (r *DeleteCacheRuleRequest) SetDomain(domain string) {
    r.Domain = domain
}

/* param configId: 缓存规则id(Optional) */
func (r *DeleteCacheRuleRequest) SetConfigId(configId int64) {
    r.ConfigId = &configId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DeleteCacheRuleRequest) GetRegionId() string {
    return ""
}

type DeleteCacheRuleResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DeleteCacheRuleResult `json:"result"`
}

type DeleteCacheRuleResult struct {
}