// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    cdn "github.com/jdcloud-api/jdcloud-sdk-go/services/cdn/models"
)

type QueryLiveDomainDetailRequest struct {

    core.JDCloudRequest

    /* 用户域名  */
    Domain string `json:"domain"`
}

/*
 * param domain: 用户域名 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewQueryLiveDomainDetailRequest(
    domain string,
) *QueryLiveDomainDetailRequest {

	return &QueryLiveDomainDetailRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/liveDomain/{domain}",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        Domain: domain,
	}
}

/*
 * param domain: 用户域名 (Required)
 */
func NewQueryLiveDomainDetailRequestWithAllParams(
    domain string,
) *QueryLiveDomainDetailRequest {

    return &QueryLiveDomainDetailRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/liveDomain/{domain}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        Domain: domain,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewQueryLiveDomainDetailRequestWithoutParam() *QueryLiveDomainDetailRequest {

    return &QueryLiveDomainDetailRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/liveDomain/{domain}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param domain: 用户域名(Required) */
func (r *QueryLiveDomainDetailRequest) SetDomain(domain string) {
    r.Domain = domain
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r QueryLiveDomainDetailRequest) GetRegionId() string {
    return ""
}

type QueryLiveDomainDetailResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result QueryLiveDomainDetailResult `json:"result"`
}

type QueryLiveDomainDetailResult struct {
    DomainType string `json:"domainType"`
    PlayDomain string `json:"playDomain"`
    PublishDomain string `json:"publishDomain"`
    OriginDomain string `json:"originDomain"`
    CreatedTime string `json:"createdTime"`
    Cname string `json:"cname"`
    SiteType string `json:"siteType"`
    Status string `json:"status"`
    Source cdn.BackSourceInfo `json:"source"`
    SourceType string `json:"sourceType"`
    BackSourceType string `json:"backSourceType"`
    VideoType string `json:"videoType"`
    AudioType string `json:"audioType"`
    Type string `json:"type"`
    DefaultSourceHost string `json:"defaultSourceHost"`
    ArchiveNo string `json:"archiveNo"`
    RtmpDomain string `json:"rtmpDomain"`
    RtmpCname string `json:"rtmpCname"`
    HdlDomain string `json:"hdlDomain"`
    HdlCname string `json:"hdlCname"`
    HlsDomain string `json:"hlsDomain"`
    HlsCname string `json:"hlsCname"`
    ForwardCustomVhost string `json:"forwardCustomVhost"`
    FlvUrls []string `json:"flvUrls"`
    HlsUrls []string `json:"hlsUrls"`
    RtmpUrls []string `json:"rtmpUrls"`
    ProtocolConverts []cdn.ProtocolConvert `json:"protocolConverts"`
    Certificate string `json:"certificate"`
    RsaKey string `json:"rsaKey"`
    AccesskeyType int `json:"accesskeyType"`
    AccesskeyKey string `json:"accesskeyKey"`
    PlayAuthLifeTime int `json:"playAuthLifeTime"`
    AuthLifeTime int `json:"authLifeTime"`
    ForwardAccessKeyType int `json:"forwardAccessKeyType"`
    ForwardPrivateKey string `json:"forwardPrivateKey"`
    OriginAccessKeyType int `json:"originAccessKeyType"`
    OriginPrivateKey string `json:"originPrivateKey"`
    AllowApps []string `json:"allowApps"`
    Ips []string `json:"ips"`
    BlackIpsEnable string `json:"blackIpsEnable"`
    ExternId string `json:"externId"`
    IgnoreQueryString string `json:"ignoreQueryString"`
    ReferType string `json:"referType"`
    ReferList []string `json:"referList"`
    AllowNoReferHeader string `json:"allowNoReferHeader"`
    AllowNullReferHeader string `json:"allowNullReferHeader"`
    PublishNormalTimeout string `json:"publishNormalTimeout"`
    NotifyCustomUrl string `json:"notifyCustomUrl"`
    NotifyCustomAuthKey string `json:"notifyCustomAuthKey"`
}