// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    cdn "github.com/jdcloud-api/jdcloud-sdk-go/services/cdn/models"
)

type QueryLiveTrafficGroupSumRequest struct {

    core.JDCloudRequest

    /* 查询起始时间,UTC时间，格式为:yyyy-MM-dd'T'HH:mm:ss'Z'，示例:2018-10-21T10:00:00Z (Optional) */
    StartTime *string `json:"startTime"`

    /* 查询截止时间,UTC时间，格式为:yyyy-MM-dd'T'HH:mm:ss'Z'，示例:2018-10-21T10:00:00Z (Optional) */
    EndTime *string `json:"endTime"`

    /* 需要查询的域名, 必须为用户pin下有权限的域名 (Optional) */
    Domain *string `json:"domain"`

    /*  (Optional) */
    SubDomain *string `json:"subDomain"`

    /* app名 (Optional) */
    AppName *string `json:"appName"`

    /* 流名 (Optional) */
    StreamName *string `json:"streamName"`

    /* 需要查询的字段 (Optional) */
    Fields *string `json:"fields"`

    /*  (Optional) */
    Area *string `json:"area"`

    /*  (Optional) */
    Isp *string `json:"isp"`

    /* 查询的流协议 (Optional) */
    Scheme *string `json:"scheme"`

    /* 时间粒度，可选值:[oneMin,fiveMin,followTime],followTime只会返回一个汇总后的数据 (Optional) */
    Period *string `json:"period"`

    /* 分组依据 (Optional) */
    GroupBy *string `json:"groupBy"`

    /*  (Optional) */
    ReqMethod *string `json:"reqMethod"`
}

/*
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewQueryLiveTrafficGroupSumRequest(
) *QueryLiveTrafficGroupSumRequest {

	return &QueryLiveTrafficGroupSumRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/liveStatistics:groupSum",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
	}
}

/*
 * param startTime: 查询起始时间,UTC时间，格式为:yyyy-MM-dd'T'HH:mm:ss'Z'，示例:2018-10-21T10:00:00Z (Optional)
 * param endTime: 查询截止时间,UTC时间，格式为:yyyy-MM-dd'T'HH:mm:ss'Z'，示例:2018-10-21T10:00:00Z (Optional)
 * param domain: 需要查询的域名, 必须为用户pin下有权限的域名 (Optional)
 * param subDomain:  (Optional)
 * param appName: app名 (Optional)
 * param streamName: 流名 (Optional)
 * param fields: 需要查询的字段 (Optional)
 * param area:  (Optional)
 * param isp:  (Optional)
 * param scheme: 查询的流协议 (Optional)
 * param period: 时间粒度，可选值:[oneMin,fiveMin,followTime],followTime只会返回一个汇总后的数据 (Optional)
 * param groupBy: 分组依据 (Optional)
 * param reqMethod:  (Optional)
 */
func NewQueryLiveTrafficGroupSumRequestWithAllParams(
    startTime *string,
    endTime *string,
    domain *string,
    subDomain *string,
    appName *string,
    streamName *string,
    fields *string,
    area *string,
    isp *string,
    scheme *string,
    period *string,
    groupBy *string,
    reqMethod *string,
) *QueryLiveTrafficGroupSumRequest {

    return &QueryLiveTrafficGroupSumRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/liveStatistics:groupSum",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        StartTime: startTime,
        EndTime: endTime,
        Domain: domain,
        SubDomain: subDomain,
        AppName: appName,
        StreamName: streamName,
        Fields: fields,
        Area: area,
        Isp: isp,
        Scheme: scheme,
        Period: period,
        GroupBy: groupBy,
        ReqMethod: reqMethod,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewQueryLiveTrafficGroupSumRequestWithoutParam() *QueryLiveTrafficGroupSumRequest {

    return &QueryLiveTrafficGroupSumRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/liveStatistics:groupSum",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param startTime: 查询起始时间,UTC时间，格式为:yyyy-MM-dd'T'HH:mm:ss'Z'，示例:2018-10-21T10:00:00Z(Optional) */
func (r *QueryLiveTrafficGroupSumRequest) SetStartTime(startTime string) {
    r.StartTime = &startTime
}

/* param endTime: 查询截止时间,UTC时间，格式为:yyyy-MM-dd'T'HH:mm:ss'Z'，示例:2018-10-21T10:00:00Z(Optional) */
func (r *QueryLiveTrafficGroupSumRequest) SetEndTime(endTime string) {
    r.EndTime = &endTime
}

/* param domain: 需要查询的域名, 必须为用户pin下有权限的域名(Optional) */
func (r *QueryLiveTrafficGroupSumRequest) SetDomain(domain string) {
    r.Domain = &domain
}

/* param subDomain: (Optional) */
func (r *QueryLiveTrafficGroupSumRequest) SetSubDomain(subDomain string) {
    r.SubDomain = &subDomain
}

/* param appName: app名(Optional) */
func (r *QueryLiveTrafficGroupSumRequest) SetAppName(appName string) {
    r.AppName = &appName
}

/* param streamName: 流名(Optional) */
func (r *QueryLiveTrafficGroupSumRequest) SetStreamName(streamName string) {
    r.StreamName = &streamName
}

/* param fields: 需要查询的字段(Optional) */
func (r *QueryLiveTrafficGroupSumRequest) SetFields(fields string) {
    r.Fields = &fields
}

/* param area: (Optional) */
func (r *QueryLiveTrafficGroupSumRequest) SetArea(area string) {
    r.Area = &area
}

/* param isp: (Optional) */
func (r *QueryLiveTrafficGroupSumRequest) SetIsp(isp string) {
    r.Isp = &isp
}

/* param scheme: 查询的流协议(Optional) */
func (r *QueryLiveTrafficGroupSumRequest) SetScheme(scheme string) {
    r.Scheme = &scheme
}

/* param period: 时间粒度，可选值:[oneMin,fiveMin,followTime],followTime只会返回一个汇总后的数据(Optional) */
func (r *QueryLiveTrafficGroupSumRequest) SetPeriod(period string) {
    r.Period = &period
}

/* param groupBy: 分组依据(Optional) */
func (r *QueryLiveTrafficGroupSumRequest) SetGroupBy(groupBy string) {
    r.GroupBy = &groupBy
}

/* param reqMethod: (Optional) */
func (r *QueryLiveTrafficGroupSumRequest) SetReqMethod(reqMethod string) {
    r.ReqMethod = &reqMethod
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r QueryLiveTrafficGroupSumRequest) GetRegionId() string {
    return ""
}

type QueryLiveTrafficGroupSumResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result QueryLiveTrafficGroupSumResult `json:"result"`
}

type QueryLiveTrafficGroupSumResult struct {
    StartTime string `json:"startTime"`
    EndTime string `json:"endTime"`
    Domain string `json:"domain"`
    Statistics []cdn.StatisticsGroupSumDataItem `json:"statistics"`
}