// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type SetLiveDomainAccessKeyRequest struct {

    core.JDCloudRequest

    /* 用户域名  */
    Domain string `json:"domain"`

    /* url鉴权开启1关闭0 (Optional) */
    AccesskeyType *int `json:"accesskeyType"`

    /* url鉴权开启时必传 (Optional) */
    AccesskeyKey *string `json:"accesskeyKey"`

    /* 开启时默认值为300s,关闭时为0 (Optional) */
    AuthLifeTime *int `json:"authLifeTime"`
}

/*
 * param domain: 用户域名 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewSetLiveDomainAccessKeyRequest(
    domain string,
) *SetLiveDomainAccessKeyRequest {

	return &SetLiveDomainAccessKeyRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/liveDomain/{domain}/accesskeyConfig",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        Domain: domain,
	}
}

/*
 * param domain: 用户域名 (Required)
 * param accesskeyType: url鉴权开启1关闭0 (Optional)
 * param accesskeyKey: url鉴权开启时必传 (Optional)
 * param authLifeTime: 开启时默认值为300s,关闭时为0 (Optional)
 */
func NewSetLiveDomainAccessKeyRequestWithAllParams(
    domain string,
    accesskeyType *int,
    accesskeyKey *string,
    authLifeTime *int,
) *SetLiveDomainAccessKeyRequest {

    return &SetLiveDomainAccessKeyRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/liveDomain/{domain}/accesskeyConfig",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        Domain: domain,
        AccesskeyType: accesskeyType,
        AccesskeyKey: accesskeyKey,
        AuthLifeTime: authLifeTime,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewSetLiveDomainAccessKeyRequestWithoutParam() *SetLiveDomainAccessKeyRequest {

    return &SetLiveDomainAccessKeyRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/liveDomain/{domain}/accesskeyConfig",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param domain: 用户域名(Required) */
func (r *SetLiveDomainAccessKeyRequest) SetDomain(domain string) {
    r.Domain = domain
}

/* param accesskeyType: url鉴权开启1关闭0(Optional) */
func (r *SetLiveDomainAccessKeyRequest) SetAccesskeyType(accesskeyType int) {
    r.AccesskeyType = &accesskeyType
}

/* param accesskeyKey: url鉴权开启时必传(Optional) */
func (r *SetLiveDomainAccessKeyRequest) SetAccesskeyKey(accesskeyKey string) {
    r.AccesskeyKey = &accesskeyKey
}

/* param authLifeTime: 开启时默认值为300s,关闭时为0(Optional) */
func (r *SetLiveDomainAccessKeyRequest) SetAuthLifeTime(authLifeTime int) {
    r.AuthLifeTime = &authLifeTime
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r SetLiveDomainAccessKeyRequest) GetRegionId() string {
    return ""
}

type SetLiveDomainAccessKeyResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result SetLiveDomainAccessKeyResult `json:"result"`
}

type SetLiveDomainAccessKeyResult struct {
}