// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type SetLiveDomainBackSourceHostRequest struct {

    core.JDCloudRequest

    /* 用户域名  */
    Domain string `json:"domain"`

    /* 默认回源host (Optional) */
    SourceHost *string `json:"sourceHost"`
}

/*
 * param domain: 用户域名 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewSetLiveDomainBackSourceHostRequest(
    domain string,
) *SetLiveDomainBackSourceHostRequest {

	return &SetLiveDomainBackSourceHostRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/liveDomain/{domain}/backSourceHost",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        Domain: domain,
	}
}

/*
 * param domain: 用户域名 (Required)
 * param sourceHost: 默认回源host (Optional)
 */
func NewSetLiveDomainBackSourceHostRequestWithAllParams(
    domain string,
    sourceHost *string,
) *SetLiveDomainBackSourceHostRequest {

    return &SetLiveDomainBackSourceHostRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/liveDomain/{domain}/backSourceHost",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        Domain: domain,
        SourceHost: sourceHost,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewSetLiveDomainBackSourceHostRequestWithoutParam() *SetLiveDomainBackSourceHostRequest {

    return &SetLiveDomainBackSourceHostRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/liveDomain/{domain}/backSourceHost",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param domain: 用户域名(Required) */
func (r *SetLiveDomainBackSourceHostRequest) SetDomain(domain string) {
    r.Domain = domain
}

/* param sourceHost: 默认回源host(Optional) */
func (r *SetLiveDomainBackSourceHostRequest) SetSourceHost(sourceHost string) {
    r.SourceHost = &sourceHost
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r SetLiveDomainBackSourceHostRequest) GetRegionId() string {
    return ""
}

type SetLiveDomainBackSourceHostResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result SetLiveDomainBackSourceHostResult `json:"result"`
}

type SetLiveDomainBackSourceHostResult struct {
}