// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    cdn "github.com/jdcloud-api/jdcloud-sdk-go/services/cdn/models"
)

type SetProtocolConvertRequest struct {

    core.JDCloudRequest

    /* 用户域名  */
    Domain string `json:"domain"`

    /* https证书,转https格式时必传 (Optional) */
    Certificate *string `json:"certificate"`

    /* https私钥，转https格式时必传 (Optional) */
    RsaKey *string `json:"rsaKey"`

    /*  (Optional) */
    ProtocolConverts []cdn.ProtocolConvert `json:"protocolConverts"`
}

/*
 * param domain: 用户域名 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewSetProtocolConvertRequest(
    domain string,
) *SetProtocolConvertRequest {

	return &SetProtocolConvertRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/liveDomain/{domain}/protocolConvert",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        Domain: domain,
	}
}

/*
 * param domain: 用户域名 (Required)
 * param certificate: https证书,转https格式时必传 (Optional)
 * param rsaKey: https私钥，转https格式时必传 (Optional)
 * param protocolConverts:  (Optional)
 */
func NewSetProtocolConvertRequestWithAllParams(
    domain string,
    certificate *string,
    rsaKey *string,
    protocolConverts []cdn.ProtocolConvert,
) *SetProtocolConvertRequest {

    return &SetProtocolConvertRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/liveDomain/{domain}/protocolConvert",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        Domain: domain,
        Certificate: certificate,
        RsaKey: rsaKey,
        ProtocolConverts: protocolConverts,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewSetProtocolConvertRequestWithoutParam() *SetProtocolConvertRequest {

    return &SetProtocolConvertRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/liveDomain/{domain}/protocolConvert",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param domain: 用户域名(Required) */
func (r *SetProtocolConvertRequest) SetDomain(domain string) {
    r.Domain = domain
}

/* param certificate: https证书,转https格式时必传(Optional) */
func (r *SetProtocolConvertRequest) SetCertificate(certificate string) {
    r.Certificate = &certificate
}

/* param rsaKey: https私钥，转https格式时必传(Optional) */
func (r *SetProtocolConvertRequest) SetRsaKey(rsaKey string) {
    r.RsaKey = &rsaKey
}

/* param protocolConverts: (Optional) */
func (r *SetProtocolConvertRequest) SetProtocolConverts(protocolConverts []cdn.ProtocolConvert) {
    r.ProtocolConverts = protocolConverts
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r SetProtocolConvertRequest) GetRegionId() string {
    return ""
}

type SetProtocolConvertResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result SetProtocolConvertResult `json:"result"`
}

type SetProtocolConvertResult struct {
}