// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    cdn "github.com/jdcloud-api/jdcloud-sdk-go/services/cdn/models"
)

type SetSourceRequest struct {

    core.JDCloudRequest

    /* 用户域名  */
    Domain string `json:"domain"`

    /* 回源类型只能是[ips,domain,oss]中的一种 (Optional) */
    SourceType *string `json:"sourceType"`

    /* 回源方式,只能是[https,http]中的一种,默认http (Optional) */
    BackSourceType *string `json:"backSourceType"`

    /*  (Optional) */
    IpSource []cdn.IpSourceInfo `json:"ipSource"`

    /*  (Optional) */
    DomainSource []cdn.DomainSourceInfo `json:"domainSource"`

    /*  (Optional) */
    OssSource *string `json:"ossSource"`

    /*  (Optional) */
    DefaultSourceHost *string `json:"defaultSourceHost"`
}

/*
 * param domain: 用户域名 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewSetSourceRequest(
    domain string,
) *SetSourceRequest {

	return &SetSourceRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/domain/{domain}/source",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        Domain: domain,
	}
}

/*
 * param domain: 用户域名 (Required)
 * param sourceType: 回源类型只能是[ips,domain,oss]中的一种 (Optional)
 * param backSourceType: 回源方式,只能是[https,http]中的一种,默认http (Optional)
 * param ipSource:  (Optional)
 * param domainSource:  (Optional)
 * param ossSource:  (Optional)
 * param defaultSourceHost:  (Optional)
 */
func NewSetSourceRequestWithAllParams(
    domain string,
    sourceType *string,
    backSourceType *string,
    ipSource []cdn.IpSourceInfo,
    domainSource []cdn.DomainSourceInfo,
    ossSource *string,
    defaultSourceHost *string,
) *SetSourceRequest {

    return &SetSourceRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/domain/{domain}/source",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        Domain: domain,
        SourceType: sourceType,
        BackSourceType: backSourceType,
        IpSource: ipSource,
        DomainSource: domainSource,
        OssSource: ossSource,
        DefaultSourceHost: defaultSourceHost,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewSetSourceRequestWithoutParam() *SetSourceRequest {

    return &SetSourceRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/domain/{domain}/source",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param domain: 用户域名(Required) */
func (r *SetSourceRequest) SetDomain(domain string) {
    r.Domain = domain
}

/* param sourceType: 回源类型只能是[ips,domain,oss]中的一种(Optional) */
func (r *SetSourceRequest) SetSourceType(sourceType string) {
    r.SourceType = &sourceType
}

/* param backSourceType: 回源方式,只能是[https,http]中的一种,默认http(Optional) */
func (r *SetSourceRequest) SetBackSourceType(backSourceType string) {
    r.BackSourceType = &backSourceType
}

/* param ipSource: (Optional) */
func (r *SetSourceRequest) SetIpSource(ipSource []cdn.IpSourceInfo) {
    r.IpSource = ipSource
}

/* param domainSource: (Optional) */
func (r *SetSourceRequest) SetDomainSource(domainSource []cdn.DomainSourceInfo) {
    r.DomainSource = domainSource
}

/* param ossSource: (Optional) */
func (r *SetSourceRequest) SetOssSource(ossSource string) {
    r.OssSource = &ossSource
}

/* param defaultSourceHost: (Optional) */
func (r *SetSourceRequest) SetDefaultSourceHost(defaultSourceHost string) {
    r.DefaultSourceHost = &defaultSourceHost
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r SetSourceRequest) GetRegionId() string {
    return ""
}

type SetSourceResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result SetSourceResult `json:"result"`
}

type SetSourceResult struct {
}