// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    clouddnsservice "github.com/jdcloud-api/jdcloud-sdk-go/services/clouddnsservice/models"
)

type AddRRRequest struct {

    core.JDCloudRequest

    /* 实例所属的地域ID  */
    RegionId string `json:"regionId"`

    /* 域名ID，请使用getDomains接口获取。  */
    DomainId string `json:"domainId"`

    /* RR参数  */
    Req *clouddnsservice.AddRR `json:"req"`
}

/*
 * param regionId: 实例所属的地域ID (Required)
 * param domainId: 域名ID，请使用getDomains接口获取。 (Required)
 * param req: RR参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewAddRRRequest(
    regionId string,
    domainId string,
    req *clouddnsservice.AddRR,
) *AddRRRequest {

	return &AddRRRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/domain/{domainId}/RRAdd",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        DomainId: domainId,
        Req: req,
	}
}

/*
 * param regionId: 实例所属的地域ID (Required)
 * param domainId: 域名ID，请使用getDomains接口获取。 (Required)
 * param req: RR参数 (Required)
 */
func NewAddRRRequestWithAllParams(
    regionId string,
    domainId string,
    req *clouddnsservice.AddRR,
) *AddRRRequest {

    return &AddRRRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/domain/{domainId}/RRAdd",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        DomainId: domainId,
        Req: req,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewAddRRRequestWithoutParam() *AddRRRequest {

    return &AddRRRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/domain/{domainId}/RRAdd",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 实例所属的地域ID(Required) */
func (r *AddRRRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param domainId: 域名ID，请使用getDomains接口获取。(Required) */
func (r *AddRRRequest) SetDomainId(domainId string) {
    r.DomainId = domainId
}

/* param req: RR参数(Required) */
func (r *AddRRRequest) SetReq(req *clouddnsservice.AddRR) {
    r.Req = req
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r AddRRRequest) GetRegionId() string {
    return r.RegionId
}

type AddRRResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result AddRRResult `json:"result"`
}

type AddRRResult struct {
    DataList clouddnsservice.RR `json:"dataList"`
}