// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    clouddnsservice "github.com/jdcloud-api/jdcloud-sdk-go/services/clouddnsservice/models"
)

type BatchSetDnsResolveRequest struct {

    core.JDCloudRequest

    /* 实例所属的地域ID  */
    RegionId string `json:"regionId"`

    /* 需要设置的解析记录列表  */
    Req []clouddnsservice.BatchSetDNS `json:"req"`
}

/*
 * param regionId: 实例所属的地域ID (Required)
 * param req: 需要设置的解析记录列表 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewBatchSetDnsResolveRequest(
    regionId string,
    req []clouddnsservice.BatchSetDNS,
) *BatchSetDnsResolveRequest {

	return &BatchSetDnsResolveRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/BatchSetDnsResolve",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Req: req,
	}
}

/*
 * param regionId: 实例所属的地域ID (Required)
 * param req: 需要设置的解析记录列表 (Required)
 */
func NewBatchSetDnsResolveRequestWithAllParams(
    regionId string,
    req []clouddnsservice.BatchSetDNS,
) *BatchSetDnsResolveRequest {

    return &BatchSetDnsResolveRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/BatchSetDnsResolve",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Req: req,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewBatchSetDnsResolveRequestWithoutParam() *BatchSetDnsResolveRequest {

    return &BatchSetDnsResolveRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/BatchSetDnsResolve",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 实例所属的地域ID(Required) */
func (r *BatchSetDnsResolveRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param req: 需要设置的解析记录列表(Required) */
func (r *BatchSetDnsResolveRequest) SetReq(req []clouddnsservice.BatchSetDNS) {
    r.Req = req
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r BatchSetDnsResolveRequest) GetRegionId() string {
    return r.RegionId
}

type BatchSetDnsResolveResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result BatchSetDnsResolveResult `json:"result"`
}

type BatchSetDnsResolveResult struct {
    Data []string `json:"data"`
}