// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    clouddnsservice "github.com/jdcloud-api/jdcloud-sdk-go/services/clouddnsservice/models"
)

type DelUserViewIPRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 删除域名的自定义解析线路的IP段的参数  */
    Req *clouddnsservice.DelViewIP `json:"req"`
}

/*
 * param regionId: 地域ID (Required)
 * param req: 删除域名的自定义解析线路的IP段的参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDelUserViewIPRequest(
    regionId string,
    req *clouddnsservice.DelViewIP,
) *DelUserViewIPRequest {

	return &DelUserViewIPRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/userview/delUserViewIP",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Req: req,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param req: 删除域名的自定义解析线路的IP段的参数 (Required)
 */
func NewDelUserViewIPRequestWithAllParams(
    regionId string,
    req *clouddnsservice.DelViewIP,
) *DelUserViewIPRequest {

    return &DelUserViewIPRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/userview/delUserViewIP",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Req: req,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDelUserViewIPRequestWithoutParam() *DelUserViewIPRequest {

    return &DelUserViewIPRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/userview/delUserViewIP",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *DelUserViewIPRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param req: 删除域名的自定义解析线路的IP段的参数(Required) */
func (r *DelUserViewIPRequest) SetReq(req *clouddnsservice.DelViewIP) {
    r.Req = req
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DelUserViewIPRequest) GetRegionId() string {
    return r.RegionId
}

type DelUserViewIPResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DelUserViewIPResult `json:"result"`
}

type DelUserViewIPResult struct {
}