// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type OperateMonitorRequest struct {

    core.JDCloudRequest

    /* 实例所属的地域ID  */
    RegionId string `json:"regionId"`

    /* 域名ID，请使用getDomains接口获取。  */
    DomainId string `json:"domainId"`

    /* 删除del, 暂停stop, 开启start, 手动恢复recover，手动切换switch  */
    Action string `json:"action"`

    /* 监控项ID  */
    Ids []int `json:"ids"`

    /* 监控项的主机值, 手动切换时必填 (Optional) */
    SwitchTarget *string `json:"switchTarget"`
}

/*
 * param regionId: 实例所属的地域ID (Required)
 * param domainId: 域名ID，请使用getDomains接口获取。 (Required)
 * param action: 删除del, 暂停stop, 开启start, 手动恢复recover，手动切换switch (Required)
 * param ids: 监控项ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewOperateMonitorRequest(
    regionId string,
    domainId string,
    action string,
    ids []int,
) *OperateMonitorRequest {

	return &OperateMonitorRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/domain/{domainId}/monitorOperate",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        DomainId: domainId,
        Action: action,
        Ids: ids,
	}
}

/*
 * param regionId: 实例所属的地域ID (Required)
 * param domainId: 域名ID，请使用getDomains接口获取。 (Required)
 * param action: 删除del, 暂停stop, 开启start, 手动恢复recover，手动切换switch (Required)
 * param ids: 监控项ID (Required)
 * param switchTarget: 监控项的主机值, 手动切换时必填 (Optional)
 */
func NewOperateMonitorRequestWithAllParams(
    regionId string,
    domainId string,
    action string,
    ids []int,
    switchTarget *string,
) *OperateMonitorRequest {

    return &OperateMonitorRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/domain/{domainId}/monitorOperate",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        DomainId: domainId,
        Action: action,
        Ids: ids,
        SwitchTarget: switchTarget,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewOperateMonitorRequestWithoutParam() *OperateMonitorRequest {

    return &OperateMonitorRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/domain/{domainId}/monitorOperate",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 实例所属的地域ID(Required) */
func (r *OperateMonitorRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param domainId: 域名ID，请使用getDomains接口获取。(Required) */
func (r *OperateMonitorRequest) SetDomainId(domainId string) {
    r.DomainId = domainId
}

/* param action: 删除del, 暂停stop, 开启start, 手动恢复recover，手动切换switch(Required) */
func (r *OperateMonitorRequest) SetAction(action string) {
    r.Action = action
}

/* param ids: 监控项ID(Required) */
func (r *OperateMonitorRequest) SetIds(ids []int) {
    r.Ids = ids
}

/* param switchTarget: 监控项的主机值, 手动切换时必填(Optional) */
func (r *OperateMonitorRequest) SetSwitchTarget(switchTarget string) {
    r.SwitchTarget = &switchTarget
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r OperateMonitorRequest) GetRegionId() string {
    return r.RegionId
}

type OperateMonitorResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result OperateMonitorResult `json:"result"`
}

type OperateMonitorResult struct {
}