// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DeleteJobsRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 待删除job的UUID列表  */
    JobIds []string `json:"jobIds"`
}

/*
 * param regionId: Region ID (Required)
 * param jobIds: 待删除job的UUID列表 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDeleteJobsRequest(
    regionId string,
    jobIds []string,
) *DeleteJobsRequest {

	return &DeleteJobsRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/jobs",
			Method:  "DELETE",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        JobIds: jobIds,
	}
}

/*
 * param regionId: Region ID (Required)
 * param jobIds: 待删除job的UUID列表 (Required)
 */
func NewDeleteJobsRequestWithAllParams(
    regionId string,
    jobIds []string,
) *DeleteJobsRequest {

    return &DeleteJobsRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/jobs",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        JobIds: jobIds,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDeleteJobsRequestWithoutParam() *DeleteJobsRequest {

    return &DeleteJobsRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/jobs",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *DeleteJobsRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param jobIds: 待删除job的UUID列表(Required) */
func (r *DeleteJobsRequest) SetJobIds(jobIds []string) {
    r.JobIds = jobIds
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DeleteJobsRequest) GetRegionId() string {
    return r.RegionId
}

type DeleteJobsResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DeleteJobsResult `json:"result"`
}

type DeleteJobsResult struct {
    Result bool `json:"result"`
    Ids []string `json:"ids"`
}