// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type GetBuildStatusRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* job uuid  */
    Jobid string `json:"jobid"`

    /* 构建任务uuid  */
    Id string `json:"id"`
}

/*
 * param regionId: Region ID (Required)
 * param jobid: job uuid (Required)
 * param id: 构建任务uuid (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewGetBuildStatusRequest(
    regionId string,
    jobid string,
    id string,
) *GetBuildStatusRequest {

	return &GetBuildStatusRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/jobs/{jobid}/builds/{id}/status",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Jobid: jobid,
        Id: id,
	}
}

/*
 * param regionId: Region ID (Required)
 * param jobid: job uuid (Required)
 * param id: 构建任务uuid (Required)
 */
func NewGetBuildStatusRequestWithAllParams(
    regionId string,
    jobid string,
    id string,
) *GetBuildStatusRequest {

    return &GetBuildStatusRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/jobs/{jobid}/builds/{id}/status",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Jobid: jobid,
        Id: id,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewGetBuildStatusRequestWithoutParam() *GetBuildStatusRequest {

    return &GetBuildStatusRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/jobs/{jobid}/builds/{id}/status",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *GetBuildStatusRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param jobid: job uuid(Required) */
func (r *GetBuildStatusRequest) SetJobid(jobid string) {
    r.Jobid = jobid
}

/* param id: 构建任务uuid(Required) */
func (r *GetBuildStatusRequest) SetId(id string) {
    r.Id = id
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r GetBuildStatusRequest) GetRegionId() string {
    return r.RegionId
}

type GetBuildStatusResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result GetBuildStatusResult `json:"result"`
}

type GetBuildStatusResult struct {
    Name string `json:"name"`
    CreatedAt int `json:"createdAt"`
    Status string `json:"status"`
    CompletionRate float32 `json:"completionRate"`
}