// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package models


type Job struct {

    /* 构建任务uuid (Optional) */
    Uuid string `json:"uuid"`

    /* 创建时间戳 (Optional) */
    CreatedAt int `json:"createdAt"`

    /* 最后一次更新时间 (Optional) */
    UpdatedAt int `json:"updatedAt"`

    /* 构建名称 (Optional) */
    Name string `json:"name"`

    /* 代码存储类型，目前只支持github (Optional) */
    CodeType string `json:"codeType"`

    /* 代码clone路径 (Optional) */
    CodeRepoUrl string `json:"codeRepoUrl"`

    /* 代码名称的显示Label (Optional) */
    CodeRepoUrlLabel string `json:"codeRepoUrlLabel"`

    /* 分支 (Optional) */
    CodeRepoBranch string `json:"codeRepoBranch"`

    /* 创建者 (Optional) */
    CreateUserName string `json:"createUserName"`

    /* 是否是私有仓库 (Optional) */
    CodeRepoPrivate bool `json:"codeRepoPrivate"`

    /* 最后一次更细者 (Optional) */
    CreateUserPin string `json:"createUserPin"`

    /* 用户云存储路径，如果为空，使用公用的云存储 (Optional) */
    OssPath string `json:"ossPath"`

    /* 用户云存储主机，实际为用户云存储所在地域 (Optional) */
    OssHost string `json:"ossHost"`

    /* 用户云存储bucket，如果为空，使用公用的云存储 (Optional) */
    OssBucket string `json:"ossBucket"`

    /* 编译镜像地址 (Optional) */
    BuildImage string `json:"buildImage"`

    /* 编译镜像的显示Label (Optional) */
    BuildImageLabel string `json:"buildImageLabel"`

    /* 是否在页面配置构建方式，这项为true，则buildSetConfig需要有内容，如果这项为false，即使buildSetConfig有内容，也不生效 (Optional) */
    IsUserBuildSetConfig bool `json:"isUserBuildSetConfig"`

    /* 见isUserBuildSetConfig的说明 (Optional) */
    BuildSetConfig string `json:"buildSetConfig"`

    /* 超时时间，单位秒 (Optional) */
    BuildTimeOut int `json:"buildTimeOut"`

    /* cpu分配核数 (Optional) */
    BuildResourceCpu int `json:"buildResourceCpu"`

    /* 内存分配大小，单位MB (Optional) */
    BuildResourceMem int `json:"buildResourceMem"`

    /* 通知邮件 (Optional) */
    NoticeMail string `json:"noticeMail"`

    /* 通知频率， MAIL_FAILED失败时通知，MAIL_EVERY每次构建就通知 (Optional) */
    NoticeType string `json:"noticeType"`

    /* 构建类型 (Optional) */
    CompilerType string `json:"compilerType"`

    /* 镜像注册表名 (Optional) */
    DockerRegistry string `json:"dockerRegistry"`

    /* 镜像仓库名 (Optional) */
    DockerRepository string `json:"dockerRepository"`

    /* 注册表的URI (Optional) */
    DockerRegistryUri string `json:"dockerRegistryUri"`
}
