// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type CheckRepositoryNameRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 注册表名。  */
    RegistryName string `json:"registryName"`

    /* 待验证的镜像仓库名。  */
    RepositoryName string `json:"repositoryName"`
}

/*
 * param regionId: Region ID (Required)
 * param registryName: 注册表名。 (Required)
 * param repositoryName: 待验证的镜像仓库名。 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCheckRepositoryNameRequest(
    regionId string,
    registryName string,
    repositoryName string,
) *CheckRepositoryNameRequest {

	return &CheckRepositoryNameRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/repositories:checkRepositoryName",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        RegistryName: registryName,
        RepositoryName: repositoryName,
	}
}

/*
 * param regionId: Region ID (Required)
 * param registryName: 注册表名。 (Required)
 * param repositoryName: 待验证的镜像仓库名。 (Required)
 */
func NewCheckRepositoryNameRequestWithAllParams(
    regionId string,
    registryName string,
    repositoryName string,
) *CheckRepositoryNameRequest {

    return &CheckRepositoryNameRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/repositories:checkRepositoryName",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        RegistryName: registryName,
        RepositoryName: repositoryName,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCheckRepositoryNameRequestWithoutParam() *CheckRepositoryNameRequest {

    return &CheckRepositoryNameRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/repositories:checkRepositoryName",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *CheckRepositoryNameRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param registryName: 注册表名。(Required) */
func (r *CheckRepositoryNameRequest) SetRegistryName(registryName string) {
    r.RegistryName = registryName
}

/* param repositoryName: 待验证的镜像仓库名。(Required) */
func (r *CheckRepositoryNameRequest) SetRepositoryName(repositoryName string) {
    r.RepositoryName = repositoryName
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CheckRepositoryNameRequest) GetRegionId() string {
    return r.RegionId
}

type CheckRepositoryNameResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CheckRepositoryNameResult `json:"result"`
}

type CheckRepositoryNameResult struct {
    Code int `json:"code"`
    Reason string `json:"reason"`
}