// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    containerregistry "github.com/jdcloud-api/jdcloud-sdk-go/services/containerregistry/models"
    common "github.com/jdcloud-api/jdcloud-sdk-go/services/common/models"
)

type DescribeRepositoriesRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* name - 仓库名称，模糊匹配，支持单个
 (Optional) */
    Filters []common.Filter `json:"filters"`

    /* 注册表名 (Optional) */
    RegistryName *string `json:"registryName"`

    /* 页码；默认为1 (Optional) */
    PageNumber *int `json:"pageNumber"`

    /* 分页大小；默认为20；取值范围[10, 100] (Optional) */
    PageSize *int `json:"pageSize"`
}

/*
 * param regionId: Region ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeRepositoriesRequest(
    regionId string,
) *DescribeRepositoriesRequest {

	return &DescribeRepositoriesRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/listRepositories",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
	}
}

/*
 * param regionId: Region ID (Required)
 * param filters: name - 仓库名称，模糊匹配，支持单个
 (Optional)
 * param registryName: 注册表名 (Optional)
 * param pageNumber: 页码；默认为1 (Optional)
 * param pageSize: 分页大小；默认为20；取值范围[10, 100] (Optional)
 */
func NewDescribeRepositoriesRequestWithAllParams(
    regionId string,
    filters []common.Filter,
    registryName *string,
    pageNumber *int,
    pageSize *int,
) *DescribeRepositoriesRequest {

    return &DescribeRepositoriesRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/listRepositories",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Filters: filters,
        RegistryName: registryName,
        PageNumber: pageNumber,
        PageSize: pageSize,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeRepositoriesRequestWithoutParam() *DescribeRepositoriesRequest {

    return &DescribeRepositoriesRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/listRepositories",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *DescribeRepositoriesRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param filters: name - 仓库名称，模糊匹配，支持单个
(Optional) */
func (r *DescribeRepositoriesRequest) SetFilters(filters []common.Filter) {
    r.Filters = filters
}

/* param registryName: 注册表名(Optional) */
func (r *DescribeRepositoriesRequest) SetRegistryName(registryName string) {
    r.RegistryName = &registryName
}

/* param pageNumber: 页码；默认为1(Optional) */
func (r *DescribeRepositoriesRequest) SetPageNumber(pageNumber int) {
    r.PageNumber = &pageNumber
}

/* param pageSize: 分页大小；默认为20；取值范围[10, 100](Optional) */
func (r *DescribeRepositoriesRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeRepositoriesRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeRepositoriesResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeRepositoriesResult `json:"result"`
}

type DescribeRepositoriesResult struct {
    Repositories []containerregistry.Repository `json:"repositories"`
    TotalCount int `json:"totalCount"`
}