// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    cps "github.com/jdcloud-api/jdcloud-sdk-go/services/cps/models"
)

type DescribeRegionesRequest struct {

    core.JDCloudRequest

    /* 网络类型basic/vpc, 默认basic (Optional) */
    NetworkType *string `json:"networkType"`
}

/*
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeRegionesRequest(
) *DescribeRegionesRequest {

	return &DescribeRegionesRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
	}
}

/*
 * param networkType: 网络类型basic/vpc, 默认basic (Optional)
 */
func NewDescribeRegionesRequestWithAllParams(
    networkType *string,
) *DescribeRegionesRequest {

    return &DescribeRegionesRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        NetworkType: networkType,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeRegionesRequestWithoutParam() *DescribeRegionesRequest {

    return &DescribeRegionesRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param networkType: 网络类型basic/vpc, 默认basic(Optional) */
func (r *DescribeRegionesRequest) SetNetworkType(networkType string) {
    r.NetworkType = &networkType
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeRegionesRequest) GetRegionId() string {
    return ""
}

type DescribeRegionesResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeRegionesResult `json:"result"`
}

type DescribeRegionesResult struct {
    Regions []cps.Region `json:"regions"`
}