// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type CreateRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 商场ID  */
    MallId string `json:"mallId"`

    /* 定制画像任务ID  */
    ProfileId string `json:"profileId"`

    /* 多级筛选的标签，多个标签请用英文逗号分隔，最多只能传三个标签  */
    Dimensions string `json:"dimensions"`
}

/*
 * param regionId: 地域ID (Required)
 * param mallId: 商场ID (Required)
 * param profileId: 定制画像任务ID (Required)
 * param dimensions: 多级筛选的标签，多个标签请用英文逗号分隔，最多只能传三个标签 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCreateRequest(
    regionId string,
    mallId string,
    profileId string,
    dimensions string,
) *CreateRequest {

	return &CreateRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/profileMultiLevel:create",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        MallId: mallId,
        ProfileId: profileId,
        Dimensions: dimensions,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param mallId: 商场ID (Required)
 * param profileId: 定制画像任务ID (Required)
 * param dimensions: 多级筛选的标签，多个标签请用英文逗号分隔，最多只能传三个标签 (Required)
 */
func NewCreateRequestWithAllParams(
    regionId string,
    mallId string,
    profileId string,
    dimensions string,
) *CreateRequest {

    return &CreateRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/profileMultiLevel:create",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        MallId: mallId,
        ProfileId: profileId,
        Dimensions: dimensions,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCreateRequestWithoutParam() *CreateRequest {

    return &CreateRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/profileMultiLevel:create",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *CreateRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param mallId: 商场ID(Required) */
func (r *CreateRequest) SetMallId(mallId string) {
    r.MallId = mallId
}

/* param profileId: 定制画像任务ID(Required) */
func (r *CreateRequest) SetProfileId(profileId string) {
    r.ProfileId = profileId
}

/* param dimensions: 多级筛选的标签，多个标签请用英文逗号分隔，最多只能传三个标签(Required) */
func (r *CreateRequest) SetDimensions(dimensions string) {
    r.Dimensions = dimensions
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CreateRequest) GetRegionId() string {
    return r.RegionId
}

type CreateResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CreateResult `json:"result"`
}

type CreateResult struct {
    Status bool `json:"status"`
    Message string `json:"message"`
    Data string `json:"data"`
}