// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    datastar "github.com/jdcloud-api/jdcloud-sdk-go/services/datastar/models"
)

type GetLargeScreenDataRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 查询区域，比如某某省或某某市（可选区域以最终授权为准）  */
    Region string `json:"region"`

    /* 查询行业，比如某个水果或者农作物（可选行业以最终授权为准）  */
    Industry string `json:"industry"`

    /* 查询起始时间，格式如下：yyyy-MM-dd  */
    StartDate string `json:"startDate"`

    /* 查询结束时间，格式如下：yyyy-MM-dd  */
    EndDate string `json:"endDate"`

    /* 数据对应的第一级分析指标（可选一级指标以最终授权为准）  */
    FirstIndex string `json:"firstIndex"`

    /* 数据对应的第二级分析指标，如不填写，则默认把一级指标下的所有二级指标都查询出来（可选二级指标以最终授权为准） (Optional) */
    SecondIndex *string `json:"secondIndex"`
}

/*
 * param regionId: 地域ID (Required)
 * param region: 查询区域，比如某某省或某某市（可选区域以最终授权为准） (Required)
 * param industry: 查询行业，比如某个水果或者农作物（可选行业以最终授权为准） (Required)
 * param startDate: 查询起始时间，格式如下：yyyy-MM-dd (Required)
 * param endDate: 查询结束时间，格式如下：yyyy-MM-dd (Required)
 * param firstIndex: 数据对应的第一级分析指标（可选一级指标以最终授权为准） (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewGetLargeScreenDataRequest(
    regionId string,
    region string,
    industry string,
    startDate string,
    endDate string,
    firstIndex string,
) *GetLargeScreenDataRequest {

	return &GetLargeScreenDataRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/largeScreen/getData",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Region: region,
        Industry: industry,
        StartDate: startDate,
        EndDate: endDate,
        FirstIndex: firstIndex,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param region: 查询区域，比如某某省或某某市（可选区域以最终授权为准） (Required)
 * param industry: 查询行业，比如某个水果或者农作物（可选行业以最终授权为准） (Required)
 * param startDate: 查询起始时间，格式如下：yyyy-MM-dd (Required)
 * param endDate: 查询结束时间，格式如下：yyyy-MM-dd (Required)
 * param firstIndex: 数据对应的第一级分析指标（可选一级指标以最终授权为准） (Required)
 * param secondIndex: 数据对应的第二级分析指标，如不填写，则默认把一级指标下的所有二级指标都查询出来（可选二级指标以最终授权为准） (Optional)
 */
func NewGetLargeScreenDataRequestWithAllParams(
    regionId string,
    region string,
    industry string,
    startDate string,
    endDate string,
    firstIndex string,
    secondIndex *string,
) *GetLargeScreenDataRequest {

    return &GetLargeScreenDataRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/largeScreen/getData",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Region: region,
        Industry: industry,
        StartDate: startDate,
        EndDate: endDate,
        FirstIndex: firstIndex,
        SecondIndex: secondIndex,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewGetLargeScreenDataRequestWithoutParam() *GetLargeScreenDataRequest {

    return &GetLargeScreenDataRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/largeScreen/getData",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *GetLargeScreenDataRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param region: 查询区域，比如某某省或某某市（可选区域以最终授权为准）(Required) */
func (r *GetLargeScreenDataRequest) SetRegion(region string) {
    r.Region = region
}

/* param industry: 查询行业，比如某个水果或者农作物（可选行业以最终授权为准）(Required) */
func (r *GetLargeScreenDataRequest) SetIndustry(industry string) {
    r.Industry = industry
}

/* param startDate: 查询起始时间，格式如下：yyyy-MM-dd(Required) */
func (r *GetLargeScreenDataRequest) SetStartDate(startDate string) {
    r.StartDate = startDate
}

/* param endDate: 查询结束时间，格式如下：yyyy-MM-dd(Required) */
func (r *GetLargeScreenDataRequest) SetEndDate(endDate string) {
    r.EndDate = endDate
}

/* param firstIndex: 数据对应的第一级分析指标（可选一级指标以最终授权为准）(Required) */
func (r *GetLargeScreenDataRequest) SetFirstIndex(firstIndex string) {
    r.FirstIndex = firstIndex
}

/* param secondIndex: 数据对应的第二级分析指标，如不填写，则默认把一级指标下的所有二级指标都查询出来（可选二级指标以最终授权为准）(Optional) */
func (r *GetLargeScreenDataRequest) SetSecondIndex(secondIndex string) {
    r.SecondIndex = &secondIndex
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r GetLargeScreenDataRequest) GetRegionId() string {
    return r.RegionId
}

type GetLargeScreenDataResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result GetLargeScreenDataResult `json:"result"`
}

type GetLargeScreenDataResult struct {
    Status bool `json:"status"`
    Message string `json:"message"`
    Data datastar.RegionIndustryDataList `json:"data"`
}