// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type GetPackageIdRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* MD5（deviceId），多个MD5（deviceId）用英文逗号进行分割，注：MD5结果小写  */
    DeviceIds string `json:"deviceIds"`
}

/*
 * param regionId: 地域ID (Required)
 * param deviceIds: MD5（deviceId），多个MD5（deviceId）用英文逗号进行分割，注：MD5结果小写 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewGetPackageIdRequest(
    regionId string,
    deviceIds string,
) *GetPackageIdRequest {

	return &GetPackageIdRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/dmp/getPackageId",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        DeviceIds: deviceIds,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param deviceIds: MD5（deviceId），多个MD5（deviceId）用英文逗号进行分割，注：MD5结果小写 (Required)
 */
func NewGetPackageIdRequestWithAllParams(
    regionId string,
    deviceIds string,
) *GetPackageIdRequest {

    return &GetPackageIdRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/dmp/getPackageId",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        DeviceIds: deviceIds,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewGetPackageIdRequestWithoutParam() *GetPackageIdRequest {

    return &GetPackageIdRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/dmp/getPackageId",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *GetPackageIdRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param deviceIds: MD5（deviceId），多个MD5（deviceId）用英文逗号进行分割，注：MD5结果小写(Required) */
func (r *GetPackageIdRequest) SetDeviceIds(deviceIds string) {
    r.DeviceIds = deviceIds
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r GetPackageIdRequest) GetRegionId() string {
    return r.RegionId
}

type GetPackageIdResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result GetPackageIdResult `json:"result"`
}

type GetPackageIdResult struct {
    Status bool `json:"status"`
    Message string `json:"message"`
    Data string `json:"data"`
}