// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type GetProfileRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* deviceId，mobile等,多个id英文逗号分隔  */
    Id string `json:"id"`

    /* 数据类型  */
    Type string `json:"type"`

    /* 画像标签编号,多个画像标签英文逗号分隔  */
    LabelCode string `json:"labelCode"`
}

/*
 * param regionId: 地域ID (Required)
 * param id: deviceId，mobile等,多个id英文逗号分隔 (Required)
 * param type_: 数据类型 (Required)
 * param labelCode: 画像标签编号,多个画像标签英文逗号分隔 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewGetProfileRequest(
    regionId string,
    id string,
    type_ string,
    labelCode string,
) *GetProfileRequest {

	return &GetProfileRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/profile/getProfile",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Id: id,
        Type: type_,
        LabelCode: labelCode,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param id: deviceId，mobile等,多个id英文逗号分隔 (Required)
 * param type_: 数据类型 (Required)
 * param labelCode: 画像标签编号,多个画像标签英文逗号分隔 (Required)
 */
func NewGetProfileRequestWithAllParams(
    regionId string,
    id string,
    type_ string,
    labelCode string,
) *GetProfileRequest {

    return &GetProfileRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/profile/getProfile",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Id: id,
        Type: type_,
        LabelCode: labelCode,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewGetProfileRequestWithoutParam() *GetProfileRequest {

    return &GetProfileRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/profile/getProfile",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *GetProfileRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param id: deviceId，mobile等,多个id英文逗号分隔(Required) */
func (r *GetProfileRequest) SetId(id string) {
    r.Id = id
}

/* param type_: 数据类型(Required) */
func (r *GetProfileRequest) SetType(type_ string) {
    r.Type = type_
}

/* param labelCode: 画像标签编号,多个画像标签英文逗号分隔(Required) */
func (r *GetProfileRequest) SetLabelCode(labelCode string) {
    r.LabelCode = labelCode
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r GetProfileRequest) GetRegionId() string {
    return r.RegionId
}

type GetProfileResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result GetProfileResult `json:"result"`
}

type GetProfileResult struct {
    Status bool `json:"status"`
    Message string `json:"message"`
    Data string `json:"data"`
}