// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package client

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    datastar "github.com/jdcloud-api/jdcloud-sdk-go/services/datastar/apis"
    "encoding/json"
    "errors"
)

type DatastarClient struct {
    core.JDCloudClient
}

func NewDatastarClient(credential *core.Credential) *DatastarClient {
    if credential == nil {
        return nil
    }

    config := core.NewConfig()
    config.SetEndpoint("datastar.jdcloud-api.com")

    return &DatastarClient{
        core.JDCloudClient{
            Credential:  *credential,
            Config:      *config,
            ServiceName: "datastar",
            Revision:    "1.0.6",
            Logger:      core.NewDefaultLogger(core.LogInfo),
        }}
}

func (c *DatastarClient) SetConfig(config *core.Config) {
    c.Config = *config
}

func (c *DatastarClient) SetLogger(logger core.Logger) {
    c.Logger = logger
}

/* 根据区域、行业、一级指标、二级指标、起始时间等条件查询数据 */
func (c *DatastarClient) GetLargeScreenData(request *datastar.GetLargeScreenDataRequest) (*datastar.GetLargeScreenDataResponse, error) {
    if request == nil {
        return nil, errors.New("Request object is nil. ")
    }
    resp, err := c.Send(request, c.ServiceName)
    if err != nil {
        return nil, err
    }

    jdResp := &datastar.GetLargeScreenDataResponse{}
    err = json.Unmarshal(resp, jdResp)
    if err != nil {
        c.Logger.Log(core.LogError, "Unmarshal json failed, resp: %s", string(resp))
        return nil, err
    }

    return jdResp, err
}

