// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    deploy "github.com/jdcloud-api/jdcloud-sdk-go/services/deploy/models"
)

type DescribeAppRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* App Id  */
    AppId string `json:"appId"`
}

/*
 * param regionId: 地域ID (Required)
 * param appId: App Id (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeAppRequest(
    regionId string,
    appId string,
) *DescribeAppRequest {

	return &DescribeAppRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/app/{appId}",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        AppId: appId,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param appId: App Id (Required)
 */
func NewDescribeAppRequestWithAllParams(
    regionId string,
    appId string,
) *DescribeAppRequest {

    return &DescribeAppRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/app/{appId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        AppId: appId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeAppRequestWithoutParam() *DescribeAppRequest {

    return &DescribeAppRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/app/{appId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *DescribeAppRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param appId: App Id(Required) */
func (r *DescribeAppRequest) SetAppId(appId string) {
    r.AppId = appId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeAppRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeAppResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeAppResult `json:"result"`
}

type DescribeAppResult struct {
    App deploy.App `json:"app"`
}