// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    deploy "github.com/jdcloud-api/jdcloud-sdk-go/services/deploy/models"
)

type DescribeDeployRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* Deploy Id  */
    DeployId string `json:"deployId"`
}

/*
 * param regionId: 地域ID (Required)
 * param deployId: Deploy Id (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeDeployRequest(
    regionId string,
    deployId string,
) *DescribeDeployRequest {

	return &DescribeDeployRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/deploy/{deployId}",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        DeployId: deployId,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param deployId: Deploy Id (Required)
 */
func NewDescribeDeployRequestWithAllParams(
    regionId string,
    deployId string,
) *DescribeDeployRequest {

    return &DescribeDeployRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/deploy/{deployId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        DeployId: deployId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeDeployRequestWithoutParam() *DescribeDeployRequest {

    return &DescribeDeployRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/deploy/{deployId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *DescribeDeployRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param deployId: Deploy Id(Required) */
func (r *DescribeDeployRequest) SetDeployId(deployId string) {
    r.DeployId = deployId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeDeployRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeDeployResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeDeployResult `json:"result"`
}

type DescribeDeployResult struct {
    Deploy deploy.Deploy `json:"deploy"`
}