// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    deploy "github.com/jdcloud-api/jdcloud-sdk-go/services/deploy/models"
)

type DescribeGroupRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* Group Id  */
    GroupId string `json:"groupId"`
}

/*
 * param regionId: 地域ID (Required)
 * param groupId: Group Id (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeGroupRequest(
    regionId string,
    groupId string,
) *DescribeGroupRequest {

	return &DescribeGroupRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/group/{groupId}",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        GroupId: groupId,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param groupId: Group Id (Required)
 */
func NewDescribeGroupRequestWithAllParams(
    regionId string,
    groupId string,
) *DescribeGroupRequest {

    return &DescribeGroupRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/group/{groupId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        GroupId: groupId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeGroupRequestWithoutParam() *DescribeGroupRequest {

    return &DescribeGroupRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/group/{groupId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *DescribeGroupRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param groupId: Group Id(Required) */
func (r *DescribeGroupRequest) SetGroupId(groupId string) {
    r.GroupId = groupId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeGroupRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeGroupResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeGroupResult `json:"result"`
}

type DescribeGroupResult struct {
    Group deploy.Group `json:"group"`
}