// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    elite "github.com/jdcloud-api/jdcloud-sdk-go/services/elite/models"
)

type JdxReportOrderRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 上报订单信息  */
    ReportOrderInfo *elite.ReportOrderInfo `json:"reportOrderInfo"`
}

/*
 * param regionId: 地域ID (Required)
 * param reportOrderInfo: 上报订单信息 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewJdxReportOrderRequest(
    regionId string,
    reportOrderInfo *elite.ReportOrderInfo,
) *JdxReportOrderRequest {

	return &JdxReportOrderRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/jdxReportOrder",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        ReportOrderInfo: reportOrderInfo,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param reportOrderInfo: 上报订单信息 (Required)
 */
func NewJdxReportOrderRequestWithAllParams(
    regionId string,
    reportOrderInfo *elite.ReportOrderInfo,
) *JdxReportOrderRequest {

    return &JdxReportOrderRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/jdxReportOrder",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        ReportOrderInfo: reportOrderInfo,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewJdxReportOrderRequestWithoutParam() *JdxReportOrderRequest {

    return &JdxReportOrderRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/jdxReportOrder",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *JdxReportOrderRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param reportOrderInfo: 上报订单信息(Required) */
func (r *JdxReportOrderRequest) SetReportOrderInfo(reportOrderInfo *elite.ReportOrderInfo) {
    r.ReportOrderInfo = reportOrderInfo
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r JdxReportOrderRequest) GetRegionId() string {
    return r.RegionId
}

type JdxReportOrderResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result JdxReportOrderResult `json:"result"`
}

type JdxReportOrderResult struct {
    Status bool `json:"status"`
    Message string `json:"message"`
}