// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    function "github.com/jdcloud-api/jdcloud-sdk-go/services/function/models"
)

type CreateFunctionRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 函数名称 (Optional) */
    Name *string `json:"name"`

    /* 函数描述信息 (Optional) */
    Description *string `json:"description"`

    /* 函数入口，格式为入口文件.入口函数名 (Optional) */
    Entrance *string `json:"entrance"`

    /* 函数运行最大内存 (Optional) */
    Memory *int `json:"memory"`

    /* 函数运行环境 (Optional) */
    RunTime *string `json:"runTime"`

    /* 函数运行超时时间 (Optional) */
    OverTime *int `json:"overTime"`

    /* 函数版本，默认为LATEST (Optional) */
    Version *string `json:"version"`

    /* 函数代码包 (Optional) */
    Code *function.Code `json:"code"`

    /* 函数运行时环境变量 (Optional) */
    Environment *function.Env `json:"environment"`

    /* 函数指定的日志集Id (Optional) */
    LogSetId *string `json:"logSetId"`

    /* 函数指定的日志主题Id (Optional) */
    LogTopicId *string `json:"logTopicId"`

    /* 函数配置的VPCId (Optional) */
    VpcId *string `json:"vpcId"`

    /* 函数配置的子网Id (Optional) */
    SubnetId *string `json:"subnetId"`
}

/*
 * param regionId: Region ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCreateFunctionRequest(
    regionId string,
) *CreateFunctionRequest {

	return &CreateFunctionRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/functions",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
	}
}

/*
 * param regionId: Region ID (Required)
 * param name: 函数名称 (Optional)
 * param description: 函数描述信息 (Optional)
 * param entrance: 函数入口，格式为入口文件.入口函数名 (Optional)
 * param memory: 函数运行最大内存 (Optional)
 * param runTime: 函数运行环境 (Optional)
 * param overTime: 函数运行超时时间 (Optional)
 * param version: 函数版本，默认为LATEST (Optional)
 * param code: 函数代码包 (Optional)
 * param environment: 函数运行时环境变量 (Optional)
 * param logSetId: 函数指定的日志集Id (Optional)
 * param logTopicId: 函数指定的日志主题Id (Optional)
 * param vpcId: 函数配置的VPCId (Optional)
 * param subnetId: 函数配置的子网Id (Optional)
 */
func NewCreateFunctionRequestWithAllParams(
    regionId string,
    name *string,
    description *string,
    entrance *string,
    memory *int,
    runTime *string,
    overTime *int,
    version *string,
    code *function.Code,
    environment *function.Env,
    logSetId *string,
    logTopicId *string,
    vpcId *string,
    subnetId *string,
) *CreateFunctionRequest {

    return &CreateFunctionRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/functions",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Name: name,
        Description: description,
        Entrance: entrance,
        Memory: memory,
        RunTime: runTime,
        OverTime: overTime,
        Version: version,
        Code: code,
        Environment: environment,
        LogSetId: logSetId,
        LogTopicId: logTopicId,
        VpcId: vpcId,
        SubnetId: subnetId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCreateFunctionRequestWithoutParam() *CreateFunctionRequest {

    return &CreateFunctionRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/functions",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *CreateFunctionRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param name: 函数名称(Optional) */
func (r *CreateFunctionRequest) SetName(name string) {
    r.Name = &name
}

/* param description: 函数描述信息(Optional) */
func (r *CreateFunctionRequest) SetDescription(description string) {
    r.Description = &description
}

/* param entrance: 函数入口，格式为入口文件.入口函数名(Optional) */
func (r *CreateFunctionRequest) SetEntrance(entrance string) {
    r.Entrance = &entrance
}

/* param memory: 函数运行最大内存(Optional) */
func (r *CreateFunctionRequest) SetMemory(memory int) {
    r.Memory = &memory
}

/* param runTime: 函数运行环境(Optional) */
func (r *CreateFunctionRequest) SetRunTime(runTime string) {
    r.RunTime = &runTime
}

/* param overTime: 函数运行超时时间(Optional) */
func (r *CreateFunctionRequest) SetOverTime(overTime int) {
    r.OverTime = &overTime
}

/* param version: 函数版本，默认为LATEST(Optional) */
func (r *CreateFunctionRequest) SetVersion(version string) {
    r.Version = &version
}

/* param code: 函数代码包(Optional) */
func (r *CreateFunctionRequest) SetCode(code *function.Code) {
    r.Code = code
}

/* param environment: 函数运行时环境变量(Optional) */
func (r *CreateFunctionRequest) SetEnvironment(environment *function.Env) {
    r.Environment = environment
}

/* param logSetId: 函数指定的日志集Id(Optional) */
func (r *CreateFunctionRequest) SetLogSetId(logSetId string) {
    r.LogSetId = &logSetId
}

/* param logTopicId: 函数指定的日志主题Id(Optional) */
func (r *CreateFunctionRequest) SetLogTopicId(logTopicId string) {
    r.LogTopicId = &logTopicId
}

/* param vpcId: 函数配置的VPCId(Optional) */
func (r *CreateFunctionRequest) SetVpcId(vpcId string) {
    r.VpcId = &vpcId
}

/* param subnetId: 函数配置的子网Id(Optional) */
func (r *CreateFunctionRequest) SetSubnetId(subnetId string) {
    r.SubnetId = &subnetId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CreateFunctionRequest) GetRegionId() string {
    return r.RegionId
}

type CreateFunctionResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CreateFunctionResult `json:"result"`
}

type CreateFunctionResult struct {
    Data function.Function `json:"data"`
}