// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    function "github.com/jdcloud-api/jdcloud-sdk-go/services/function/models"
)

type ListAliasRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 别名所属函数名称  */
    FunctionName string `json:"functionName"`
}

/*
 * param regionId: Region ID (Required)
 * param functionName: 别名所属函数名称 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewListAliasRequest(
    regionId string,
    functionName string,
) *ListAliasRequest {

	return &ListAliasRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/functions/{functionName}/aliases",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        FunctionName: functionName,
	}
}

/*
 * param regionId: Region ID (Required)
 * param functionName: 别名所属函数名称 (Required)
 */
func NewListAliasRequestWithAllParams(
    regionId string,
    functionName string,
) *ListAliasRequest {

    return &ListAliasRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/functions/{functionName}/aliases",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        FunctionName: functionName,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewListAliasRequestWithoutParam() *ListAliasRequest {

    return &ListAliasRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/functions/{functionName}/aliases",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *ListAliasRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param functionName: 别名所属函数名称(Required) */
func (r *ListAliasRequest) SetFunctionName(functionName string) {
    r.FunctionName = functionName
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ListAliasRequest) GetRegionId() string {
    return r.RegionId
}

type ListAliasResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ListAliasResult `json:"result"`
}

type ListAliasResult struct {
    Data []function.Alias `json:"data"`
}