// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    function "github.com/jdcloud-api/jdcloud-sdk-go/services/function/models"
    common "github.com/jdcloud-api/jdcloud-sdk-go/services/common/models"
)

type ListFunctionRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 是否返回所有函数  */
    ListAll bool `json:"listAll"`

    /* 页码 (Optional) */
    PageNumber *int `json:"pageNumber"`

    /* 分页大小 (Optional) */
    PageSize *int `json:"pageSize"`

    /* functionId -函数ID，精确匹配，支持多个
functionName  - 函数名称，模糊匹配，支持单个
 (Optional) */
    Filters []common.Filter `json:"filters"`
}

/*
 * param regionId: Region ID (Required)
 * param listAll: 是否返回所有函数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewListFunctionRequest(
    regionId string,
    listAll bool,
) *ListFunctionRequest {

	return &ListFunctionRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/functions",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        ListAll: listAll,
	}
}

/*
 * param regionId: Region ID (Required)
 * param listAll: 是否返回所有函数 (Required)
 * param pageNumber: 页码 (Optional)
 * param pageSize: 分页大小 (Optional)
 * param filters: functionId -函数ID，精确匹配，支持多个
functionName  - 函数名称，模糊匹配，支持单个
 (Optional)
 */
func NewListFunctionRequestWithAllParams(
    regionId string,
    listAll bool,
    pageNumber *int,
    pageSize *int,
    filters []common.Filter,
) *ListFunctionRequest {

    return &ListFunctionRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/functions",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        ListAll: listAll,
        PageNumber: pageNumber,
        PageSize: pageSize,
        Filters: filters,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewListFunctionRequestWithoutParam() *ListFunctionRequest {

    return &ListFunctionRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/functions",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *ListFunctionRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param listAll: 是否返回所有函数(Required) */
func (r *ListFunctionRequest) SetListAll(listAll bool) {
    r.ListAll = listAll
}

/* param pageNumber: 页码(Optional) */
func (r *ListFunctionRequest) SetPageNumber(pageNumber int) {
    r.PageNumber = &pageNumber
}

/* param pageSize: 分页大小(Optional) */
func (r *ListFunctionRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

/* param filters: functionId -函数ID，精确匹配，支持多个
functionName  - 函数名称，模糊匹配，支持单个
(Optional) */
func (r *ListFunctionRequest) SetFilters(filters []common.Filter) {
    r.Filters = filters
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ListFunctionRequest) GetRegionId() string {
    return r.RegionId
}

type ListFunctionResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ListFunctionResult `json:"result"`
}

type ListFunctionResult struct {
    Data function.ListFunctionResult `json:"data"`
}