// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    function "github.com/jdcloud-api/jdcloud-sdk-go/services/function/models"
)

type UpdateAliasRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 别名所属函数名称  */
    FunctionName string `json:"functionName"`

    /* 别名名称  */
    AliasName string `json:"aliasName"`

    /* 别名描述信息  */
    Description string `json:"description"`

    /* 别名对应版本  */
    Version string `json:"version"`
}

/*
 * param regionId: Region ID (Required)
 * param functionName: 别名所属函数名称 (Required)
 * param aliasName: 别名名称 (Required)
 * param description: 别名描述信息 (Required)
 * param version: 别名对应版本 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewUpdateAliasRequest(
    regionId string,
    functionName string,
    aliasName string,
    description string,
    version string,
) *UpdateAliasRequest {

	return &UpdateAliasRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/functions/{functionName}/aliases/{aliasName}",
			Method:  "PUT",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        FunctionName: functionName,
        AliasName: aliasName,
        Description: description,
        Version: version,
	}
}

/*
 * param regionId: Region ID (Required)
 * param functionName: 别名所属函数名称 (Required)
 * param aliasName: 别名名称 (Required)
 * param description: 别名描述信息 (Required)
 * param version: 别名对应版本 (Required)
 */
func NewUpdateAliasRequestWithAllParams(
    regionId string,
    functionName string,
    aliasName string,
    description string,
    version string,
) *UpdateAliasRequest {

    return &UpdateAliasRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/functions/{functionName}/aliases/{aliasName}",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        FunctionName: functionName,
        AliasName: aliasName,
        Description: description,
        Version: version,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewUpdateAliasRequestWithoutParam() *UpdateAliasRequest {

    return &UpdateAliasRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/functions/{functionName}/aliases/{aliasName}",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *UpdateAliasRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param functionName: 别名所属函数名称(Required) */
func (r *UpdateAliasRequest) SetFunctionName(functionName string) {
    r.FunctionName = functionName
}

/* param aliasName: 别名名称(Required) */
func (r *UpdateAliasRequest) SetAliasName(aliasName string) {
    r.AliasName = aliasName
}

/* param description: 别名描述信息(Required) */
func (r *UpdateAliasRequest) SetDescription(description string) {
    r.Description = description
}

/* param version: 别名对应版本(Required) */
func (r *UpdateAliasRequest) SetVersion(version string) {
    r.Version = version
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r UpdateAliasRequest) GetRegionId() string {
    return r.RegionId
}

type UpdateAliasResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result UpdateAliasResult `json:"result"`
}

type UpdateAliasResult struct {
    Data function.Alias `json:"data"`
}