// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DelDomainsRequest struct {

    core.JDCloudRequest

    /* 实例所属的地域ID  */
    RegionId string `json:"regionId"`

    /* 需要删除的域名数组  */
    DomainNames []string `json:"domainNames"`
}

/*
 * param regionId: 实例所属的地域ID (Required)
 * param domainNames: 需要删除的域名数组 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDelDomainsRequest(
    regionId string,
    domainNames []string,
) *DelDomainsRequest {

	return &DelDomainsRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/domain/delDomain",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        DomainNames: domainNames,
	}
}

/*
 * param regionId: 实例所属的地域ID (Required)
 * param domainNames: 需要删除的域名数组 (Required)
 */
func NewDelDomainsRequestWithAllParams(
    regionId string,
    domainNames []string,
) *DelDomainsRequest {

    return &DelDomainsRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/domain/delDomain",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        DomainNames: domainNames,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDelDomainsRequestWithoutParam() *DelDomainsRequest {

    return &DelDomainsRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/domain/delDomain",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 实例所属的地域ID(Required) */
func (r *DelDomainsRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param domainNames: 需要删除的域名数组(Required) */
func (r *DelDomainsRequest) SetDomainNames(domainNames []string) {
    r.DomainNames = domainNames
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DelDomainsRequest) GetRegionId() string {
    return r.RegionId
}

type DelDomainsResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DelDomainsResult `json:"result"`
}

type DelDomainsResult struct {
}