// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type OperateKeyRequest struct {

    core.JDCloudRequest

    /* 实例所属的地域ID  */
    RegionId string `json:"regionId"`

    /* 操作类型, create创建, enable启用, disable禁用 (Optional) */
    Action *string `json:"action"`

    /* 操作的密钥 (Optional) */
    Key *string `json:"key"`
}

/*
 * param regionId: 实例所属的地域ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewOperateKeyRequest(
    regionId string,
) *OperateKeyRequest {

	return &OperateKeyRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/account/operateKey",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
	}
}

/*
 * param regionId: 实例所属的地域ID (Required)
 * param action: 操作类型, create创建, enable启用, disable禁用 (Optional)
 * param key: 操作的密钥 (Optional)
 */
func NewOperateKeyRequestWithAllParams(
    regionId string,
    action *string,
    key *string,
) *OperateKeyRequest {

    return &OperateKeyRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/account/operateKey",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Action: action,
        Key: key,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewOperateKeyRequestWithoutParam() *OperateKeyRequest {

    return &OperateKeyRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/account/operateKey",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 实例所属的地域ID(Required) */
func (r *OperateKeyRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param action: 操作类型, create创建, enable启用, disable禁用(Optional) */
func (r *OperateKeyRequest) SetAction(action string) {
    r.Action = &action
}

/* param key: 操作的密钥(Optional) */
func (r *OperateKeyRequest) SetKey(key string) {
    r.Key = &key
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r OperateKeyRequest) GetRegionId() string {
    return r.RegionId
}

type OperateKeyResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result OperateKeyResult `json:"result"`
}

type OperateKeyResult struct {
}