// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    iam "github.com/jdcloud-api/jdcloud-sdk-go/services/iam/models"
)

type DescribePermissionDetailRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 权限id  */
    PermissionId int `json:"permissionId"`
}

/*
 * param regionId: Region ID (Required)
 * param permissionId: 权限id (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribePermissionDetailRequest(
    regionId string,
    permissionId int,
) *DescribePermissionDetailRequest {

	return &DescribePermissionDetailRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/permission/{permissionId}",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        PermissionId: permissionId,
	}
}

/*
 * param regionId: Region ID (Required)
 * param permissionId: 权限id (Required)
 */
func NewDescribePermissionDetailRequestWithAllParams(
    regionId string,
    permissionId int,
) *DescribePermissionDetailRequest {

    return &DescribePermissionDetailRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/permission/{permissionId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        PermissionId: permissionId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribePermissionDetailRequestWithoutParam() *DescribePermissionDetailRequest {

    return &DescribePermissionDetailRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/permission/{permissionId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *DescribePermissionDetailRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param permissionId: 权限id(Required) */
func (r *DescribePermissionDetailRequest) SetPermissionId(permissionId int) {
    r.PermissionId = permissionId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribePermissionDetailRequest) GetRegionId() string {
    return r.RegionId
}

type DescribePermissionDetailResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribePermissionDetailResult `json:"result"`
}

type DescribePermissionDetailResult struct {
    Permission iam.Permission `json:"permission"`
}