// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DisabledUserAccessKeyRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* accessKey  */
    AccessKey string `json:"accessKey"`
}

/*
 * param regionId: Region ID (Required)
 * param accessKey: accessKey (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDisabledUserAccessKeyRequest(
    regionId string,
    accessKey string,
) *DisabledUserAccessKeyRequest {

	return &DisabledUserAccessKeyRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/userAccessKey/{accessKey}:disabled",
			Method:  "PUT",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        AccessKey: accessKey,
	}
}

/*
 * param regionId: Region ID (Required)
 * param accessKey: accessKey (Required)
 */
func NewDisabledUserAccessKeyRequestWithAllParams(
    regionId string,
    accessKey string,
) *DisabledUserAccessKeyRequest {

    return &DisabledUserAccessKeyRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/userAccessKey/{accessKey}:disabled",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        AccessKey: accessKey,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDisabledUserAccessKeyRequestWithoutParam() *DisabledUserAccessKeyRequest {

    return &DisabledUserAccessKeyRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/userAccessKey/{accessKey}:disabled",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *DisabledUserAccessKeyRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param accessKey: accessKey(Required) */
func (r *DisabledUserAccessKeyRequest) SetAccessKey(accessKey string) {
    r.AccessKey = accessKey
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DisabledUserAccessKeyRequest) GetRegionId() string {
    return r.RegionId
}

type DisabledUserAccessKeyResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DisabledUserAccessKeyResult `json:"result"`
}

type DisabledUserAccessKeyResult struct {
}