// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type GetAppRequest struct {

    core.JDCloudRequest

    /* 地域编码，参考OpenAPI公共说明  */
    RegionId string `json:"regionId"`

    /* 应用ID，应用创建时由京东云分配的16位数字ID  */
    ClientId string `json:"clientId"`
}

/*
 * param regionId: 地域编码，参考OpenAPI公共说明 (Required)
 * param clientId: 应用ID，应用创建时由京东云分配的16位数字ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewGetAppRequest(
    regionId string,
    clientId string,
) *GetAppRequest {

	return &GetAppRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/app/{clientId}",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        ClientId: clientId,
	}
}

/*
 * param regionId: 地域编码，参考OpenAPI公共说明 (Required)
 * param clientId: 应用ID，应用创建时由京东云分配的16位数字ID (Required)
 */
func NewGetAppRequestWithAllParams(
    regionId string,
    clientId string,
) *GetAppRequest {

    return &GetAppRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/app/{clientId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        ClientId: clientId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewGetAppRequestWithoutParam() *GetAppRequest {

    return &GetAppRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/app/{clientId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域编码，参考OpenAPI公共说明(Required) */
func (r *GetAppRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param clientId: 应用ID，应用创建时由京东云分配的16位数字ID(Required) */
func (r *GetAppRequest) SetClientId(clientId string) {
    r.ClientId = clientId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r GetAppRequest) GetRegionId() string {
    return r.RegionId
}

type GetAppResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result GetAppResult `json:"result"`
}

type GetAppResult struct {
    ClientId string `json:"clientId"`
    ClientName string `json:"clientName"`
    TokenEndpointAuthMethod string `json:"tokenEndpointAuthMethod"`
    GrantTypes string `json:"grantTypes"`
    ResponseTypes string `json:"responseTypes"`
    RedirectUris string `json:"redirectUris"`
    ClientUri string `json:"clientUri"`
    LogoUri string `json:"logoUri"`
    TosUri string `json:"tosUri"`
    PolicyUri string `json:"policyUri"`
    Scope string `json:"scope"`
    JwksUri string `json:"jwksUri"`
    Jwks string `json:"jwks"`
    Contacts string `json:"contacts"`
    Extension string `json:"extension"`
    AccessTokenValiditySeconds int `json:"accessTokenValiditySeconds"`
    RefreshTokenValiditySeconds int `json:"refreshTokenValiditySeconds"`
    MultiTenant bool `json:"multiTenant"`
    SecretUpdateTime int64 `json:"secretUpdateTime"`
    UpdateTime int64 `json:"updateTime"`
    CreateTime int64 `json:"createTime"`
    Account string `json:"account"`
    UserType string `json:"userType"`
}