// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    ias "github.com/jdcloud-api/jdcloud-sdk-go/services/ias/models"
)

type StateRequest struct {

    core.JDCloudRequest

    /*   */
    RegionId string `json:"regionId"`
}

/*
 * param regionId:  (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewStateRequest(
    regionId string,
) *StateRequest {

	return &StateRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/operate_backend/state",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
	}
}

/*
 * param regionId:  (Required)
 */
func NewStateRequestWithAllParams(
    regionId string,
) *StateRequest {

    return &StateRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/operate_backend/state",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewStateRequestWithoutParam() *StateRequest {

    return &StateRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/operate_backend/state",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: (Required) */
func (r *StateRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r StateRequest) GetRegionId() string {
    return r.RegionId
}

type StateResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result StateResult `json:"result"`
}

type StateResult struct {
    States []ias.State `json:"states"`
}