// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package models


type ApplicationRes struct {

    /* 应用ID，由京东云分配的16位数字ID  */
    ClientId string `json:"clientId"`

    /* 应用名  */
    ClientName string `json:"clientName"`

    /* 客户端认证方式  */
    TokenEndpointAuthMethod string `json:"tokenEndpointAuthMethod"`

    /* 支持的OAuth类型  */
    GrantTypes string `json:"grantTypes"`

    /* 当grantTypes为authorization_code时，responseTypes为code；当grantTypes为implicit时，responseTypes为token  */
    ResponseTypes string `json:"responseTypes"`

    /* 回调地址  */
    RedirectUris string `json:"redirectUris"`

    /* 应用介绍地址  */
    ClientUri string `json:"clientUri"`

    /* 应用logo地址  */
    LogoUri string `json:"logoUri"`

    /* 应用服务协议地址  */
    TosUri string `json:"tosUri"`

    /* 应用隐私条款地址  */
    PolicyUri string `json:"policyUri"`

    /* OAuth scope授权范围  */
    Scope string `json:"scope"`

    /* JWKS地址  */
    JwksUri string `json:"jwksUri"`

    /* JWKS  */
    Jwks string `json:"jwks"`

    /* 应用联系信息  */
    Contacts string `json:"contacts"`

    /* 应用扩展信息  */
    Extension string `json:"extension"`

    /* 访问令牌有效期  */
    AccessTokenValiditySeconds int `json:"accessTokenValiditySeconds"`

    /* 刷新令牌有效期  */
    RefreshTokenValiditySeconds int `json:"refreshTokenValiditySeconds"`

    /* 是否为多租户应用  */
    MultiTenant bool `json:"multiTenant"`

    /* 应用密码更新时间  */
    SecretUpdateTime int64 `json:"secretUpdateTime"`

    /* 应用更新时间  */
    UpdateTime int64 `json:"updateTime"`

    /* 应用创建时间  */
    CreateTime int64 `json:"createTime"`

    /* 创建应用的账户用户名  */
    Account string `json:"account"`

    /* 允许登录应用的账号类型  */
    UserType string `json:"userType"`
}
