// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DeleteDeviceRequest struct {

    core.JDCloudRequest

    /* 设备Id (Optional) */
    DeviceId *string `json:"deviceId"`

    /* hub实例instanceId (Optional) */
    InstanceId *string `json:"instanceId"`
}

/*
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDeleteDeviceRequest(
) *DeleteDeviceRequest {

	return &DeleteDeviceRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/device",
			Method:  "DELETE",
			Header:  nil,
			Version: "v1",
		},
	}
}

/*
 * param deviceId: 设备Id (Optional)
 * param instanceId: hub实例instanceId (Optional)
 */
func NewDeleteDeviceRequestWithAllParams(
    deviceId *string,
    instanceId *string,
) *DeleteDeviceRequest {

    return &DeleteDeviceRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/device",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
        DeviceId: deviceId,
        InstanceId: instanceId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDeleteDeviceRequestWithoutParam() *DeleteDeviceRequest {

    return &DeleteDeviceRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/device",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param deviceId: 设备Id(Optional) */
func (r *DeleteDeviceRequest) SetDeviceId(deviceId string) {
    r.DeviceId = &deviceId
}

/* param instanceId: hub实例instanceId(Optional) */
func (r *DeleteDeviceRequest) SetInstanceId(instanceId string) {
    r.InstanceId = &instanceId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DeleteDeviceRequest) GetRegionId() string {
    return ""
}

type DeleteDeviceResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DeleteDeviceResult `json:"result"`
}

type DeleteDeviceResult struct {
}