// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    iothub "github.com/jdcloud-api/jdcloud-sdk-go/services/iothub/models"
)

type DeviceCommandRequest struct {

    core.JDCloudRequest

    /* Device 唯一标识  */
    DeviceId string `json:"deviceId"`

    /*  (Optional) */
    Commands *iothub.DeviceCommandVO `json:"commands"`
}

/*
 * param deviceId: Device 唯一标识 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDeviceCommandRequest(
    deviceId string,
) *DeviceCommandRequest {

	return &DeviceCommandRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/device/{deviceId}/command",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        DeviceId: deviceId,
	}
}

/*
 * param deviceId: Device 唯一标识 (Required)
 * param commands:  (Optional)
 */
func NewDeviceCommandRequestWithAllParams(
    deviceId string,
    commands *iothub.DeviceCommandVO,
) *DeviceCommandRequest {

    return &DeviceCommandRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/device/{deviceId}/command",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        DeviceId: deviceId,
        Commands: commands,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDeviceCommandRequestWithoutParam() *DeviceCommandRequest {

    return &DeviceCommandRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/device/{deviceId}/command",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param deviceId: Device 唯一标识(Required) */
func (r *DeviceCommandRequest) SetDeviceId(deviceId string) {
    r.DeviceId = deviceId
}

/* param commands: (Optional) */
func (r *DeviceCommandRequest) SetCommands(commands *iothub.DeviceCommandVO) {
    r.Commands = commands
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DeviceCommandRequest) GetRegionId() string {
    return ""
}

type DeviceCommandResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DeviceCommandResult `json:"result"`
}

type DeviceCommandResult struct {
    Data string `json:"data"`
}