// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    iothub "github.com/jdcloud-api/jdcloud-sdk-go/services/iothub/models"
)

type DevicesEnrollRequest struct {

    core.JDCloudRequest

    /*  (Optional) */
    InstanceId *string `json:"instanceId"`

    /*  (Optional) */
    Device *iothub.DeviceEnrollVO `json:"device"`
}

/*
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDevicesEnrollRequest(
) *DevicesEnrollRequest {

	return &DevicesEnrollRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/device",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
	}
}

/*
 * param instanceId:  (Optional)
 * param device:  (Optional)
 */
func NewDevicesEnrollRequestWithAllParams(
    instanceId *string,
    device *iothub.DeviceEnrollVO,
) *DevicesEnrollRequest {

    return &DevicesEnrollRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/device",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        InstanceId: instanceId,
        Device: device,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDevicesEnrollRequestWithoutParam() *DevicesEnrollRequest {

    return &DevicesEnrollRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/device",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param instanceId: (Optional) */
func (r *DevicesEnrollRequest) SetInstanceId(instanceId string) {
    r.InstanceId = &instanceId
}

/* param device: (Optional) */
func (r *DevicesEnrollRequest) SetDevice(device *iothub.DeviceEnrollVO) {
    r.Device = device
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DevicesEnrollRequest) GetRegionId() string {
    return ""
}

type DevicesEnrollResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DevicesEnrollResult `json:"result"`
}

type DevicesEnrollResult struct {
    Data string `json:"data"`
}