// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type GetOMPrivateURLRequest struct {

    core.JDCloudRequest

    /*   */
    DeviceId string `json:"deviceId"`

    /*  (Optional) */
    InstanceId *string `json:"instanceId"`
}

/*
 * param deviceId:  (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewGetOMPrivateURLRequest(
    deviceId string,
) *GetOMPrivateURLRequest {

	return &GetOMPrivateURLRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/om/{deviceId}/privateurl",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        DeviceId: deviceId,
	}
}

/*
 * param deviceId:  (Required)
 * param instanceId:  (Optional)
 */
func NewGetOMPrivateURLRequestWithAllParams(
    deviceId string,
    instanceId *string,
) *GetOMPrivateURLRequest {

    return &GetOMPrivateURLRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/om/{deviceId}/privateurl",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        DeviceId: deviceId,
        InstanceId: instanceId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewGetOMPrivateURLRequestWithoutParam() *GetOMPrivateURLRequest {

    return &GetOMPrivateURLRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/om/{deviceId}/privateurl",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param deviceId: (Required) */
func (r *GetOMPrivateURLRequest) SetDeviceId(deviceId string) {
    r.DeviceId = deviceId
}

/* param instanceId: (Optional) */
func (r *GetOMPrivateURLRequest) SetInstanceId(instanceId string) {
    r.InstanceId = &instanceId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r GetOMPrivateURLRequest) GetRegionId() string {
    return ""
}

type GetOMPrivateURLResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result GetOMPrivateURLResult `json:"result"`
}

type GetOMPrivateURLResult struct {
    PrivateUrl string `json:"privateUrl"`
}