// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type OmEnrollRequest struct {

    core.JDCloudRequest

    /* 物模型唯一标识  */
    OmName string `json:"omName"`

    /*  (Optional) */
    InstanceId *string `json:"instanceId"`

    /*  (Optional) */
    Payload *string `json:"payload"`
}

/*
 * param omName: 物模型唯一标识 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewOmEnrollRequest(
    omName string,
) *OmEnrollRequest {

	return &OmEnrollRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/om/{omName}",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        OmName: omName,
	}
}

/*
 * param omName: 物模型唯一标识 (Required)
 * param instanceId:  (Optional)
 * param payload:  (Optional)
 */
func NewOmEnrollRequestWithAllParams(
    omName string,
    instanceId *string,
    payload *string,
) *OmEnrollRequest {

    return &OmEnrollRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/om/{omName}",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        OmName: omName,
        InstanceId: instanceId,
        Payload: payload,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewOmEnrollRequestWithoutParam() *OmEnrollRequest {

    return &OmEnrollRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/om/{omName}",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param omName: 物模型唯一标识(Required) */
func (r *OmEnrollRequest) SetOmName(omName string) {
    r.OmName = omName
}

/* param instanceId: (Optional) */
func (r *OmEnrollRequest) SetInstanceId(instanceId string) {
    r.InstanceId = &instanceId
}

/* param payload: (Optional) */
func (r *OmEnrollRequest) SetPayload(payload string) {
    r.Payload = &payload
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r OmEnrollRequest) GetRegionId() string {
    return ""
}

type OmEnrollResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result OmEnrollResult `json:"result"`
}

type OmEnrollResult struct {
    Data string `json:"data"`
}