// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    iothub "github.com/jdcloud-api/jdcloud-sdk-go/services/iothub/models"
)

type QueryDeviceOnlineInfosRequest struct {

    core.JDCloudRequest

    /* 设备Id集合 (Optional) */
    DeviceIds []string `json:"deviceIds"`
}

/*
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewQueryDeviceOnlineInfosRequest(
) *QueryDeviceOnlineInfosRequest {

	return &QueryDeviceOnlineInfosRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/device:queryOnlineInfos",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
	}
}

/*
 * param deviceIds: 设备Id集合 (Optional)
 */
func NewQueryDeviceOnlineInfosRequestWithAllParams(
    deviceIds []string,
) *QueryDeviceOnlineInfosRequest {

    return &QueryDeviceOnlineInfosRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/device:queryOnlineInfos",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        DeviceIds: deviceIds,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewQueryDeviceOnlineInfosRequestWithoutParam() *QueryDeviceOnlineInfosRequest {

    return &QueryDeviceOnlineInfosRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/device:queryOnlineInfos",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param deviceIds: 设备Id集合(Optional) */
func (r *QueryDeviceOnlineInfosRequest) SetDeviceIds(deviceIds []string) {
    r.DeviceIds = deviceIds
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r QueryDeviceOnlineInfosRequest) GetRegionId() string {
    return ""
}

type QueryDeviceOnlineInfosResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result QueryDeviceOnlineInfosResult `json:"result"`
}

type QueryDeviceOnlineInfosResult struct {
    OnlineInfos []iothub.OnlineInfo `json:"onlineInfos"`
}