// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    ipanti "github.com/jdcloud-api/jdcloud-sdk-go/services/ipanti/models"
)

type CreateWebRuleRequest struct {

    core.JDCloudRequest

    /* 区域 Id  */
    RegionId string `json:"regionId"`

    /* 高防实例 Id  */
    InstanceId int `json:"instanceId"`

    /* 添加网站类规则请求参数  */
    WebRuleSpec *ipanti.WebRuleSpec `json:"webRuleSpec"`
}

/*
 * param regionId: 区域 Id (Required)
 * param instanceId: 高防实例 Id (Required)
 * param webRuleSpec: 添加网站类规则请求参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCreateWebRuleRequest(
    regionId string,
    instanceId int,
    webRuleSpec *ipanti.WebRuleSpec,
) *CreateWebRuleRequest {

	return &CreateWebRuleRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/instances/{instanceId}/webRules",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        InstanceId: instanceId,
        WebRuleSpec: webRuleSpec,
	}
}

/*
 * param regionId: 区域 Id (Required)
 * param instanceId: 高防实例 Id (Required)
 * param webRuleSpec: 添加网站类规则请求参数 (Required)
 */
func NewCreateWebRuleRequestWithAllParams(
    regionId string,
    instanceId int,
    webRuleSpec *ipanti.WebRuleSpec,
) *CreateWebRuleRequest {

    return &CreateWebRuleRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}/webRules",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        InstanceId: instanceId,
        WebRuleSpec: webRuleSpec,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCreateWebRuleRequestWithoutParam() *CreateWebRuleRequest {

    return &CreateWebRuleRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}/webRules",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 区域 Id(Required) */
func (r *CreateWebRuleRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param instanceId: 高防实例 Id(Required) */
func (r *CreateWebRuleRequest) SetInstanceId(instanceId int) {
    r.InstanceId = instanceId
}

/* param webRuleSpec: 添加网站类规则请求参数(Required) */
func (r *CreateWebRuleRequest) SetWebRuleSpec(webRuleSpec *ipanti.WebRuleSpec) {
    r.WebRuleSpec = webRuleSpec
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CreateWebRuleRequest) GetRegionId() string {
    return r.RegionId
}

type CreateWebRuleResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CreateWebRuleResult `json:"result"`
}

type CreateWebRuleResult struct {
    Code int `json:"code"`
    Message string `json:"message"`
}