// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    ipanti "github.com/jdcloud-api/jdcloud-sdk-go/services/ipanti/models"
)

type DescribeCCAttackLogDetailsRequest struct {

    core.JDCloudRequest

    /* 区域 Id  */
    RegionId string `json:"regionId"`

    /* 页码, 默认为1 (Optional) */
    PageNumber *int `json:"pageNumber"`

    /* 分页大小, 默认为10, 取值范围[10, 100] (Optional) */
    PageSize *int `json:"pageSize"`

    /* 开始时间, 只能查询最近 60 天以内的数据, UTC 时间, 格式: yyyy-MM-dd'T'HH:mm:ssZ  */
    StartTime string `json:"startTime"`

    /* 查询的结束时间, UTC 时间, 格式: yyyy-MM-dd'T'HH:mm:ssZ  */
    EndTime string `json:"endTime"`

    /* 高防实例 ID  */
    InstanceId int `json:"instanceId"`

    /* 子域名 (Optional) */
    SubDomain []string `json:"subDomain"`
}

/*
 * param regionId: 区域 Id (Required)
 * param startTime: 开始时间, 只能查询最近 60 天以内的数据, UTC 时间, 格式: yyyy-MM-dd'T'HH:mm:ssZ (Required)
 * param endTime: 查询的结束时间, UTC 时间, 格式: yyyy-MM-dd'T'HH:mm:ssZ (Required)
 * param instanceId: 高防实例 ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeCCAttackLogDetailsRequest(
    regionId string,
    startTime string,
    endTime string,
    instanceId int,
) *DescribeCCAttackLogDetailsRequest {

	return &DescribeCCAttackLogDetailsRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/attacklog:CCDetail",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        StartTime: startTime,
        EndTime: endTime,
        InstanceId: instanceId,
	}
}

/*
 * param regionId: 区域 Id (Required)
 * param pageNumber: 页码, 默认为1 (Optional)
 * param pageSize: 分页大小, 默认为10, 取值范围[10, 100] (Optional)
 * param startTime: 开始时间, 只能查询最近 60 天以内的数据, UTC 时间, 格式: yyyy-MM-dd'T'HH:mm:ssZ (Required)
 * param endTime: 查询的结束时间, UTC 时间, 格式: yyyy-MM-dd'T'HH:mm:ssZ (Required)
 * param instanceId: 高防实例 ID (Required)
 * param subDomain: 子域名 (Optional)
 */
func NewDescribeCCAttackLogDetailsRequestWithAllParams(
    regionId string,
    pageNumber *int,
    pageSize *int,
    startTime string,
    endTime string,
    instanceId int,
    subDomain []string,
) *DescribeCCAttackLogDetailsRequest {

    return &DescribeCCAttackLogDetailsRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/attacklog:CCDetail",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        PageNumber: pageNumber,
        PageSize: pageSize,
        StartTime: startTime,
        EndTime: endTime,
        InstanceId: instanceId,
        SubDomain: subDomain,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeCCAttackLogDetailsRequestWithoutParam() *DescribeCCAttackLogDetailsRequest {

    return &DescribeCCAttackLogDetailsRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/attacklog:CCDetail",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 区域 Id(Required) */
func (r *DescribeCCAttackLogDetailsRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param pageNumber: 页码, 默认为1(Optional) */
func (r *DescribeCCAttackLogDetailsRequest) SetPageNumber(pageNumber int) {
    r.PageNumber = &pageNumber
}

/* param pageSize: 分页大小, 默认为10, 取值范围[10, 100](Optional) */
func (r *DescribeCCAttackLogDetailsRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

/* param startTime: 开始时间, 只能查询最近 60 天以内的数据, UTC 时间, 格式: yyyy-MM-dd'T'HH:mm:ssZ(Required) */
func (r *DescribeCCAttackLogDetailsRequest) SetStartTime(startTime string) {
    r.StartTime = startTime
}

/* param endTime: 查询的结束时间, UTC 时间, 格式: yyyy-MM-dd'T'HH:mm:ssZ(Required) */
func (r *DescribeCCAttackLogDetailsRequest) SetEndTime(endTime string) {
    r.EndTime = endTime
}

/* param instanceId: 高防实例 ID(Required) */
func (r *DescribeCCAttackLogDetailsRequest) SetInstanceId(instanceId int) {
    r.InstanceId = instanceId
}

/* param subDomain: 子域名(Optional) */
func (r *DescribeCCAttackLogDetailsRequest) SetSubDomain(subDomain []string) {
    r.SubDomain = subDomain
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeCCAttackLogDetailsRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeCCAttackLogDetailsResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeCCAttackLogDetailsResult `json:"result"`
}

type DescribeCCAttackLogDetailsResult struct {
    DataList []ipanti.CCAttackLogDetail `json:"dataList"`
    CurrentCount int `json:"currentCount"`
    TotalCount int `json:"totalCount"`
    TotalPage int `json:"totalPage"`
}