// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    ipanti "github.com/jdcloud-api/jdcloud-sdk-go/services/ipanti/models"
)

type ModifyCertInfoRequest struct {

    core.JDCloudRequest

    /* 区域 Id  */
    RegionId string `json:"regionId"`

    /* 高防实例 Id  */
    InstanceId int `json:"instanceId"`

    /* 网站规则 Id  */
    WebRuleId int `json:"webRuleId"`

    /* 编辑网站规则证书信息请求参数  */
    CertInfoModifySpec *ipanti.CertInfoModifySpec `json:"certInfoModifySpec"`
}

/*
 * param regionId: 区域 Id (Required)
 * param instanceId: 高防实例 Id (Required)
 * param webRuleId: 网站规则 Id (Required)
 * param certInfoModifySpec: 编辑网站规则证书信息请求参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewModifyCertInfoRequest(
    regionId string,
    instanceId int,
    webRuleId int,
    certInfoModifySpec *ipanti.CertInfoModifySpec,
) *ModifyCertInfoRequest {

	return &ModifyCertInfoRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/instances/{instanceId}/webRules/{webRuleId}:modifyCertInfo",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        InstanceId: instanceId,
        WebRuleId: webRuleId,
        CertInfoModifySpec: certInfoModifySpec,
	}
}

/*
 * param regionId: 区域 Id (Required)
 * param instanceId: 高防实例 Id (Required)
 * param webRuleId: 网站规则 Id (Required)
 * param certInfoModifySpec: 编辑网站规则证书信息请求参数 (Required)
 */
func NewModifyCertInfoRequestWithAllParams(
    regionId string,
    instanceId int,
    webRuleId int,
    certInfoModifySpec *ipanti.CertInfoModifySpec,
) *ModifyCertInfoRequest {

    return &ModifyCertInfoRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}/webRules/{webRuleId}:modifyCertInfo",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        InstanceId: instanceId,
        WebRuleId: webRuleId,
        CertInfoModifySpec: certInfoModifySpec,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewModifyCertInfoRequestWithoutParam() *ModifyCertInfoRequest {

    return &ModifyCertInfoRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}/webRules/{webRuleId}:modifyCertInfo",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 区域 Id(Required) */
func (r *ModifyCertInfoRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param instanceId: 高防实例 Id(Required) */
func (r *ModifyCertInfoRequest) SetInstanceId(instanceId int) {
    r.InstanceId = instanceId
}

/* param webRuleId: 网站规则 Id(Required) */
func (r *ModifyCertInfoRequest) SetWebRuleId(webRuleId int) {
    r.WebRuleId = webRuleId
}

/* param certInfoModifySpec: 编辑网站规则证书信息请求参数(Required) */
func (r *ModifyCertInfoRequest) SetCertInfoModifySpec(certInfoModifySpec *ipanti.CertInfoModifySpec) {
    r.CertInfoModifySpec = certInfoModifySpec
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ModifyCertInfoRequest) GetRegionId() string {
    return r.RegionId
}

type ModifyCertInfoResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ModifyCertInfoResult `json:"result"`
}

type ModifyCertInfoResult struct {
    Code int `json:"code"`
    Message string `json:"message"`
}