// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    ipanti "github.com/jdcloud-api/jdcloud-sdk-go/services/ipanti/models"
)

type ModifyEPBRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 实例 ID  */
    InstanceId int `json:"instanceId"`

    /* 修改实例名称请求参数  */
    ModifyInstanceEPBSpec *ipanti.ModifyInstanceEPBSpec `json:"modifyInstanceEPBSpec"`
}

/*
 * param regionId: Region ID (Required)
 * param instanceId: 实例 ID (Required)
 * param modifyInstanceEPBSpec: 修改实例名称请求参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewModifyEPBRequest(
    regionId string,
    instanceId int,
    modifyInstanceEPBSpec *ipanti.ModifyInstanceEPBSpec,
) *ModifyEPBRequest {

	return &ModifyEPBRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/instances/{instanceId}:modifyEPB",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        InstanceId: instanceId,
        ModifyInstanceEPBSpec: modifyInstanceEPBSpec,
	}
}

/*
 * param regionId: Region ID (Required)
 * param instanceId: 实例 ID (Required)
 * param modifyInstanceEPBSpec: 修改实例名称请求参数 (Required)
 */
func NewModifyEPBRequestWithAllParams(
    regionId string,
    instanceId int,
    modifyInstanceEPBSpec *ipanti.ModifyInstanceEPBSpec,
) *ModifyEPBRequest {

    return &ModifyEPBRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}:modifyEPB",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        InstanceId: instanceId,
        ModifyInstanceEPBSpec: modifyInstanceEPBSpec,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewModifyEPBRequestWithoutParam() *ModifyEPBRequest {

    return &ModifyEPBRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}:modifyEPB",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *ModifyEPBRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param instanceId: 实例 ID(Required) */
func (r *ModifyEPBRequest) SetInstanceId(instanceId int) {
    r.InstanceId = instanceId
}

/* param modifyInstanceEPBSpec: 修改实例名称请求参数(Required) */
func (r *ModifyEPBRequest) SetModifyInstanceEPBSpec(modifyInstanceEPBSpec *ipanti.ModifyInstanceEPBSpec) {
    r.ModifyInstanceEPBSpec = modifyInstanceEPBSpec
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ModifyEPBRequest) GetRegionId() string {
    return r.RegionId
}

type ModifyEPBResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ModifyEPBResult `json:"result"`
}

type ModifyEPBResult struct {
    Code int `json:"code"`
    Message string `json:"message"`
}