// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    ipanti "github.com/jdcloud-api/jdcloud-sdk-go/services/ipanti/models"
)

type ModifyInstanceCCRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 实例 ID  */
    InstanceId int `json:"instanceId"`

    /* CC 参数  */
    CCSpec *ipanti.CCSpec `json:"cCSpec"`
}

/*
 * param regionId: Region ID (Required)
 * param instanceId: 实例 ID (Required)
 * param cCSpec: CC 参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewModifyInstanceCCRequest(
    regionId string,
    instanceId int,
    cCSpec *ipanti.CCSpec,
) *ModifyInstanceCCRequest {

	return &ModifyInstanceCCRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/instances/{instanceId}:setCC",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        InstanceId: instanceId,
        CCSpec: cCSpec,
	}
}

/*
 * param regionId: Region ID (Required)
 * param instanceId: 实例 ID (Required)
 * param cCSpec: CC 参数 (Required)
 */
func NewModifyInstanceCCRequestWithAllParams(
    regionId string,
    instanceId int,
    cCSpec *ipanti.CCSpec,
) *ModifyInstanceCCRequest {

    return &ModifyInstanceCCRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}:setCC",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        InstanceId: instanceId,
        CCSpec: cCSpec,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewModifyInstanceCCRequestWithoutParam() *ModifyInstanceCCRequest {

    return &ModifyInstanceCCRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}:setCC",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *ModifyInstanceCCRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param instanceId: 实例 ID(Required) */
func (r *ModifyInstanceCCRequest) SetInstanceId(instanceId int) {
    r.InstanceId = instanceId
}

/* param cCSpec: CC 参数(Required) */
func (r *ModifyInstanceCCRequest) SetCCSpec(cCSpec *ipanti.CCSpec) {
    r.CCSpec = cCSpec
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ModifyInstanceCCRequest) GetRegionId() string {
    return r.RegionId
}

type ModifyInstanceCCResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ModifyInstanceCCResult `json:"result"`
}

type ModifyInstanceCCResult struct {
    Code int `json:"code"`
    Message string `json:"message"`
}