// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    ipanti "github.com/jdcloud-api/jdcloud-sdk-go/services/ipanti/models"
)

type ModifyInstanceIpWhiteListRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 实例 ID  */
    InstanceId int `json:"instanceId"`

    /* 设置 IP 白名单请求参数  */
    IpBwListSpec *ipanti.IpBwListSpec `json:"ipBwListSpec"`
}

/*
 * param regionId: Region ID (Required)
 * param instanceId: 实例 ID (Required)
 * param ipBwListSpec: 设置 IP 白名单请求参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewModifyInstanceIpWhiteListRequest(
    regionId string,
    instanceId int,
    ipBwListSpec *ipanti.IpBwListSpec,
) *ModifyInstanceIpWhiteListRequest {

	return &ModifyInstanceIpWhiteListRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/instances/{instanceId}:setIpWhiteList",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        InstanceId: instanceId,
        IpBwListSpec: ipBwListSpec,
	}
}

/*
 * param regionId: Region ID (Required)
 * param instanceId: 实例 ID (Required)
 * param ipBwListSpec: 设置 IP 白名单请求参数 (Required)
 */
func NewModifyInstanceIpWhiteListRequestWithAllParams(
    regionId string,
    instanceId int,
    ipBwListSpec *ipanti.IpBwListSpec,
) *ModifyInstanceIpWhiteListRequest {

    return &ModifyInstanceIpWhiteListRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}:setIpWhiteList",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        InstanceId: instanceId,
        IpBwListSpec: ipBwListSpec,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewModifyInstanceIpWhiteListRequestWithoutParam() *ModifyInstanceIpWhiteListRequest {

    return &ModifyInstanceIpWhiteListRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}:setIpWhiteList",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *ModifyInstanceIpWhiteListRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param instanceId: 实例 ID(Required) */
func (r *ModifyInstanceIpWhiteListRequest) SetInstanceId(instanceId int) {
    r.InstanceId = instanceId
}

/* param ipBwListSpec: 设置 IP 白名单请求参数(Required) */
func (r *ModifyInstanceIpWhiteListRequest) SetIpBwListSpec(ipBwListSpec *ipanti.IpBwListSpec) {
    r.IpBwListSpec = ipBwListSpec
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ModifyInstanceIpWhiteListRequest) GetRegionId() string {
    return r.RegionId
}

type ModifyInstanceIpWhiteListResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ModifyInstanceIpWhiteListResult `json:"result"`
}

type ModifyInstanceIpWhiteListResult struct {
    Code int `json:"code"`
    Message string `json:"message"`
}