// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type ModifyInstanceUrlWhiteListRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 实例 ID  */
    InstanceId int `json:"instanceId"`

    /* 网站类规则参数  */
    UrlWhiteList []string `json:"urlWhiteList"`
}

/*
 * param regionId: Region ID (Required)
 * param instanceId: 实例 ID (Required)
 * param urlWhiteList: 网站类规则参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewModifyInstanceUrlWhiteListRequest(
    regionId string,
    instanceId int,
    urlWhiteList []string,
) *ModifyInstanceUrlWhiteListRequest {

	return &ModifyInstanceUrlWhiteListRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/instances/{instanceId}:setUrlWhiteList",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        InstanceId: instanceId,
        UrlWhiteList: urlWhiteList,
	}
}

/*
 * param regionId: Region ID (Required)
 * param instanceId: 实例 ID (Required)
 * param urlWhiteList: 网站类规则参数 (Required)
 */
func NewModifyInstanceUrlWhiteListRequestWithAllParams(
    regionId string,
    instanceId int,
    urlWhiteList []string,
) *ModifyInstanceUrlWhiteListRequest {

    return &ModifyInstanceUrlWhiteListRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}:setUrlWhiteList",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        InstanceId: instanceId,
        UrlWhiteList: urlWhiteList,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewModifyInstanceUrlWhiteListRequestWithoutParam() *ModifyInstanceUrlWhiteListRequest {

    return &ModifyInstanceUrlWhiteListRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}:setUrlWhiteList",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *ModifyInstanceUrlWhiteListRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param instanceId: 实例 ID(Required) */
func (r *ModifyInstanceUrlWhiteListRequest) SetInstanceId(instanceId int) {
    r.InstanceId = instanceId
}

/* param urlWhiteList: 网站类规则参数(Required) */
func (r *ModifyInstanceUrlWhiteListRequest) SetUrlWhiteList(urlWhiteList []string) {
    r.UrlWhiteList = urlWhiteList
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ModifyInstanceUrlWhiteListRequest) GetRegionId() string {
    return r.RegionId
}

type ModifyInstanceUrlWhiteListResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ModifyInstanceUrlWhiteListResult `json:"result"`
}

type ModifyInstanceUrlWhiteListResult struct {
    Code int `json:"code"`
    Message string `json:"message"`
}