// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    ipanti "github.com/jdcloud-api/jdcloud-sdk-go/services/ipanti/models"
)

type ModifyProtectionRuleOfForwardRuleRequest struct {

    core.JDCloudRequest

    /* 区域 Id  */
    RegionId string `json:"regionId"`

    /* 高防实例 Id  */
    InstanceId int `json:"instanceId"`

    /* 转发规则 Id  */
    ForwardRuleId int `json:"forwardRuleId"`

    /* 修改非网站类转发规则的防护规则请求参数  */
    ForwardProtectionRuleSpec *ipanti.ForwardProtectionRuleSpec `json:"forwardProtectionRuleSpec"`
}

/*
 * param regionId: 区域 Id (Required)
 * param instanceId: 高防实例 Id (Required)
 * param forwardRuleId: 转发规则 Id (Required)
 * param forwardProtectionRuleSpec: 修改非网站类转发规则的防护规则请求参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewModifyProtectionRuleOfForwardRuleRequest(
    regionId string,
    instanceId int,
    forwardRuleId int,
    forwardProtectionRuleSpec *ipanti.ForwardProtectionRuleSpec,
) *ModifyProtectionRuleOfForwardRuleRequest {

	return &ModifyProtectionRuleOfForwardRuleRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/instances/{instanceId}/forwardRules/{forwardRuleId}:modifyProtectionRule",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        InstanceId: instanceId,
        ForwardRuleId: forwardRuleId,
        ForwardProtectionRuleSpec: forwardProtectionRuleSpec,
	}
}

/*
 * param regionId: 区域 Id (Required)
 * param instanceId: 高防实例 Id (Required)
 * param forwardRuleId: 转发规则 Id (Required)
 * param forwardProtectionRuleSpec: 修改非网站类转发规则的防护规则请求参数 (Required)
 */
func NewModifyProtectionRuleOfForwardRuleRequestWithAllParams(
    regionId string,
    instanceId int,
    forwardRuleId int,
    forwardProtectionRuleSpec *ipanti.ForwardProtectionRuleSpec,
) *ModifyProtectionRuleOfForwardRuleRequest {

    return &ModifyProtectionRuleOfForwardRuleRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}/forwardRules/{forwardRuleId}:modifyProtectionRule",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        InstanceId: instanceId,
        ForwardRuleId: forwardRuleId,
        ForwardProtectionRuleSpec: forwardProtectionRuleSpec,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewModifyProtectionRuleOfForwardRuleRequestWithoutParam() *ModifyProtectionRuleOfForwardRuleRequest {

    return &ModifyProtectionRuleOfForwardRuleRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}/forwardRules/{forwardRuleId}:modifyProtectionRule",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 区域 Id(Required) */
func (r *ModifyProtectionRuleOfForwardRuleRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param instanceId: 高防实例 Id(Required) */
func (r *ModifyProtectionRuleOfForwardRuleRequest) SetInstanceId(instanceId int) {
    r.InstanceId = instanceId
}

/* param forwardRuleId: 转发规则 Id(Required) */
func (r *ModifyProtectionRuleOfForwardRuleRequest) SetForwardRuleId(forwardRuleId int) {
    r.ForwardRuleId = forwardRuleId
}

/* param forwardProtectionRuleSpec: 修改非网站类转发规则的防护规则请求参数(Required) */
func (r *ModifyProtectionRuleOfForwardRuleRequest) SetForwardProtectionRuleSpec(forwardProtectionRuleSpec *ipanti.ForwardProtectionRuleSpec) {
    r.ForwardProtectionRuleSpec = forwardProtectionRuleSpec
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ModifyProtectionRuleOfForwardRuleRequest) GetRegionId() string {
    return r.RegionId
}

type ModifyProtectionRuleOfForwardRuleResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ModifyProtectionRuleOfForwardRuleResult `json:"result"`
}

type ModifyProtectionRuleOfForwardRuleResult struct {
    Code int `json:"code"`
    Message string `json:"message"`
}