// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DescribeConsumerGroupIdsRequest struct {

    core.JDCloudRequest

    /* 所在区域的Region ID  */
    RegionId string `json:"regionId"`
}

/*
 * param regionId: 所在区域的Region ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeConsumerGroupIdsRequest(
    regionId string,
) *DescribeConsumerGroupIdsRequest {

	return &DescribeConsumerGroupIdsRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/consumerGroupIds",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
	}
}

/*
 * param regionId: 所在区域的Region ID (Required)
 */
func NewDescribeConsumerGroupIdsRequestWithAllParams(
    regionId string,
) *DescribeConsumerGroupIdsRequest {

    return &DescribeConsumerGroupIdsRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/consumerGroupIds",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeConsumerGroupIdsRequestWithoutParam() *DescribeConsumerGroupIdsRequest {

    return &DescribeConsumerGroupIdsRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/consumerGroupIds",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 所在区域的Region ID(Required) */
func (r *DescribeConsumerGroupIdsRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeConsumerGroupIdsRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeConsumerGroupIdsResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeConsumerGroupIdsResult `json:"result"`
}

type DescribeConsumerGroupIdsResult struct {
    ConsumerGroupIds []string `json:"consumerGroupIds"`
}