// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jcq "github.com/jdcloud-api/jdcloud-sdk-go/services/jcq/models"
)

type DescribeDeadLetterNumbersWithTopicRequest struct {

    core.JDCloudRequest

    /* 所在区域的Region ID  */
    RegionId string `json:"regionId"`

    /* topic 名称  */
    TopicName string `json:"topicName"`

    /* consumerGroupId为空则显示该Topic下所有订阅关系里的死信数量 (Optional) */
    ConsumerGroupId *string `json:"consumerGroupId"`

    /* 页码 (Optional) */
    PageNumber *int `json:"pageNumber"`

    /* 每页数 (Optional) */
    PageSize *int `json:"pageSize"`
}

/*
 * param regionId: 所在区域的Region ID (Required)
 * param topicName: topic 名称 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeDeadLetterNumbersWithTopicRequest(
    regionId string,
    topicName string,
) *DescribeDeadLetterNumbersWithTopicRequest {

	return &DescribeDeadLetterNumbersWithTopicRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/topics/{topicName}/deadLetterNumbers",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        TopicName: topicName,
	}
}

/*
 * param regionId: 所在区域的Region ID (Required)
 * param topicName: topic 名称 (Required)
 * param consumerGroupId: consumerGroupId为空则显示该Topic下所有订阅关系里的死信数量 (Optional)
 * param pageNumber: 页码 (Optional)
 * param pageSize: 每页数 (Optional)
 */
func NewDescribeDeadLetterNumbersWithTopicRequestWithAllParams(
    regionId string,
    topicName string,
    consumerGroupId *string,
    pageNumber *int,
    pageSize *int,
) *DescribeDeadLetterNumbersWithTopicRequest {

    return &DescribeDeadLetterNumbersWithTopicRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/topics/{topicName}/deadLetterNumbers",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        TopicName: topicName,
        ConsumerGroupId: consumerGroupId,
        PageNumber: pageNumber,
        PageSize: pageSize,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeDeadLetterNumbersWithTopicRequestWithoutParam() *DescribeDeadLetterNumbersWithTopicRequest {

    return &DescribeDeadLetterNumbersWithTopicRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/topics/{topicName}/deadLetterNumbers",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 所在区域的Region ID(Required) */
func (r *DescribeDeadLetterNumbersWithTopicRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param topicName: topic 名称(Required) */
func (r *DescribeDeadLetterNumbersWithTopicRequest) SetTopicName(topicName string) {
    r.TopicName = topicName
}

/* param consumerGroupId: consumerGroupId为空则显示该Topic下所有订阅关系里的死信数量(Optional) */
func (r *DescribeDeadLetterNumbersWithTopicRequest) SetConsumerGroupId(consumerGroupId string) {
    r.ConsumerGroupId = &consumerGroupId
}

/* param pageNumber: 页码(Optional) */
func (r *DescribeDeadLetterNumbersWithTopicRequest) SetPageNumber(pageNumber int) {
    r.PageNumber = &pageNumber
}

/* param pageSize: 每页数(Optional) */
func (r *DescribeDeadLetterNumbersWithTopicRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeDeadLetterNumbersWithTopicRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeDeadLetterNumbersWithTopicResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeDeadLetterNumbersWithTopicResult `json:"result"`
}

type DescribeDeadLetterNumbersWithTopicResult struct {
    DeadLetterNumbers []jcq.DeadLetterNumber `json:"deadLetterNumbers"`
    TotalCount int `json:"totalCount"`
}