// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jcq "github.com/jdcloud-api/jdcloud-sdk-go/services/jcq/models"
)

type DescribeMessageRequest struct {

    core.JDCloudRequest

    /* 所在区域的Region ID  */
    RegionId string `json:"regionId"`

    /* topic 名称  */
    TopicName string `json:"topicName"`

    /* message Id  */
    MessageId string `json:"messageId"`
}

/*
 * param regionId: 所在区域的Region ID (Required)
 * param topicName: topic 名称 (Required)
 * param messageId: message Id (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeMessageRequest(
    regionId string,
    topicName string,
    messageId string,
) *DescribeMessageRequest {

	return &DescribeMessageRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/topics/{topicName}/messages/{messageId}",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        TopicName: topicName,
        MessageId: messageId,
	}
}

/*
 * param regionId: 所在区域的Region ID (Required)
 * param topicName: topic 名称 (Required)
 * param messageId: message Id (Required)
 */
func NewDescribeMessageRequestWithAllParams(
    regionId string,
    topicName string,
    messageId string,
) *DescribeMessageRequest {

    return &DescribeMessageRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/topics/{topicName}/messages/{messageId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        TopicName: topicName,
        MessageId: messageId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeMessageRequestWithoutParam() *DescribeMessageRequest {

    return &DescribeMessageRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/topics/{topicName}/messages/{messageId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 所在区域的Region ID(Required) */
func (r *DescribeMessageRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param topicName: topic 名称(Required) */
func (r *DescribeMessageRequest) SetTopicName(topicName string) {
    r.TopicName = topicName
}

/* param messageId: message Id(Required) */
func (r *DescribeMessageRequest) SetMessageId(messageId string) {
    r.MessageId = messageId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeMessageRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeMessageResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeMessageResult `json:"result"`
}

type DescribeMessageResult struct {
    Message jcq.Message `json:"message"`
}