// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jcq "github.com/jdcloud-api/jdcloud-sdk-go/services/jcq/models"
)

type ListDeadLettersRequest struct {

    core.JDCloudRequest

    /* 所在区域的Region ID  */
    RegionId string `json:"regionId"`

    /* topic 名称  */
    TopicName string `json:"topicName"`

    /* consumerGroupId  */
    ConsumerGroupId string `json:"consumerGroupId"`

    /* 页码；默认为1 (Optional) */
    PageNumber *int `json:"pageNumber"`

    /* 分页大小；默认为20；取值范围[10, 100] (Optional) */
    PageSize *int `json:"pageSize"`

    /* 开始时间  */
    StartTime string `json:"startTime"`

    /* 结束时间  */
    EndTime string `json:"endTime"`
}

/*
 * param regionId: 所在区域的Region ID (Required)
 * param topicName: topic 名称 (Required)
 * param consumerGroupId: consumerGroupId (Required)
 * param startTime: 开始时间 (Required)
 * param endTime: 结束时间 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewListDeadLettersRequest(
    regionId string,
    topicName string,
    consumerGroupId string,
    startTime string,
    endTime string,
) *ListDeadLettersRequest {

	return &ListDeadLettersRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/topics/{topicName}/subscriptions/{consumerGroupId}:listDeadLetters",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        TopicName: topicName,
        ConsumerGroupId: consumerGroupId,
        StartTime: startTime,
        EndTime: endTime,
	}
}

/*
 * param regionId: 所在区域的Region ID (Required)
 * param topicName: topic 名称 (Required)
 * param consumerGroupId: consumerGroupId (Required)
 * param pageNumber: 页码；默认为1 (Optional)
 * param pageSize: 分页大小；默认为20；取值范围[10, 100] (Optional)
 * param startTime: 开始时间 (Required)
 * param endTime: 结束时间 (Required)
 */
func NewListDeadLettersRequestWithAllParams(
    regionId string,
    topicName string,
    consumerGroupId string,
    pageNumber *int,
    pageSize *int,
    startTime string,
    endTime string,
) *ListDeadLettersRequest {

    return &ListDeadLettersRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/topics/{topicName}/subscriptions/{consumerGroupId}:listDeadLetters",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        TopicName: topicName,
        ConsumerGroupId: consumerGroupId,
        PageNumber: pageNumber,
        PageSize: pageSize,
        StartTime: startTime,
        EndTime: endTime,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewListDeadLettersRequestWithoutParam() *ListDeadLettersRequest {

    return &ListDeadLettersRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/topics/{topicName}/subscriptions/{consumerGroupId}:listDeadLetters",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 所在区域的Region ID(Required) */
func (r *ListDeadLettersRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param topicName: topic 名称(Required) */
func (r *ListDeadLettersRequest) SetTopicName(topicName string) {
    r.TopicName = topicName
}

/* param consumerGroupId: consumerGroupId(Required) */
func (r *ListDeadLettersRequest) SetConsumerGroupId(consumerGroupId string) {
    r.ConsumerGroupId = consumerGroupId
}

/* param pageNumber: 页码；默认为1(Optional) */
func (r *ListDeadLettersRequest) SetPageNumber(pageNumber int) {
    r.PageNumber = &pageNumber
}

/* param pageSize: 分页大小；默认为20；取值范围[10, 100](Optional) */
func (r *ListDeadLettersRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

/* param startTime: 开始时间(Required) */
func (r *ListDeadLettersRequest) SetStartTime(startTime string) {
    r.StartTime = startTime
}

/* param endTime: 结束时间(Required) */
func (r *ListDeadLettersRequest) SetEndTime(endTime string) {
    r.EndTime = endTime
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ListDeadLettersRequest) GetRegionId() string {
    return r.RegionId
}

type ListDeadLettersResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ListDeadLettersResult `json:"result"`
}

type ListDeadLettersResult struct {
    DeadLetters []jcq.DeadLetter `json:"deadLetters"`
    TotalCount int `json:"totalCount"`
}