// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type ResetConsumeOffsetRequest struct {

    core.JDCloudRequest

    /* 所在区域的Region ID  */
    RegionId string `json:"regionId"`

    /* topic 名称  */
    TopicName string `json:"topicName"`

    /* consumerGroupId  */
    ConsumerGroupId string `json:"consumerGroupId"`

    /* 时间  */
    Time string `json:"time"`
}

/*
 * param regionId: 所在区域的Region ID (Required)
 * param topicName: topic 名称 (Required)
 * param consumerGroupId: consumerGroupId (Required)
 * param time: 时间 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewResetConsumeOffsetRequest(
    regionId string,
    topicName string,
    consumerGroupId string,
    time string,
) *ResetConsumeOffsetRequest {

	return &ResetConsumeOffsetRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/topics/{topicName}/subscriptions/{consumerGroupId}:resetConsumeOffset",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        TopicName: topicName,
        ConsumerGroupId: consumerGroupId,
        Time: time,
	}
}

/*
 * param regionId: 所在区域的Region ID (Required)
 * param topicName: topic 名称 (Required)
 * param consumerGroupId: consumerGroupId (Required)
 * param time: 时间 (Required)
 */
func NewResetConsumeOffsetRequestWithAllParams(
    regionId string,
    topicName string,
    consumerGroupId string,
    time string,
) *ResetConsumeOffsetRequest {

    return &ResetConsumeOffsetRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/topics/{topicName}/subscriptions/{consumerGroupId}:resetConsumeOffset",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        TopicName: topicName,
        ConsumerGroupId: consumerGroupId,
        Time: time,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewResetConsumeOffsetRequestWithoutParam() *ResetConsumeOffsetRequest {

    return &ResetConsumeOffsetRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/topics/{topicName}/subscriptions/{consumerGroupId}:resetConsumeOffset",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 所在区域的Region ID(Required) */
func (r *ResetConsumeOffsetRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param topicName: topic 名称(Required) */
func (r *ResetConsumeOffsetRequest) SetTopicName(topicName string) {
    r.TopicName = topicName
}

/* param consumerGroupId: consumerGroupId(Required) */
func (r *ResetConsumeOffsetRequest) SetConsumerGroupId(consumerGroupId string) {
    r.ConsumerGroupId = consumerGroupId
}

/* param time: 时间(Required) */
func (r *ResetConsumeOffsetRequest) SetTime(time string) {
    r.Time = time
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ResetConsumeOffsetRequest) GetRegionId() string {
    return r.RegionId
}

type ResetConsumeOffsetResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ResetConsumeOffsetResult `json:"result"`
}

type ResetConsumeOffsetResult struct {
}