// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type ApplyDeploymentRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* Deployment ID  */
    Id string `json:"id"`

    /* 应用部署  */
    Apply *jdfusion.Apply `json:"apply"`
}

/*
 * param regionId: 地域ID (Required)
 * param id: Deployment ID (Required)
 * param apply: 应用部署 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewApplyDeploymentRequest(
    regionId string,
    id string,
    apply *jdfusion.Apply,
) *ApplyDeploymentRequest {

	return &ApplyDeploymentRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/deployments/{id}:apply",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Id: id,
        Apply: apply,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param id: Deployment ID (Required)
 * param apply: 应用部署 (Required)
 */
func NewApplyDeploymentRequestWithAllParams(
    regionId string,
    id string,
    apply *jdfusion.Apply,
) *ApplyDeploymentRequest {

    return &ApplyDeploymentRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/deployments/{id}:apply",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Id: id,
        Apply: apply,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewApplyDeploymentRequestWithoutParam() *ApplyDeploymentRequest {

    return &ApplyDeploymentRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/deployments/{id}:apply",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *ApplyDeploymentRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param id: Deployment ID(Required) */
func (r *ApplyDeploymentRequest) SetId(id string) {
    r.Id = id
}

/* param apply: 应用部署(Required) */
func (r *ApplyDeploymentRequest) SetApply(apply *jdfusion.Apply) {
    r.Apply = apply
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ApplyDeploymentRequest) GetRegionId() string {
    return r.RegionId
}

type ApplyDeploymentResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ApplyDeploymentResult `json:"result"`
}

type ApplyDeploymentResult struct {
    Deployment jdfusion.DeploymentInfo `json:"deployment"`
}