// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type AssociateVpcEipByIdRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 公网IP ID  */
    Id string `json:"id"`

    /* 弹性公网IP绑定到虚拟机  */
    Associate *jdfusion.AssociateEipAddress `json:"associate"`
}

/*
 * param regionId: 地域ID (Required)
 * param id: 公网IP ID (Required)
 * param associate: 弹性公网IP绑定到虚拟机 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewAssociateVpcEipByIdRequest(
    regionId string,
    id string,
    associate *jdfusion.AssociateEipAddress,
) *AssociateVpcEipByIdRequest {

	return &AssociateVpcEipByIdRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/vpc_eips/{id}:associate",
			Method:  "PUT",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Id: id,
        Associate: associate,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param id: 公网IP ID (Required)
 * param associate: 弹性公网IP绑定到虚拟机 (Required)
 */
func NewAssociateVpcEipByIdRequestWithAllParams(
    regionId string,
    id string,
    associate *jdfusion.AssociateEipAddress,
) *AssociateVpcEipByIdRequest {

    return &AssociateVpcEipByIdRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/vpc_eips/{id}:associate",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Id: id,
        Associate: associate,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewAssociateVpcEipByIdRequestWithoutParam() *AssociateVpcEipByIdRequest {

    return &AssociateVpcEipByIdRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/vpc_eips/{id}:associate",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *AssociateVpcEipByIdRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param id: 公网IP ID(Required) */
func (r *AssociateVpcEipByIdRequest) SetId(id string) {
    r.Id = id
}

/* param associate: 弹性公网IP绑定到虚拟机(Required) */
func (r *AssociateVpcEipByIdRequest) SetAssociate(associate *jdfusion.AssociateEipAddress) {
    r.Associate = associate
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r AssociateVpcEipByIdRequest) GetRegionId() string {
    return r.RegionId
}

type AssociateVpcEipByIdResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result AssociateVpcEipByIdResult `json:"result"`
}

type AssociateVpcEipByIdResult struct {
    Task jdfusion.ResourceTFInfo `json:"task"`
}