// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type AttachDiskToVmInstanceByDiskIdRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 云硬盘 ID  */
    Id string `json:"id"`

    /* 云硬盘挂载至虚拟机  */
    Attach *jdfusion.AttachDataDisk `json:"attach"`
}

/*
 * param regionId: 地域ID (Required)
 * param id: 云硬盘 ID (Required)
 * param attach: 云硬盘挂载至虚拟机 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewAttachDiskToVmInstanceByDiskIdRequest(
    regionId string,
    id string,
    attach *jdfusion.AttachDataDisk,
) *AttachDiskToVmInstanceByDiskIdRequest {

	return &AttachDiskToVmInstanceByDiskIdRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/disk_disks/{id}:attach",
			Method:  "PUT",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Id: id,
        Attach: attach,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param id: 云硬盘 ID (Required)
 * param attach: 云硬盘挂载至虚拟机 (Required)
 */
func NewAttachDiskToVmInstanceByDiskIdRequestWithAllParams(
    regionId string,
    id string,
    attach *jdfusion.AttachDataDisk,
) *AttachDiskToVmInstanceByDiskIdRequest {

    return &AttachDiskToVmInstanceByDiskIdRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/disk_disks/{id}:attach",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Id: id,
        Attach: attach,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewAttachDiskToVmInstanceByDiskIdRequestWithoutParam() *AttachDiskToVmInstanceByDiskIdRequest {

    return &AttachDiskToVmInstanceByDiskIdRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/disk_disks/{id}:attach",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *AttachDiskToVmInstanceByDiskIdRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param id: 云硬盘 ID(Required) */
func (r *AttachDiskToVmInstanceByDiskIdRequest) SetId(id string) {
    r.Id = id
}

/* param attach: 云硬盘挂载至虚拟机(Required) */
func (r *AttachDiskToVmInstanceByDiskIdRequest) SetAttach(attach *jdfusion.AttachDataDisk) {
    r.Attach = attach
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r AttachDiskToVmInstanceByDiskIdRequest) GetRegionId() string {
    return r.RegionId
}

type AttachDiskToVmInstanceByDiskIdResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result AttachDiskToVmInstanceByDiskIdResult `json:"result"`
}

type AttachDiskToVmInstanceByDiskIdResult struct {
    Task jdfusion.ResourceTFInfo `json:"task"`
}