// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type AttachVpcNetworkInterfaceByIdRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 网卡 ID  */
    Id string `json:"id"`

    /* 网卡挂载虚拟机  */
    Attach *jdfusion.AttachNetInterface `json:"attach"`
}

/*
 * param regionId: 地域ID (Required)
 * param id: 网卡 ID (Required)
 * param attach: 网卡挂载虚拟机 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewAttachVpcNetworkInterfaceByIdRequest(
    regionId string,
    id string,
    attach *jdfusion.AttachNetInterface,
) *AttachVpcNetworkInterfaceByIdRequest {

	return &AttachVpcNetworkInterfaceByIdRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/vpc_networkInterfaces/{id}:attach",
			Method:  "PUT",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Id: id,
        Attach: attach,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param id: 网卡 ID (Required)
 * param attach: 网卡挂载虚拟机 (Required)
 */
func NewAttachVpcNetworkInterfaceByIdRequestWithAllParams(
    regionId string,
    id string,
    attach *jdfusion.AttachNetInterface,
) *AttachVpcNetworkInterfaceByIdRequest {

    return &AttachVpcNetworkInterfaceByIdRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/vpc_networkInterfaces/{id}:attach",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Id: id,
        Attach: attach,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewAttachVpcNetworkInterfaceByIdRequestWithoutParam() *AttachVpcNetworkInterfaceByIdRequest {

    return &AttachVpcNetworkInterfaceByIdRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/vpc_networkInterfaces/{id}:attach",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *AttachVpcNetworkInterfaceByIdRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param id: 网卡 ID(Required) */
func (r *AttachVpcNetworkInterfaceByIdRequest) SetId(id string) {
    r.Id = id
}

/* param attach: 网卡挂载虚拟机(Required) */
func (r *AttachVpcNetworkInterfaceByIdRequest) SetAttach(attach *jdfusion.AttachNetInterface) {
    r.Attach = attach
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r AttachVpcNetworkInterfaceByIdRequest) GetRegionId() string {
    return r.RegionId
}

type AttachVpcNetworkInterfaceByIdResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result AttachVpcNetworkInterfaceByIdResult `json:"result"`
}

type AttachVpcNetworkInterfaceByIdResult struct {
    Task jdfusion.ResourceTFInfo `json:"task"`
}