// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type CreateDeploymentRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 创建deployment  */
    Deployment *jdfusion.DeploymentInfo `json:"deployment"`
}

/*
 * param regionId: 地域ID (Required)
 * param deployment: 创建deployment (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCreateDeploymentRequest(
    regionId string,
    deployment *jdfusion.DeploymentInfo,
) *CreateDeploymentRequest {

	return &CreateDeploymentRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/deployments",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Deployment: deployment,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param deployment: 创建deployment (Required)
 */
func NewCreateDeploymentRequestWithAllParams(
    regionId string,
    deployment *jdfusion.DeploymentInfo,
) *CreateDeploymentRequest {

    return &CreateDeploymentRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/deployments",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Deployment: deployment,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCreateDeploymentRequestWithoutParam() *CreateDeploymentRequest {

    return &CreateDeploymentRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/deployments",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *CreateDeploymentRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param deployment: 创建deployment(Required) */
func (r *CreateDeploymentRequest) SetDeployment(deployment *jdfusion.DeploymentInfo) {
    r.Deployment = deployment
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CreateDeploymentRequest) GetRegionId() string {
    return r.RegionId
}

type CreateDeploymentResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CreateDeploymentResult `json:"result"`
}

type CreateDeploymentResult struct {
    Deployment jdfusion.DeploymentInfo `json:"deployment"`
}