// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type CreateRdsAccountsRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* RDS实例ID  */
    InstId string `json:"instId"`

    /* 创建RDS实例的账号信息  */
    Account *jdfusion.CreateRDSAccount `json:"account"`
}

/*
 * param regionId: 地域ID (Required)
 * param instId: RDS实例ID (Required)
 * param account: 创建RDS实例的账号信息 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCreateRdsAccountsRequest(
    regionId string,
    instId string,
    account *jdfusion.CreateRDSAccount,
) *CreateRdsAccountsRequest {

	return &CreateRdsAccountsRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/rds_instances/{instId}/accounts",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        InstId: instId,
        Account: account,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param instId: RDS实例ID (Required)
 * param account: 创建RDS实例的账号信息 (Required)
 */
func NewCreateRdsAccountsRequestWithAllParams(
    regionId string,
    instId string,
    account *jdfusion.CreateRDSAccount,
) *CreateRdsAccountsRequest {

    return &CreateRdsAccountsRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/rds_instances/{instId}/accounts",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        InstId: instId,
        Account: account,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCreateRdsAccountsRequestWithoutParam() *CreateRdsAccountsRequest {

    return &CreateRdsAccountsRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/rds_instances/{instId}/accounts",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *CreateRdsAccountsRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param instId: RDS实例ID(Required) */
func (r *CreateRdsAccountsRequest) SetInstId(instId string) {
    r.InstId = instId
}

/* param account: 创建RDS实例的账号信息(Required) */
func (r *CreateRdsAccountsRequest) SetAccount(account *jdfusion.CreateRDSAccount) {
    r.Account = account
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CreateRdsAccountsRequest) GetRegionId() string {
    return r.RegionId
}

type CreateRdsAccountsResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CreateRdsAccountsResult `json:"result"`
}

type CreateRdsAccountsResult struct {
    Task jdfusion.ResourceTFInfo `json:"task"`
}