// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type CreateRdsInstanceRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 创建RDS实例  */
    Instance *jdfusion.CreateRDSInstance `json:"instance"`
}

/*
 * param regionId: 地域ID (Required)
 * param instance: 创建RDS实例 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCreateRdsInstanceRequest(
    regionId string,
    instance *jdfusion.CreateRDSInstance,
) *CreateRdsInstanceRequest {

	return &CreateRdsInstanceRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/rds_instances",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Instance: instance,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param instance: 创建RDS实例 (Required)
 */
func NewCreateRdsInstanceRequestWithAllParams(
    regionId string,
    instance *jdfusion.CreateRDSInstance,
) *CreateRdsInstanceRequest {

    return &CreateRdsInstanceRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/rds_instances",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Instance: instance,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCreateRdsInstanceRequestWithoutParam() *CreateRdsInstanceRequest {

    return &CreateRdsInstanceRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/rds_instances",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *CreateRdsInstanceRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param instance: 创建RDS实例(Required) */
func (r *CreateRdsInstanceRequest) SetInstance(instance *jdfusion.CreateRDSInstance) {
    r.Instance = instance
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CreateRdsInstanceRequest) GetRegionId() string {
    return r.RegionId
}

type CreateRdsInstanceResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CreateRdsInstanceResult `json:"result"`
}

type CreateRdsInstanceResult struct {
    Task jdfusion.ResourceTFInfo `json:"task"`
}