// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type CreateTransferTaskRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /*  (Optional) */
    Task *jdfusion.TransferSimpleTaskInfo `json:"task"`
}

/*
 * param regionId: 地域ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCreateTransferTaskRequest(
    regionId string,
) *CreateTransferTaskRequest {

	return &CreateTransferTaskRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/oss_transferTasks_simple",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param task:  (Optional)
 */
func NewCreateTransferTaskRequestWithAllParams(
    regionId string,
    task *jdfusion.TransferSimpleTaskInfo,
) *CreateTransferTaskRequest {

    return &CreateTransferTaskRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/oss_transferTasks_simple",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Task: task,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCreateTransferTaskRequestWithoutParam() *CreateTransferTaskRequest {

    return &CreateTransferTaskRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/oss_transferTasks_simple",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *CreateTransferTaskRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param task: (Optional) */
func (r *CreateTransferTaskRequest) SetTask(task *jdfusion.TransferSimpleTaskInfo) {
    r.Task = task
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CreateTransferTaskRequest) GetRegionId() string {
    return r.RegionId
}

type CreateTransferTaskResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CreateTransferTaskResult `json:"result"`
}

type CreateTransferTaskResult struct {
    Task jdfusion.TransferTaskInfoWithID `json:"task"`
}