// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type CreateVmKeypairRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 创建keypair  */
    Keypair *jdfusion.CreateKeypair `json:"keypair"`
}

/*
 * param regionId: 地域ID (Required)
 * param keypair: 创建keypair (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCreateVmKeypairRequest(
    regionId string,
    keypair *jdfusion.CreateKeypair,
) *CreateVmKeypairRequest {

	return &CreateVmKeypairRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/vm_keypairs",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Keypair: keypair,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param keypair: 创建keypair (Required)
 */
func NewCreateVmKeypairRequestWithAllParams(
    regionId string,
    keypair *jdfusion.CreateKeypair,
) *CreateVmKeypairRequest {

    return &CreateVmKeypairRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/vm_keypairs",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Keypair: keypair,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCreateVmKeypairRequestWithoutParam() *CreateVmKeypairRequest {

    return &CreateVmKeypairRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/vm_keypairs",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *CreateVmKeypairRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param keypair: 创建keypair(Required) */
func (r *CreateVmKeypairRequest) SetKeypair(keypair *jdfusion.CreateKeypair) {
    r.Keypair = keypair
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CreateVmKeypairRequest) GetRegionId() string {
    return r.RegionId
}

type CreateVmKeypairResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CreateVmKeypairResult `json:"result"`
}

type CreateVmKeypairResult struct {
    Tasks []jdfusion.ResourceTFInfo `json:"tasks"`
}