// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type CreateVpcSecurityGroupRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 创建securityGroup  */
    SecurityGroup *jdfusion.CreateSecurityGroup `json:"securityGroup"`
}

/*
 * param regionId: 地域ID (Required)
 * param securityGroup: 创建securityGroup (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCreateVpcSecurityGroupRequest(
    regionId string,
    securityGroup *jdfusion.CreateSecurityGroup,
) *CreateVpcSecurityGroupRequest {

	return &CreateVpcSecurityGroupRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/vpc_securityGroups",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        SecurityGroup: securityGroup,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param securityGroup: 创建securityGroup (Required)
 */
func NewCreateVpcSecurityGroupRequestWithAllParams(
    regionId string,
    securityGroup *jdfusion.CreateSecurityGroup,
) *CreateVpcSecurityGroupRequest {

    return &CreateVpcSecurityGroupRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/vpc_securityGroups",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        SecurityGroup: securityGroup,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCreateVpcSecurityGroupRequestWithoutParam() *CreateVpcSecurityGroupRequest {

    return &CreateVpcSecurityGroupRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/vpc_securityGroups",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *CreateVpcSecurityGroupRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param securityGroup: 创建securityGroup(Required) */
func (r *CreateVpcSecurityGroupRequest) SetSecurityGroup(securityGroup *jdfusion.CreateSecurityGroup) {
    r.SecurityGroup = securityGroup
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CreateVpcSecurityGroupRequest) GetRegionId() string {
    return r.RegionId
}

type CreateVpcSecurityGroupResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CreateVpcSecurityGroupResult `json:"result"`
}

type CreateVpcSecurityGroupResult struct {
    Task jdfusion.ResourceTFInfo `json:"task"`
}