// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type CreateVpcVServerGroupRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 创建虚拟服务器组  */
    VserverGroup *jdfusion.CreateVserverGroup `json:"vserverGroup"`
}

/*
 * param regionId: 地域ID (Required)
 * param vserverGroup: 创建虚拟服务器组 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCreateVpcVServerGroupRequest(
    regionId string,
    vserverGroup *jdfusion.CreateVserverGroup,
) *CreateVpcVServerGroupRequest {

	return &CreateVpcVServerGroupRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/vpc_vserverGroups",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        VserverGroup: vserverGroup,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param vserverGroup: 创建虚拟服务器组 (Required)
 */
func NewCreateVpcVServerGroupRequestWithAllParams(
    regionId string,
    vserverGroup *jdfusion.CreateVserverGroup,
) *CreateVpcVServerGroupRequest {

    return &CreateVpcVServerGroupRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/vpc_vserverGroups",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        VserverGroup: vserverGroup,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCreateVpcVServerGroupRequestWithoutParam() *CreateVpcVServerGroupRequest {

    return &CreateVpcVServerGroupRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/vpc_vserverGroups",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *CreateVpcVServerGroupRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param vserverGroup: 创建虚拟服务器组(Required) */
func (r *CreateVpcVServerGroupRequest) SetVserverGroup(vserverGroup *jdfusion.CreateVserverGroup) {
    r.VserverGroup = vserverGroup
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CreateVpcVServerGroupRequest) GetRegionId() string {
    return r.RegionId
}

type CreateVpcVServerGroupResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CreateVpcVServerGroupResult `json:"result"`
}

type CreateVpcVServerGroupResult struct {
    Task jdfusion.ResourceTFInfo `json:"task"`
}