// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type DetachDiskToVmInstanceByDiskIdRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 云硬盘 ID  */
    Id string `json:"id"`

    /* 从虚拟机卸载云硬盘  */
    Detach *jdfusion.DetachDataDisk `json:"detach"`
}

/*
 * param regionId: 地域ID (Required)
 * param id: 云硬盘 ID (Required)
 * param detach: 从虚拟机卸载云硬盘 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDetachDiskToVmInstanceByDiskIdRequest(
    regionId string,
    id string,
    detach *jdfusion.DetachDataDisk,
) *DetachDiskToVmInstanceByDiskIdRequest {

	return &DetachDiskToVmInstanceByDiskIdRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/disk_disks/{id}:detach",
			Method:  "PUT",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Id: id,
        Detach: detach,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param id: 云硬盘 ID (Required)
 * param detach: 从虚拟机卸载云硬盘 (Required)
 */
func NewDetachDiskToVmInstanceByDiskIdRequestWithAllParams(
    regionId string,
    id string,
    detach *jdfusion.DetachDataDisk,
) *DetachDiskToVmInstanceByDiskIdRequest {

    return &DetachDiskToVmInstanceByDiskIdRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/disk_disks/{id}:detach",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Id: id,
        Detach: detach,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDetachDiskToVmInstanceByDiskIdRequestWithoutParam() *DetachDiskToVmInstanceByDiskIdRequest {

    return &DetachDiskToVmInstanceByDiskIdRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/disk_disks/{id}:detach",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *DetachDiskToVmInstanceByDiskIdRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param id: 云硬盘 ID(Required) */
func (r *DetachDiskToVmInstanceByDiskIdRequest) SetId(id string) {
    r.Id = id
}

/* param detach: 从虚拟机卸载云硬盘(Required) */
func (r *DetachDiskToVmInstanceByDiskIdRequest) SetDetach(detach *jdfusion.DetachDataDisk) {
    r.Detach = detach
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DetachDiskToVmInstanceByDiskIdRequest) GetRegionId() string {
    return r.RegionId
}

type DetachDiskToVmInstanceByDiskIdResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DetachDiskToVmInstanceByDiskIdResult `json:"result"`
}

type DetachDiskToVmInstanceByDiskIdResult struct {
}