// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type DetachVpcNetworkInterfaceByIdRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 网卡 ID  */
    Id string `json:"id"`

    /* 卸载网卡  */
    Detach *jdfusion.DetachNetInterface `json:"detach"`
}

/*
 * param regionId: 地域ID (Required)
 * param id: 网卡 ID (Required)
 * param detach: 卸载网卡 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDetachVpcNetworkInterfaceByIdRequest(
    regionId string,
    id string,
    detach *jdfusion.DetachNetInterface,
) *DetachVpcNetworkInterfaceByIdRequest {

	return &DetachVpcNetworkInterfaceByIdRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/vpc_networkInterfaces/{id}:detach",
			Method:  "PUT",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Id: id,
        Detach: detach,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param id: 网卡 ID (Required)
 * param detach: 卸载网卡 (Required)
 */
func NewDetachVpcNetworkInterfaceByIdRequestWithAllParams(
    regionId string,
    id string,
    detach *jdfusion.DetachNetInterface,
) *DetachVpcNetworkInterfaceByIdRequest {

    return &DetachVpcNetworkInterfaceByIdRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/vpc_networkInterfaces/{id}:detach",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Id: id,
        Detach: detach,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDetachVpcNetworkInterfaceByIdRequestWithoutParam() *DetachVpcNetworkInterfaceByIdRequest {

    return &DetachVpcNetworkInterfaceByIdRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/vpc_networkInterfaces/{id}:detach",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *DetachVpcNetworkInterfaceByIdRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param id: 网卡 ID(Required) */
func (r *DetachVpcNetworkInterfaceByIdRequest) SetId(id string) {
    r.Id = id
}

/* param detach: 卸载网卡(Required) */
func (r *DetachVpcNetworkInterfaceByIdRequest) SetDetach(detach *jdfusion.DetachNetInterface) {
    r.Detach = detach
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DetachVpcNetworkInterfaceByIdRequest) GetRegionId() string {
    return r.RegionId
}

type DetachVpcNetworkInterfaceByIdResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DetachVpcNetworkInterfaceByIdResult `json:"result"`
}

type DetachVpcNetworkInterfaceByIdResult struct {
}