// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type DisassociateVpcEipByIdRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 公网IP ID  */
    Id string `json:"id"`

    /* 解绑公网IP  */
    Unassociate *jdfusion.UnassociateEipAddress `json:"unassociate"`
}

/*
 * param regionId: 地域ID (Required)
 * param id: 公网IP ID (Required)
 * param unassociate: 解绑公网IP (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDisassociateVpcEipByIdRequest(
    regionId string,
    id string,
    unassociate *jdfusion.UnassociateEipAddress,
) *DisassociateVpcEipByIdRequest {

	return &DisassociateVpcEipByIdRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/vpc_eips/{id}:disassociate",
			Method:  "PUT",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Id: id,
        Unassociate: unassociate,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param id: 公网IP ID (Required)
 * param unassociate: 解绑公网IP (Required)
 */
func NewDisassociateVpcEipByIdRequestWithAllParams(
    regionId string,
    id string,
    unassociate *jdfusion.UnassociateEipAddress,
) *DisassociateVpcEipByIdRequest {

    return &DisassociateVpcEipByIdRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/vpc_eips/{id}:disassociate",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Id: id,
        Unassociate: unassociate,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDisassociateVpcEipByIdRequestWithoutParam() *DisassociateVpcEipByIdRequest {

    return &DisassociateVpcEipByIdRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/vpc_eips/{id}:disassociate",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *DisassociateVpcEipByIdRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param id: 公网IP ID(Required) */
func (r *DisassociateVpcEipByIdRequest) SetId(id string) {
    r.Id = id
}

/* param unassociate: 解绑公网IP(Required) */
func (r *DisassociateVpcEipByIdRequest) SetUnassociate(unassociate *jdfusion.UnassociateEipAddress) {
    r.Unassociate = unassociate
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DisassociateVpcEipByIdRequest) GetRegionId() string {
    return r.RegionId
}

type DisassociateVpcEipByIdResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DisassociateVpcEipByIdResult `json:"result"`
}

type DisassociateVpcEipByIdResult struct {
}