// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type EditDeploymentRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* Deployment ID  */
    Id string `json:"id"`

    /* 修改deployment  */
    Deployment *jdfusion.DeploymentInfo `json:"deployment"`
}

/*
 * param regionId: 地域ID (Required)
 * param id: Deployment ID (Required)
 * param deployment: 修改deployment (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewEditDeploymentRequest(
    regionId string,
    id string,
    deployment *jdfusion.DeploymentInfo,
) *EditDeploymentRequest {

	return &EditDeploymentRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/deployments/{id}",
			Method:  "PUT",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Id: id,
        Deployment: deployment,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param id: Deployment ID (Required)
 * param deployment: 修改deployment (Required)
 */
func NewEditDeploymentRequestWithAllParams(
    regionId string,
    id string,
    deployment *jdfusion.DeploymentInfo,
) *EditDeploymentRequest {

    return &EditDeploymentRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/deployments/{id}",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Id: id,
        Deployment: deployment,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewEditDeploymentRequestWithoutParam() *EditDeploymentRequest {

    return &EditDeploymentRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/deployments/{id}",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *EditDeploymentRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param id: Deployment ID(Required) */
func (r *EditDeploymentRequest) SetId(id string) {
    r.Id = id
}

/* param deployment: 修改deployment(Required) */
func (r *EditDeploymentRequest) SetDeployment(deployment *jdfusion.DeploymentInfo) {
    r.Deployment = deployment
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r EditDeploymentRequest) GetRegionId() string {
    return r.RegionId
}

type EditDeploymentResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result EditDeploymentResult `json:"result"`
}

type EditDeploymentResult struct {
    Deployment jdfusion.DeploymentInfo `json:"deployment"`
}