// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type GetCloudInfosRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 只获取对应driver的云信息 (Optional) */
    Driver *string `json:"driver"`
}

/*
 * param regionId: 地域ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewGetCloudInfosRequest(
    regionId string,
) *GetCloudInfosRequest {

	return &GetCloudInfosRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/cloud_info",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param driver: 只获取对应driver的云信息 (Optional)
 */
func NewGetCloudInfosRequestWithAllParams(
    regionId string,
    driver *string,
) *GetCloudInfosRequest {

    return &GetCloudInfosRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/cloud_info",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Driver: driver,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewGetCloudInfosRequestWithoutParam() *GetCloudInfosRequest {

    return &GetCloudInfosRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/cloud_info",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *GetCloudInfosRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param driver: 只获取对应driver的云信息(Optional) */
func (r *GetCloudInfosRequest) SetDriver(driver string) {
    r.Driver = &driver
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r GetCloudInfosRequest) GetRegionId() string {
    return r.RegionId
}

type GetCloudInfosResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result GetCloudInfosResult `json:"result"`
}

type GetCloudInfosResult struct {
    Clouds []jdfusion.CloudInfo `json:"clouds"`
}