// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type GetRdsAccountsByInstIdRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* RDS实例ID  */
    InstId string `json:"instId"`
}

/*
 * param regionId: 地域ID (Required)
 * param instId: RDS实例ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewGetRdsAccountsByInstIdRequest(
    regionId string,
    instId string,
) *GetRdsAccountsByInstIdRequest {

	return &GetRdsAccountsByInstIdRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/rds_instances/{instId}/accounts",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        InstId: instId,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param instId: RDS实例ID (Required)
 */
func NewGetRdsAccountsByInstIdRequestWithAllParams(
    regionId string,
    instId string,
) *GetRdsAccountsByInstIdRequest {

    return &GetRdsAccountsByInstIdRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/rds_instances/{instId}/accounts",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        InstId: instId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewGetRdsAccountsByInstIdRequestWithoutParam() *GetRdsAccountsByInstIdRequest {

    return &GetRdsAccountsByInstIdRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/rds_instances/{instId}/accounts",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *GetRdsAccountsByInstIdRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param instId: RDS实例ID(Required) */
func (r *GetRdsAccountsByInstIdRequest) SetInstId(instId string) {
    r.InstId = instId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r GetRdsAccountsByInstIdRequest) GetRegionId() string {
    return r.RegionId
}

type GetRdsAccountsByInstIdResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result GetRdsAccountsByInstIdResult `json:"result"`
}

type GetRdsAccountsByInstIdResult struct {
    Accounts []jdfusion.RdsAccountInfo `json:"accounts"`
}