// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type GetRegionsAvailableZonesRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 区域id  */
    Region string `json:"region"`
}

/*
 * param regionId: 地域ID (Required)
 * param region: 区域id (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewGetRegionsAvailableZonesRequest(
    regionId string,
    region string,
) *GetRegionsAvailableZonesRequest {

	return &GetRegionsAvailableZonesRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/regions_availableZones/{region}",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Region: region,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param region: 区域id (Required)
 */
func NewGetRegionsAvailableZonesRequestWithAllParams(
    regionId string,
    region string,
) *GetRegionsAvailableZonesRequest {

    return &GetRegionsAvailableZonesRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/regions_availableZones/{region}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Region: region,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewGetRegionsAvailableZonesRequestWithoutParam() *GetRegionsAvailableZonesRequest {

    return &GetRegionsAvailableZonesRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/regions_availableZones/{region}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *GetRegionsAvailableZonesRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param region: 区域id(Required) */
func (r *GetRegionsAvailableZonesRequest) SetRegion(region string) {
    r.Region = region
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r GetRegionsAvailableZonesRequest) GetRegionId() string {
    return r.RegionId
}

type GetRegionsAvailableZonesResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result GetRegionsAvailableZonesResult `json:"result"`
}

type GetRegionsAvailableZonesResult struct {
    Azs []jdfusion.AzInfo `json:"azs"`
}