// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type GetTaskInfoByIdRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 执行请求 ID  */
    Task string `json:"task"`

    /* 执行文件名称 (Optional) */
    FileName *string `json:"fileName"`
}

/*
 * param regionId: 地域ID (Required)
 * param task: 执行请求 ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewGetTaskInfoByIdRequest(
    regionId string,
    task string,
) *GetTaskInfoByIdRequest {

	return &GetTaskInfoByIdRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/task_infos/{task}",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Task: task,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param task: 执行请求 ID (Required)
 * param fileName: 执行文件名称 (Optional)
 */
func NewGetTaskInfoByIdRequestWithAllParams(
    regionId string,
    task string,
    fileName *string,
) *GetTaskInfoByIdRequest {

    return &GetTaskInfoByIdRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/task_infos/{task}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Task: task,
        FileName: fileName,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewGetTaskInfoByIdRequestWithoutParam() *GetTaskInfoByIdRequest {

    return &GetTaskInfoByIdRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/task_infos/{task}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *GetTaskInfoByIdRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param task: 执行请求 ID(Required) */
func (r *GetTaskInfoByIdRequest) SetTask(task string) {
    r.Task = task
}

/* param fileName: 执行文件名称(Optional) */
func (r *GetTaskInfoByIdRequest) SetFileName(fileName string) {
    r.FileName = &fileName
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r GetTaskInfoByIdRequest) GetRegionId() string {
    return r.RegionId
}

type GetTaskInfoByIdResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result GetTaskInfoByIdResult `json:"result"`
}

type GetTaskInfoByIdResult struct {
    Task jdfusion.TaskInfo `json:"task"`
}