// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdfusion "github.com/jdcloud-api/jdcloud-sdk-go/services/jdfusion/models"
)

type GetTaskInfoHistoryByIdRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 执行请求 ID  */
    Task string `json:"task"`
}

/*
 * param regionId: 地域ID (Required)
 * param task: 执行请求 ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewGetTaskInfoHistoryByIdRequest(
    regionId string,
    task string,
) *GetTaskInfoHistoryByIdRequest {

	return &GetTaskInfoHistoryByIdRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/task_infos/{task}/history",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Task: task,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param task: 执行请求 ID (Required)
 */
func NewGetTaskInfoHistoryByIdRequestWithAllParams(
    regionId string,
    task string,
) *GetTaskInfoHistoryByIdRequest {

    return &GetTaskInfoHistoryByIdRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/task_infos/{task}/history",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Task: task,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewGetTaskInfoHistoryByIdRequestWithoutParam() *GetTaskInfoHistoryByIdRequest {

    return &GetTaskInfoHistoryByIdRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/task_infos/{task}/history",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *GetTaskInfoHistoryByIdRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param task: 执行请求 ID(Required) */
func (r *GetTaskInfoHistoryByIdRequest) SetTask(task string) {
    r.Task = task
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r GetTaskInfoHistoryByIdRequest) GetRegionId() string {
    return r.RegionId
}

type GetTaskInfoHistoryByIdResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result GetTaskInfoHistoryByIdResult `json:"result"`
}

type GetTaskInfoHistoryByIdResult struct {
    Tasks []jdfusion.TaskInfo `json:"tasks"`
}