// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package models


type CreateVm struct {

    /* 资源ID，如果为空，则执行创建操作，否则执行修改操作 (Optional) */
    Id *string `json:"id"`

    /* 可用区,根据各云平台规范填写 (Optional) */
    Region *string `json:"region"`

    /* 云主机所属的可用区 (Optional) */
    Az *string `json:"az"`

    /* 云主机名称  */
    Name string `json:"name"`

    /* 云主机 (Optional) */
    HostName *string `json:"hostName"`

    /*  (Optional) */
    ImageType *ImageType `json:"imageType"`

    /*  (Optional) */
    InstanceType *InstanceType `json:"instanceType"`

    /* 云主机描述 (Optional) */
    Description *string `json:"description"`

    /* 子网ID  */
    SubnetId string `json:"subnetId"`

    /*  (Optional) */
    Tags []Tag `json:"tags"`

    /* 所属云提供商ID (Optional) */
    CloudID *string `json:"cloudID"`

    /* 密钥对名称,jd当前只支持传入一个 (Optional) */
    KeyNames []string `json:"keyNames"`

    /* 主网卡主IP绑定弹性IP的地址 (Optional) */
    ElasticIpAddress *string `json:"elasticIpAddress"`

    /* 私有ip地址 (Optional) */
    PrivateIpAddress *string `json:"privateIpAddress"`

    /* 云主机状态 (Optional) */
    Status *string `json:"status"`

    /* 创建时间 (Optional) */
    CreatedTime *string `json:"createdTime"`

    /* 镜像文件ID，启动实例时选择的镜像资源  */
    ImageId string `json:"imageId"`

    /* 规格类型  */
    InstanceFlavorType string `json:"instanceFlavorType"`

    /* 指定新创建实例所属于的安全组代码，同一个安全组内的实例之间可以互相访问 (Optional) */
    SecurityGroupId *string `json:"securityGroupId"`

    /* 否  公网入带宽最大值，单位为Mbit/s (Optional) */
    InternetMaxBandwidthIn *int `json:"internetMaxBandwidthIn"`

    /* 否  公网出带宽最大值，单位为Mbit/s (Optional) */
    InternetMaxBandwidthOut *int `json:"internetMaxBandwidthOut"`

    /* 否  实例的密码 (Optional) */
    Password *string `json:"password"`

    /* 否  是否使用镜像预设的密码 (Optional) */
    PasswordInherit *bool `json:"passwordInherit"`

    /* 否  实例自定义数据，需要以Base64方式编码，原始数据最多为16KB (Optional) */
    UserData *string `json:"userData"`

    /* 否  密钥对名称 (Optional) */
    KeyPairName *string `json:"keyPairName"`

    /*  (Optional) */
    SystemDisk *SystemDisk `json:"systemDisk"`
}
