// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdro "github.com/jdcloud-api/jdcloud-sdk-go/services/jdro/models"
)

type DescribeStackEventsRequest struct {

    core.JDCloudRequest

    /* 地域 ID  */
    RegionId string `json:"regionId"`

    /* 资源栈 ID  */
    StackId string `json:"stackId"`

    /* 当前所在页，默认为1 (Optional) */
    PageNumber *int `json:"pageNumber"`

    /* 页面大小，默认为20；取值范围[1, 100] (Optional) */
    PageSize *int `json:"pageSize"`

    /* 事件开始时间 (Optional) */
    StartTime *string `json:"startTime"`

    /* 事件结束时间 (Optional) */
    EndTime *string `json:"endTime"`
}

/*
 * param regionId: 地域 ID (Required)
 * param stackId: 资源栈 ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeStackEventsRequest(
    regionId string,
    stackId string,
) *DescribeStackEventsRequest {

	return &DescribeStackEventsRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/stacks/{stackId}/events",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        StackId: stackId,
	}
}

/*
 * param regionId: 地域 ID (Required)
 * param stackId: 资源栈 ID (Required)
 * param pageNumber: 当前所在页，默认为1 (Optional)
 * param pageSize: 页面大小，默认为20；取值范围[1, 100] (Optional)
 * param startTime: 事件开始时间 (Optional)
 * param endTime: 事件结束时间 (Optional)
 */
func NewDescribeStackEventsRequestWithAllParams(
    regionId string,
    stackId string,
    pageNumber *int,
    pageSize *int,
    startTime *string,
    endTime *string,
) *DescribeStackEventsRequest {

    return &DescribeStackEventsRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/stacks/{stackId}/events",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        StackId: stackId,
        PageNumber: pageNumber,
        PageSize: pageSize,
        StartTime: startTime,
        EndTime: endTime,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeStackEventsRequestWithoutParam() *DescribeStackEventsRequest {

    return &DescribeStackEventsRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/stacks/{stackId}/events",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域 ID(Required) */
func (r *DescribeStackEventsRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param stackId: 资源栈 ID(Required) */
func (r *DescribeStackEventsRequest) SetStackId(stackId string) {
    r.StackId = stackId
}

/* param pageNumber: 当前所在页，默认为1(Optional) */
func (r *DescribeStackEventsRequest) SetPageNumber(pageNumber int) {
    r.PageNumber = &pageNumber
}

/* param pageSize: 页面大小，默认为20；取值范围[1, 100](Optional) */
func (r *DescribeStackEventsRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

/* param startTime: 事件开始时间(Optional) */
func (r *DescribeStackEventsRequest) SetStartTime(startTime string) {
    r.StartTime = &startTime
}

/* param endTime: 事件结束时间(Optional) */
func (r *DescribeStackEventsRequest) SetEndTime(endTime string) {
    r.EndTime = &endTime
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeStackEventsRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeStackEventsResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeStackEventsResult `json:"result"`
}

type DescribeStackEventsResult struct {
    List []jdro.EventOut `json:"list"`
    TotalCount int64 `json:"totalCount"`
}