// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    jdro "github.com/jdcloud-api/jdcloud-sdk-go/services/jdro/models"
)

type DescribeStackResourcesRequest struct {

    core.JDCloudRequest

    /* 地域 ID  */
    RegionId string `json:"regionId"`

    /* 资源栈 ID  */
    StackId string `json:"stackId"`

    /* 当前所在页，默认为1 (Optional) */
    PageNumber *int `json:"pageNumber"`

    /* 页面大小，默认为20；取值范围[1, 100] (Optional) */
    PageSize *int `json:"pageSize"`

    /* 按照京东云产品线名称或者资源逻辑ID进行模糊搜索 (Optional) */
    Search *string `json:"search"`

    /* 只按照京东云产品线名称进行模糊搜索，比如VM，Disk等 (Optional) */
    Product *string `json:"product"`
}

/*
 * param regionId: 地域 ID (Required)
 * param stackId: 资源栈 ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeStackResourcesRequest(
    regionId string,
    stackId string,
) *DescribeStackResourcesRequest {

	return &DescribeStackResourcesRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/stacks/{stackId}/resources",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        StackId: stackId,
	}
}

/*
 * param regionId: 地域 ID (Required)
 * param stackId: 资源栈 ID (Required)
 * param pageNumber: 当前所在页，默认为1 (Optional)
 * param pageSize: 页面大小，默认为20；取值范围[1, 100] (Optional)
 * param search: 按照京东云产品线名称或者资源逻辑ID进行模糊搜索 (Optional)
 * param product: 只按照京东云产品线名称进行模糊搜索，比如VM，Disk等 (Optional)
 */
func NewDescribeStackResourcesRequestWithAllParams(
    regionId string,
    stackId string,
    pageNumber *int,
    pageSize *int,
    search *string,
    product *string,
) *DescribeStackResourcesRequest {

    return &DescribeStackResourcesRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/stacks/{stackId}/resources",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        StackId: stackId,
        PageNumber: pageNumber,
        PageSize: pageSize,
        Search: search,
        Product: product,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeStackResourcesRequestWithoutParam() *DescribeStackResourcesRequest {

    return &DescribeStackResourcesRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/stacks/{stackId}/resources",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域 ID(Required) */
func (r *DescribeStackResourcesRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param stackId: 资源栈 ID(Required) */
func (r *DescribeStackResourcesRequest) SetStackId(stackId string) {
    r.StackId = stackId
}

/* param pageNumber: 当前所在页，默认为1(Optional) */
func (r *DescribeStackResourcesRequest) SetPageNumber(pageNumber int) {
    r.PageNumber = &pageNumber
}

/* param pageSize: 页面大小，默认为20；取值范围[1, 100](Optional) */
func (r *DescribeStackResourcesRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

/* param search: 按照京东云产品线名称或者资源逻辑ID进行模糊搜索(Optional) */
func (r *DescribeStackResourcesRequest) SetSearch(search string) {
    r.Search = &search
}

/* param product: 只按照京东云产品线名称进行模糊搜索，比如VM，Disk等(Optional) */
func (r *DescribeStackResourcesRequest) SetProduct(product string) {
    r.Product = &product
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeStackResourcesRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeStackResourcesResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeStackResourcesResult `json:"result"`
}

type DescribeStackResourcesResult struct {
    List []jdro.ResourceOut `json:"list"`
    TotalCount int64 `json:"totalCount"`
}