// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type CancelKeyVersionDeletionRequest struct {

    core.JDCloudRequest

    /* 密钥ID  */
    KeyId string `json:"keyId"`

    /* 密钥版本  */
    Version string `json:"version"`
}

/*
 * param keyId: 密钥ID (Required)
 * param version: 密钥版本 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCancelKeyVersionDeletionRequest(
    keyId string,
    version string,
) *CancelKeyVersionDeletionRequest {

	return &CancelKeyVersionDeletionRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/key/{keyId}/version/{version}:cancelDelete",
			Method:  "PATCH",
			Header:  nil,
			Version: "v1",
		},
        KeyId: keyId,
        Version: version,
	}
}

/*
 * param keyId: 密钥ID (Required)
 * param version: 密钥版本 (Required)
 */
func NewCancelKeyVersionDeletionRequestWithAllParams(
    keyId string,
    version string,
) *CancelKeyVersionDeletionRequest {

    return &CancelKeyVersionDeletionRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/key/{keyId}/version/{version}:cancelDelete",
            Method:  "PATCH",
            Header:  nil,
            Version: "v1",
        },
        KeyId: keyId,
        Version: version,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCancelKeyVersionDeletionRequestWithoutParam() *CancelKeyVersionDeletionRequest {

    return &CancelKeyVersionDeletionRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/key/{keyId}/version/{version}:cancelDelete",
            Method:  "PATCH",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param keyId: 密钥ID(Required) */
func (r *CancelKeyVersionDeletionRequest) SetKeyId(keyId string) {
    r.KeyId = keyId
}

/* param version: 密钥版本(Required) */
func (r *CancelKeyVersionDeletionRequest) SetVersion(version string) {
    r.Version = version
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CancelKeyVersionDeletionRequest) GetRegionId() string {
    return ""
}

type CancelKeyVersionDeletionResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CancelKeyVersionDeletionResult `json:"result"`
}

type CancelKeyVersionDeletionResult struct {
}