// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    kms "github.com/jdcloud-api/jdcloud-sdk-go/services/kms/models"
)

type CreateKeyRequest struct {

    core.JDCloudRequest

    /*   */
    KeyCfg *kms.KeyCfg `json:"keyCfg"`
}

/*
 * param keyCfg:  (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCreateKeyRequest(
    keyCfg *kms.KeyCfg,
) *CreateKeyRequest {

	return &CreateKeyRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/key:create",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        KeyCfg: keyCfg,
	}
}

/*
 * param keyCfg:  (Required)
 */
func NewCreateKeyRequestWithAllParams(
    keyCfg *kms.KeyCfg,
) *CreateKeyRequest {

    return &CreateKeyRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/key:create",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        KeyCfg: keyCfg,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCreateKeyRequestWithoutParam() *CreateKeyRequest {

    return &CreateKeyRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/key:create",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param keyCfg: (Required) */
func (r *CreateKeyRequest) SetKeyCfg(keyCfg *kms.KeyCfg) {
    r.KeyCfg = keyCfg
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CreateKeyRequest) GetRegionId() string {
    return ""
}

type CreateKeyResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CreateKeyResult `json:"result"`
}

type CreateKeyResult struct {
}