// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    kms "github.com/jdcloud-api/jdcloud-sdk-go/services/kms/models"
)

type CreateSecretRequest struct {

    core.JDCloudRequest

    /*   */
    SecretCfg *kms.SecretCfg `json:"secretCfg"`
}

/*
 * param secretCfg:  (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCreateSecretRequest(
    secretCfg *kms.SecretCfg,
) *CreateSecretRequest {

	return &CreateSecretRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/secret:create",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        SecretCfg: secretCfg,
	}
}

/*
 * param secretCfg:  (Required)
 */
func NewCreateSecretRequestWithAllParams(
    secretCfg *kms.SecretCfg,
) *CreateSecretRequest {

    return &CreateSecretRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/secret:create",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        SecretCfg: secretCfg,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCreateSecretRequestWithoutParam() *CreateSecretRequest {

    return &CreateSecretRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/secret:create",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param secretCfg: (Required) */
func (r *CreateSecretRequest) SetSecretCfg(secretCfg *kms.SecretCfg) {
    r.SecretCfg = secretCfg
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CreateSecretRequest) GetRegionId() string {
    return ""
}

type CreateSecretResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CreateSecretResult `json:"result"`
}

type CreateSecretResult struct {
}