// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DecryptRequest struct {

    core.JDCloudRequest

    /* 密钥ID  */
    KeyId string `json:"keyId"`

    /* 密文数据 Base64-encoded binary data object (Optional) */
    CiphertextBlob *string `json:"ciphertextBlob"`
}

/*
 * param keyId: 密钥ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDecryptRequest(
    keyId string,
) *DecryptRequest {

	return &DecryptRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/key/{keyId}:Decrypt",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        KeyId: keyId,
	}
}

/*
 * param keyId: 密钥ID (Required)
 * param ciphertextBlob: 密文数据 Base64-encoded binary data object (Optional)
 */
func NewDecryptRequestWithAllParams(
    keyId string,
    ciphertextBlob *string,
) *DecryptRequest {

    return &DecryptRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/key/{keyId}:Decrypt",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        KeyId: keyId,
        CiphertextBlob: ciphertextBlob,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDecryptRequestWithoutParam() *DecryptRequest {

    return &DecryptRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/key/{keyId}:Decrypt",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param keyId: 密钥ID(Required) */
func (r *DecryptRequest) SetKeyId(keyId string) {
    r.KeyId = keyId
}

/* param ciphertextBlob: 密文数据 Base64-encoded binary data object(Optional) */
func (r *DecryptRequest) SetCiphertextBlob(ciphertextBlob string) {
    r.CiphertextBlob = &ciphertextBlob
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DecryptRequest) GetRegionId() string {
    return ""
}

type DecryptResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DecryptResult `json:"result"`
}

type DecryptResult struct {
    Plaintext string `json:"plaintext"`
}