// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    kms "github.com/jdcloud-api/jdcloud-sdk-go/services/kms/models"
)

type DescribeSecretVersionListRequest struct {

    core.JDCloudRequest

    /* 机密ID  */
    SecretId string `json:"secretId"`

    /* 页码；默认为1 (Optional) */
    PageNumber *int `json:"pageNumber"`

    /* 分页大小；默认为10；取值范围[10, 100] (Optional) */
    PageSize *int `json:"pageSize"`
}

/*
 * param secretId: 机密ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeSecretVersionListRequest(
    secretId string,
) *DescribeSecretVersionListRequest {

	return &DescribeSecretVersionListRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/secret/{secretId}",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        SecretId: secretId,
	}
}

/*
 * param secretId: 机密ID (Required)
 * param pageNumber: 页码；默认为1 (Optional)
 * param pageSize: 分页大小；默认为10；取值范围[10, 100] (Optional)
 */
func NewDescribeSecretVersionListRequestWithAllParams(
    secretId string,
    pageNumber *int,
    pageSize *int,
) *DescribeSecretVersionListRequest {

    return &DescribeSecretVersionListRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/secret/{secretId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        SecretId: secretId,
        PageNumber: pageNumber,
        PageSize: pageSize,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeSecretVersionListRequestWithoutParam() *DescribeSecretVersionListRequest {

    return &DescribeSecretVersionListRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/secret/{secretId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param secretId: 机密ID(Required) */
func (r *DescribeSecretVersionListRequest) SetSecretId(secretId string) {
    r.SecretId = secretId
}

/* param pageNumber: 页码；默认为1(Optional) */
func (r *DescribeSecretVersionListRequest) SetPageNumber(pageNumber int) {
    r.PageNumber = &pageNumber
}

/* param pageSize: 分页大小；默认为10；取值范围[10, 100](Optional) */
func (r *DescribeSecretVersionListRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeSecretVersionListRequest) GetRegionId() string {
    return ""
}

type DescribeSecretVersionListResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeSecretVersionListResult `json:"result"`
}

type DescribeSecretVersionListResult struct {
    SecretDetail kms.SecretDetail `json:"secretDetail"`
}