// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type ImportSecretRequest struct {

    core.JDCloudRequest

    /* 密钥包的内容 (Optional) */
    SecretPackage *string `json:"secretPackage"`
}

/*
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewImportSecretRequest(
) *ImportSecretRequest {

	return &ImportSecretRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/secret:import",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
	}
}

/*
 * param secretPackage: 密钥包的内容 (Optional)
 */
func NewImportSecretRequestWithAllParams(
    secretPackage *string,
) *ImportSecretRequest {

    return &ImportSecretRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/secret:import",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        SecretPackage: secretPackage,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewImportSecretRequestWithoutParam() *ImportSecretRequest {

    return &ImportSecretRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/secret:import",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param secretPackage: 密钥包的内容(Optional) */
func (r *ImportSecretRequest) SetSecretPackage(secretPackage string) {
    r.SecretPackage = &secretPackage
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ImportSecretRequest) GetRegionId() string {
    return ""
}

type ImportSecretResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ImportSecretResult `json:"result"`
}

type ImportSecretResult struct {
}