// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type ScheduleKeyDeletionRequest struct {

    core.JDCloudRequest

    /* 密钥ID  */
    KeyId string `json:"keyId"`

    /* 延迟删除时间，单位（天），默认为7天；支持时间范围：7~30天 (Optional) */
    DelayDays *int `json:"delayDays"`
}

/*
 * param keyId: 密钥ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewScheduleKeyDeletionRequest(
    keyId string,
) *ScheduleKeyDeletionRequest {

	return &ScheduleKeyDeletionRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/key/{keyId}:delete",
			Method:  "DELETE",
			Header:  nil,
			Version: "v1",
		},
        KeyId: keyId,
	}
}

/*
 * param keyId: 密钥ID (Required)
 * param delayDays: 延迟删除时间，单位（天），默认为7天；支持时间范围：7~30天 (Optional)
 */
func NewScheduleKeyDeletionRequestWithAllParams(
    keyId string,
    delayDays *int,
) *ScheduleKeyDeletionRequest {

    return &ScheduleKeyDeletionRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/key/{keyId}:delete",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
        KeyId: keyId,
        DelayDays: delayDays,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewScheduleKeyDeletionRequestWithoutParam() *ScheduleKeyDeletionRequest {

    return &ScheduleKeyDeletionRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/key/{keyId}:delete",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param keyId: 密钥ID(Required) */
func (r *ScheduleKeyDeletionRequest) SetKeyId(keyId string) {
    r.KeyId = keyId
}

/* param delayDays: 延迟删除时间，单位（天），默认为7天；支持时间范围：7~30天(Optional) */
func (r *ScheduleKeyDeletionRequest) SetDelayDays(delayDays int) {
    r.DelayDays = &delayDays
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ScheduleKeyDeletionRequest) GetRegionId() string {
    return ""
}

type ScheduleKeyDeletionResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ScheduleKeyDeletionResult `json:"result"`
}

type ScheduleKeyDeletionResult struct {
}