// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    kms "github.com/jdcloud-api/jdcloud-sdk-go/services/kms/models"
)

type UpdateSecretVersionRequest struct {

    core.JDCloudRequest

    /* 机密ID  */
    SecretId string `json:"secretId"`

    /* 机密版本  */
    Version string `json:"version"`

    /*   */
    SecretTimeCfg *kms.SecretTimeCfg `json:"secretTimeCfg"`
}

/*
 * param secretId: 机密ID (Required)
 * param version: 机密版本 (Required)
 * param secretTimeCfg:  (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewUpdateSecretVersionRequest(
    secretId string,
    version string,
    secretTimeCfg *kms.SecretTimeCfg,
) *UpdateSecretVersionRequest {

	return &UpdateSecretVersionRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/secret/{secretId}/version/{version}",
			Method:  "PATCH",
			Header:  nil,
			Version: "v1",
		},
        SecretId: secretId,
        Version: version,
        SecretTimeCfg: secretTimeCfg,
	}
}

/*
 * param secretId: 机密ID (Required)
 * param version: 机密版本 (Required)
 * param secretTimeCfg:  (Required)
 */
func NewUpdateSecretVersionRequestWithAllParams(
    secretId string,
    version string,
    secretTimeCfg *kms.SecretTimeCfg,
) *UpdateSecretVersionRequest {

    return &UpdateSecretVersionRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/secret/{secretId}/version/{version}",
            Method:  "PATCH",
            Header:  nil,
            Version: "v1",
        },
        SecretId: secretId,
        Version: version,
        SecretTimeCfg: secretTimeCfg,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewUpdateSecretVersionRequestWithoutParam() *UpdateSecretVersionRequest {

    return &UpdateSecretVersionRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/secret/{secretId}/version/{version}",
            Method:  "PATCH",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param secretId: 机密ID(Required) */
func (r *UpdateSecretVersionRequest) SetSecretId(secretId string) {
    r.SecretId = secretId
}

/* param version: 机密版本(Required) */
func (r *UpdateSecretVersionRequest) SetVersion(version string) {
    r.Version = version
}

/* param secretTimeCfg: (Required) */
func (r *UpdateSecretVersionRequest) SetSecretTimeCfg(secretTimeCfg *kms.SecretTimeCfg) {
    r.SecretTimeCfg = secretTimeCfg
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r UpdateSecretVersionRequest) GetRegionId() string {
    return ""
}

type UpdateSecretVersionResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result UpdateSecretVersionResult `json:"result"`
}

type UpdateSecretVersionResult struct {
}