// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    kubernetes "github.com/jdcloud-api/jdcloud-sdk-go/services/kubernetes/models"
)

type DescribeNodeGroupRequest struct {

    core.JDCloudRequest

    /* 地域 ID  */
    RegionId string `json:"regionId"`

    /* 节点组 ID  */
    NodeGroupId string `json:"nodeGroupId"`
}

/*
 * param regionId: 地域 ID (Required)
 * param nodeGroupId: 节点组 ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeNodeGroupRequest(
    regionId string,
    nodeGroupId string,
) *DescribeNodeGroupRequest {

	return &DescribeNodeGroupRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/nodeGroups/{nodeGroupId}",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        NodeGroupId: nodeGroupId,
	}
}

/*
 * param regionId: 地域 ID (Required)
 * param nodeGroupId: 节点组 ID (Required)
 */
func NewDescribeNodeGroupRequestWithAllParams(
    regionId string,
    nodeGroupId string,
) *DescribeNodeGroupRequest {

    return &DescribeNodeGroupRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/nodeGroups/{nodeGroupId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        NodeGroupId: nodeGroupId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeNodeGroupRequestWithoutParam() *DescribeNodeGroupRequest {

    return &DescribeNodeGroupRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/nodeGroups/{nodeGroupId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域 ID(Required) */
func (r *DescribeNodeGroupRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param nodeGroupId: 节点组 ID(Required) */
func (r *DescribeNodeGroupRequest) SetNodeGroupId(nodeGroupId string) {
    r.NodeGroupId = nodeGroupId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeNodeGroupRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeNodeGroupResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeNodeGroupResult `json:"result"`
}

type DescribeNodeGroupResult struct {
    NodeGroup kubernetes.NodeGroup `json:"nodeGroup"`
}