// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    kubernetes "github.com/jdcloud-api/jdcloud-sdk-go/services/kubernetes/models"
    common "github.com/jdcloud-api/jdcloud-sdk-go/services/common/models"
)

type DescribeNodeGroupsRequest struct {

    core.JDCloudRequest

    /* 地域 ID  */
    RegionId string `json:"regionId"`

    /* 页码；默认为1 (Optional) */
    PageNumber *int `json:"pageNumber"`

    /* 分页大小；默认为20；取值范围[10, 100] (Optional) */
    PageSize *int `json:"pageSize"`

    /* Tag筛选条件 (Optional) */
    Tags []kubernetes.TagFilter `json:"tags"`

    /* name - 节点组名称，模糊匹配，支持单个      
id - 节点组 id，支持多个     
clusterId - 根据clusterId查询        
clusterName - 根据名称查询 cluster             
 (Optional) */
    Filters []common.Filter `json:"filters"`
}

/*
 * param regionId: 地域 ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeNodeGroupsRequest(
    regionId string,
) *DescribeNodeGroupsRequest {

	return &DescribeNodeGroupsRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/nodeGroups",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
	}
}

/*
 * param regionId: 地域 ID (Required)
 * param pageNumber: 页码；默认为1 (Optional)
 * param pageSize: 分页大小；默认为20；取值范围[10, 100] (Optional)
 * param tags: Tag筛选条件 (Optional)
 * param filters: name - 节点组名称，模糊匹配，支持单个      
id - 节点组 id，支持多个     
clusterId - 根据clusterId查询        
clusterName - 根据名称查询 cluster             
 (Optional)
 */
func NewDescribeNodeGroupsRequestWithAllParams(
    regionId string,
    pageNumber *int,
    pageSize *int,
    tags []kubernetes.TagFilter,
    filters []common.Filter,
) *DescribeNodeGroupsRequest {

    return &DescribeNodeGroupsRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/nodeGroups",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        PageNumber: pageNumber,
        PageSize: pageSize,
        Tags: tags,
        Filters: filters,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeNodeGroupsRequestWithoutParam() *DescribeNodeGroupsRequest {

    return &DescribeNodeGroupsRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/nodeGroups",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域 ID(Required) */
func (r *DescribeNodeGroupsRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param pageNumber: 页码；默认为1(Optional) */
func (r *DescribeNodeGroupsRequest) SetPageNumber(pageNumber int) {
    r.PageNumber = &pageNumber
}

/* param pageSize: 分页大小；默认为20；取值范围[10, 100](Optional) */
func (r *DescribeNodeGroupsRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

/* param tags: Tag筛选条件(Optional) */
func (r *DescribeNodeGroupsRequest) SetTags(tags []kubernetes.TagFilter) {
    r.Tags = tags
}

/* param filters: name - 节点组名称，模糊匹配，支持单个      
id - 节点组 id，支持多个     
clusterId - 根据clusterId查询        
clusterName - 根据名称查询 cluster             
(Optional) */
func (r *DescribeNodeGroupsRequest) SetFilters(filters []common.Filter) {
    r.Filters = filters
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeNodeGroupsRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeNodeGroupsResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeNodeGroupsResult `json:"result"`
}

type DescribeNodeGroupsResult struct {
    NodeGroups []kubernetes.NodeGroup `json:"nodeGroups"`
    TotalCount int `json:"totalCount"`
}