// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    kubernetes "github.com/jdcloud-api/jdcloud-sdk-go/services/kubernetes/models"
)

type DescribeNodeVersionRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 节点版本  */
    NodeVersion string `json:"nodeVersion"`
}

/*
 * param regionId: Region ID (Required)
 * param nodeVersion: 节点版本 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeNodeVersionRequest(
    regionId string,
    nodeVersion string,
) *DescribeNodeVersionRequest {

	return &DescribeNodeVersionRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/nodeVersions/{nodeVersion}",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        NodeVersion: nodeVersion,
	}
}

/*
 * param regionId: Region ID (Required)
 * param nodeVersion: 节点版本 (Required)
 */
func NewDescribeNodeVersionRequestWithAllParams(
    regionId string,
    nodeVersion string,
) *DescribeNodeVersionRequest {

    return &DescribeNodeVersionRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/nodeVersions/{nodeVersion}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        NodeVersion: nodeVersion,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeNodeVersionRequestWithoutParam() *DescribeNodeVersionRequest {

    return &DescribeNodeVersionRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/nodeVersions/{nodeVersion}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *DescribeNodeVersionRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param nodeVersion: 节点版本(Required) */
func (r *DescribeNodeVersionRequest) SetNodeVersion(nodeVersion string) {
    r.NodeVersion = nodeVersion
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeNodeVersionRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeNodeVersionResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeNodeVersionResult `json:"result"`
}

type DescribeNodeVersionResult struct {
    NodeVersion kubernetes.NodeVersion `json:"nodeVersion"`
}