// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    kubernetes "github.com/jdcloud-api/jdcloud-sdk-go/services/kubernetes/models"
)

type DescribeProgressRequest struct {

    core.JDCloudRequest

    /* 地域 ID  */
    RegionId string `json:"regionId"`

    /* 集群 ID  */
    ClusterId string `json:"clusterId"`

    /* 节点组 ID (Optional) */
    NodeGroupIds []string `json:"nodeGroupIds"`
}

/*
 * param regionId: 地域 ID (Required)
 * param clusterId: 集群 ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeProgressRequest(
    regionId string,
    clusterId string,
) *DescribeProgressRequest {

	return &DescribeProgressRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/clusters/{clusterId}/progress",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        ClusterId: clusterId,
	}
}

/*
 * param regionId: 地域 ID (Required)
 * param clusterId: 集群 ID (Required)
 * param nodeGroupIds: 节点组 ID (Optional)
 */
func NewDescribeProgressRequestWithAllParams(
    regionId string,
    clusterId string,
    nodeGroupIds []string,
) *DescribeProgressRequest {

    return &DescribeProgressRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/clusters/{clusterId}/progress",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        ClusterId: clusterId,
        NodeGroupIds: nodeGroupIds,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeProgressRequestWithoutParam() *DescribeProgressRequest {

    return &DescribeProgressRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/clusters/{clusterId}/progress",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域 ID(Required) */
func (r *DescribeProgressRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param clusterId: 集群 ID(Required) */
func (r *DescribeProgressRequest) SetClusterId(clusterId string) {
    r.ClusterId = clusterId
}

/* param nodeGroupIds: 节点组 ID(Optional) */
func (r *DescribeProgressRequest) SetNodeGroupIds(nodeGroupIds []string) {
    r.NodeGroupIds = nodeGroupIds
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeProgressRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeProgressResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeProgressResult `json:"result"`
}

type DescribeProgressResult struct {
    MasterProgress kubernetes.MasterProgress `json:"masterProgress"`
    NodeGroupProgresses []kubernetes.NodeGroupProgress `json:"nodeGroupProgresses"`
}