// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type SetAutoRepairRequest struct {

    core.JDCloudRequest

    /* 地域 ID  */
    RegionId string `json:"regionId"`

    /* 节点组 ID  */
    NodeGroupId string `json:"nodeGroupId"`

    /* 是否开启自动修复  */
    Enabled bool `json:"enabled"`
}

/*
 * param regionId: 地域 ID (Required)
 * param nodeGroupId: 节点组 ID (Required)
 * param enabled: 是否开启自动修复 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewSetAutoRepairRequest(
    regionId string,
    nodeGroupId string,
    enabled bool,
) *SetAutoRepairRequest {

	return &SetAutoRepairRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/nodeGroups/{nodeGroupId}:setAutoRepair",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        NodeGroupId: nodeGroupId,
        Enabled: enabled,
	}
}

/*
 * param regionId: 地域 ID (Required)
 * param nodeGroupId: 节点组 ID (Required)
 * param enabled: 是否开启自动修复 (Required)
 */
func NewSetAutoRepairRequestWithAllParams(
    regionId string,
    nodeGroupId string,
    enabled bool,
) *SetAutoRepairRequest {

    return &SetAutoRepairRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/nodeGroups/{nodeGroupId}:setAutoRepair",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        NodeGroupId: nodeGroupId,
        Enabled: enabled,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewSetAutoRepairRequestWithoutParam() *SetAutoRepairRequest {

    return &SetAutoRepairRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/nodeGroups/{nodeGroupId}:setAutoRepair",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域 ID(Required) */
func (r *SetAutoRepairRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param nodeGroupId: 节点组 ID(Required) */
func (r *SetAutoRepairRequest) SetNodeGroupId(nodeGroupId string) {
    r.NodeGroupId = nodeGroupId
}

/* param enabled: 是否开启自动修复(Required) */
func (r *SetAutoRepairRequest) SetEnabled(enabled bool) {
    r.Enabled = enabled
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r SetAutoRepairRequest) GetRegionId() string {
    return r.RegionId
}

type SetAutoRepairResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result SetAutoRepairResult `json:"result"`
}

type SetAutoRepairResult struct {
}