// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type SetUserMetricsRequest struct {

    core.JDCloudRequest

    /* 地域 ID  */
    RegionId string `json:"regionId"`

    /* 集群 ID  */
    ClusterId string `json:"clusterId"`

    /* 是否开启自定义监控 (Optional) */
    Enabled *bool `json:"enabled"`
}

/*
 * param regionId: 地域 ID (Required)
 * param clusterId: 集群 ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewSetUserMetricsRequest(
    regionId string,
    clusterId string,
) *SetUserMetricsRequest {

	return &SetUserMetricsRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/clusters/{clusterId}:setUserMetrics",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        ClusterId: clusterId,
	}
}

/*
 * param regionId: 地域 ID (Required)
 * param clusterId: 集群 ID (Required)
 * param enabled: 是否开启自定义监控 (Optional)
 */
func NewSetUserMetricsRequestWithAllParams(
    regionId string,
    clusterId string,
    enabled *bool,
) *SetUserMetricsRequest {

    return &SetUserMetricsRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/clusters/{clusterId}:setUserMetrics",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        ClusterId: clusterId,
        Enabled: enabled,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewSetUserMetricsRequestWithoutParam() *SetUserMetricsRequest {

    return &SetUserMetricsRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/clusters/{clusterId}:setUserMetrics",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域 ID(Required) */
func (r *SetUserMetricsRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param clusterId: 集群 ID(Required) */
func (r *SetUserMetricsRequest) SetClusterId(clusterId string) {
    r.ClusterId = clusterId
}

/* param enabled: 是否开启自定义监控(Optional) */
func (r *SetUserMetricsRequest) SetEnabled(enabled bool) {
    r.Enabled = &enabled
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r SetUserMetricsRequest) GetRegionId() string {
    return r.RegionId
}

type SetUserMetricsResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result SetUserMetricsResult `json:"result"`
}

type SetUserMetricsResult struct {
}