// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type AddLiveAppRequest struct {

    core.JDCloudRequest

    /* 直播的推流域名  */
    PublishDomain string `json:"publishDomain"`

    /* 应用名称
- 取值: 数字字母中划线("-")下划线("_") 50个字符以内
  */
    AppName string `json:"appName"`
}

/*
 * param publishDomain: 直播的推流域名 (Required)
 * param appName: 应用名称
- 取值: 数字字母中划线("-")下划线("_") 50个字符以内
 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewAddLiveAppRequest(
    publishDomain string,
    appName string,
) *AddLiveAppRequest {

	return &AddLiveAppRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/apps",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        PublishDomain: publishDomain,
        AppName: appName,
	}
}

/*
 * param publishDomain: 直播的推流域名 (Required)
 * param appName: 应用名称
- 取值: 数字字母中划线("-")下划线("_") 50个字符以内
 (Required)
 */
func NewAddLiveAppRequestWithAllParams(
    publishDomain string,
    appName string,
) *AddLiveAppRequest {

    return &AddLiveAppRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/apps",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        PublishDomain: publishDomain,
        AppName: appName,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewAddLiveAppRequestWithoutParam() *AddLiveAppRequest {

    return &AddLiveAppRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/apps",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param publishDomain: 直播的推流域名(Required) */
func (r *AddLiveAppRequest) SetPublishDomain(publishDomain string) {
    r.PublishDomain = publishDomain
}

/* param appName: 应用名称
- 取值: 数字字母中划线("-")下划线("_") 50个字符以内
(Required) */
func (r *AddLiveAppRequest) SetAppName(appName string) {
    r.AppName = appName
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r AddLiveAppRequest) GetRegionId() string {
    return ""
}

type AddLiveAppResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result AddLiveAppResult `json:"result"`
}

type AddLiveAppResult struct {
}