// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type AddLiveDomainRequest struct {

    core.JDCloudRequest

    /* 直播的推流域名
- 不支持泛域名
  */
    PublishDomain string `json:"publishDomain"`

    /* 直播的播放域名
- 不支持泛域名
  */
    PlayDomain string `json:"playDomain"`
}

/*
 * param publishDomain: 直播的推流域名
- 不支持泛域名
 (Required)
 * param playDomain: 直播的播放域名
- 不支持泛域名
 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewAddLiveDomainRequest(
    publishDomain string,
    playDomain string,
) *AddLiveDomainRequest {

	return &AddLiveDomainRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/domains",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        PublishDomain: publishDomain,
        PlayDomain: playDomain,
	}
}

/*
 * param publishDomain: 直播的推流域名
- 不支持泛域名
 (Required)
 * param playDomain: 直播的播放域名
- 不支持泛域名
 (Required)
 */
func NewAddLiveDomainRequestWithAllParams(
    publishDomain string,
    playDomain string,
) *AddLiveDomainRequest {

    return &AddLiveDomainRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/domains",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        PublishDomain: publishDomain,
        PlayDomain: playDomain,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewAddLiveDomainRequestWithoutParam() *AddLiveDomainRequest {

    return &AddLiveDomainRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/domains",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param publishDomain: 直播的推流域名
- 不支持泛域名
(Required) */
func (r *AddLiveDomainRequest) SetPublishDomain(publishDomain string) {
    r.PublishDomain = publishDomain
}

/* param playDomain: 直播的播放域名
- 不支持泛域名
(Required) */
func (r *AddLiveDomainRequest) SetPlayDomain(playDomain string) {
    r.PlayDomain = playDomain
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r AddLiveDomainRequest) GetRegionId() string {
    return ""
}

type AddLiveDomainResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result AddLiveDomainResult `json:"result"`
}

type AddLiveDomainResult struct {
}