// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type AddLiveStreamDomainSnapshotRequest struct {

    core.JDCloudRequest

    /* 推流域名  */
    PublishDomain string `json:"publishDomain"`

    /* 截图模板
  */
    Template string `json:"template"`
}

/*
 * param publishDomain: 推流域名 (Required)
 * param template: 截图模板
 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewAddLiveStreamDomainSnapshotRequest(
    publishDomain string,
    template string,
) *AddLiveStreamDomainSnapshotRequest {

	return &AddLiveStreamDomainSnapshotRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/snapshotDomains:template",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        PublishDomain: publishDomain,
        Template: template,
	}
}

/*
 * param publishDomain: 推流域名 (Required)
 * param template: 截图模板
 (Required)
 */
func NewAddLiveStreamDomainSnapshotRequestWithAllParams(
    publishDomain string,
    template string,
) *AddLiveStreamDomainSnapshotRequest {

    return &AddLiveStreamDomainSnapshotRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/snapshotDomains:template",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        PublishDomain: publishDomain,
        Template: template,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewAddLiveStreamDomainSnapshotRequestWithoutParam() *AddLiveStreamDomainSnapshotRequest {

    return &AddLiveStreamDomainSnapshotRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/snapshotDomains:template",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param publishDomain: 推流域名(Required) */
func (r *AddLiveStreamDomainSnapshotRequest) SetPublishDomain(publishDomain string) {
    r.PublishDomain = publishDomain
}

/* param template: 截图模板
(Required) */
func (r *AddLiveStreamDomainSnapshotRequest) SetTemplate(template string) {
    r.Template = template
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r AddLiveStreamDomainSnapshotRequest) GetRegionId() string {
    return ""
}

type AddLiveStreamDomainSnapshotResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result AddLiveStreamDomainSnapshotResult `json:"result"`
}

type AddLiveStreamDomainSnapshotResult struct {
}