// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type CloseLiveTimeshiftRequest struct {

    core.JDCloudRequest

    /* 直播的播放域名  */
    PlayDomain string `json:"playDomain"`
}

/*
 * param playDomain: 直播的播放域名 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCloseLiveTimeshiftRequest(
    playDomain string,
) *CloseLiveTimeshiftRequest {

	return &CloseLiveTimeshiftRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/liveTimeshift:close",
			Method:  "PUT",
			Header:  nil,
			Version: "v1",
		},
        PlayDomain: playDomain,
	}
}

/*
 * param playDomain: 直播的播放域名 (Required)
 */
func NewCloseLiveTimeshiftRequestWithAllParams(
    playDomain string,
) *CloseLiveTimeshiftRequest {

    return &CloseLiveTimeshiftRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/liveTimeshift:close",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
        PlayDomain: playDomain,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCloseLiveTimeshiftRequestWithoutParam() *CloseLiveTimeshiftRequest {

    return &CloseLiveTimeshiftRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/liveTimeshift:close",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param playDomain: 直播的播放域名(Required) */
func (r *CloseLiveTimeshiftRequest) SetPlayDomain(playDomain string) {
    r.PlayDomain = playDomain
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CloseLiveTimeshiftRequest) GetRegionId() string {
    return ""
}

type CloseLiveTimeshiftResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CloseLiveTimeshiftResult `json:"result"`
}

type CloseLiveTimeshiftResult struct {
}