// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DeleteLiveRecordFilesRequest struct {

    core.JDCloudRequest

    /* 需要删除的录制文件ID，多个时以逗号（,）分隔
  */
    FileIds string `json:"fileIds"`
}

/*
 * param fileIds: 需要删除的录制文件ID，多个时以逗号（,）分隔
 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDeleteLiveRecordFilesRequest(
    fileIds string,
) *DeleteLiveRecordFilesRequest {

	return &DeleteLiveRecordFilesRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/recordFiles",
			Method:  "DELETE",
			Header:  nil,
			Version: "v1",
		},
        FileIds: fileIds,
	}
}

/*
 * param fileIds: 需要删除的录制文件ID，多个时以逗号（,）分隔
 (Required)
 */
func NewDeleteLiveRecordFilesRequestWithAllParams(
    fileIds string,
) *DeleteLiveRecordFilesRequest {

    return &DeleteLiveRecordFilesRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/recordFiles",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
        FileIds: fileIds,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDeleteLiveRecordFilesRequestWithoutParam() *DeleteLiveRecordFilesRequest {

    return &DeleteLiveRecordFilesRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/recordFiles",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param fileIds: 需要删除的录制文件ID，多个时以逗号（,）分隔
(Required) */
func (r *DeleteLiveRecordFilesRequest) SetFileIds(fileIds string) {
    r.FileIds = fileIds
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DeleteLiveRecordFilesRequest) GetRegionId() string {
    return ""
}

type DeleteLiveRecordFilesResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DeleteLiveRecordFilesResult `json:"result"`
}

type DeleteLiveRecordFilesResult struct {
}