// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    live "github.com/jdcloud-api/jdcloud-sdk-go/services/live/models"
    common "github.com/jdcloud-api/jdcloud-sdk-go/services/common/models"
)

type DescribeCustomLiveStreamSnapshotConfigRequest struct {

    core.JDCloudRequest

    /* 页码
- 取值范围 [1, 100000]
 (Optional) */
    PageNum *int `json:"pageNum"`

    /* 分页大小
- 取值范围 [10, 100]
 (Optional) */
    PageSize *int `json:"pageSize"`

    /* 直播截图查询过滤条件:
- name:   publishDomain 必填(推流域名)
- value:  参数
- name:   appName 必填(应用名称)
- value:  参数
- name:   streamName 非必填(流名称)
- value:  参数
 (Optional) */
    Filters []common.Filter `json:"filters"`
}

/*
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeCustomLiveStreamSnapshotConfigRequest(
) *DescribeCustomLiveStreamSnapshotConfigRequest {

	return &DescribeCustomLiveStreamSnapshotConfigRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/snapshotCustoms:config",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
	}
}

/*
 * param pageNum: 页码
- 取值范围 [1, 100000]
 (Optional)
 * param pageSize: 分页大小
- 取值范围 [10, 100]
 (Optional)
 * param filters: 直播截图查询过滤条件:
- name:   publishDomain 必填(推流域名)
- value:  参数
- name:   appName 必填(应用名称)
- value:  参数
- name:   streamName 非必填(流名称)
- value:  参数
 (Optional)
 */
func NewDescribeCustomLiveStreamSnapshotConfigRequestWithAllParams(
    pageNum *int,
    pageSize *int,
    filters []common.Filter,
) *DescribeCustomLiveStreamSnapshotConfigRequest {

    return &DescribeCustomLiveStreamSnapshotConfigRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/snapshotCustoms:config",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        PageNum: pageNum,
        PageSize: pageSize,
        Filters: filters,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeCustomLiveStreamSnapshotConfigRequestWithoutParam() *DescribeCustomLiveStreamSnapshotConfigRequest {

    return &DescribeCustomLiveStreamSnapshotConfigRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/snapshotCustoms:config",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param pageNum: 页码
- 取值范围 [1, 100000]
(Optional) */
func (r *DescribeCustomLiveStreamSnapshotConfigRequest) SetPageNum(pageNum int) {
    r.PageNum = &pageNum
}

/* param pageSize: 分页大小
- 取值范围 [10, 100]
(Optional) */
func (r *DescribeCustomLiveStreamSnapshotConfigRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

/* param filters: 直播截图查询过滤条件:
- name:   publishDomain 必填(推流域名)
- value:  参数
- name:   appName 必填(应用名称)
- value:  参数
- name:   streamName 非必填(流名称)
- value:  参数
(Optional) */
func (r *DescribeCustomLiveStreamSnapshotConfigRequest) SetFilters(filters []common.Filter) {
    r.Filters = filters
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeCustomLiveStreamSnapshotConfigRequest) GetRegionId() string {
    return ""
}

type DescribeCustomLiveStreamSnapshotConfigResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeCustomLiveStreamSnapshotConfigResult `json:"result"`
}

type DescribeCustomLiveStreamSnapshotConfigResult struct {
    PageNumber int `json:"pageNumber"`
    PageSize int `json:"pageSize"`
    TotalCount int `json:"totalCount"`
    SnapshotConfigs []live.SnapshotConfig `json:"snapshotConfigs"`
}