// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DescribeCustomLiveStreamTranscodeTemplateRequest struct {

    core.JDCloudRequest

    /* 转码模板  */
    Template string `json:"template"`
}

/*
 * param template: 转码模板 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeCustomLiveStreamTranscodeTemplateRequest(
    template string,
) *DescribeCustomLiveStreamTranscodeTemplateRequest {

	return &DescribeCustomLiveStreamTranscodeTemplateRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/transcodeCustoms/{template}",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        Template: template,
	}
}

/*
 * param template: 转码模板 (Required)
 */
func NewDescribeCustomLiveStreamTranscodeTemplateRequestWithAllParams(
    template string,
) *DescribeCustomLiveStreamTranscodeTemplateRequest {

    return &DescribeCustomLiveStreamTranscodeTemplateRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/transcodeCustoms/{template}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        Template: template,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeCustomLiveStreamTranscodeTemplateRequestWithoutParam() *DescribeCustomLiveStreamTranscodeTemplateRequest {

    return &DescribeCustomLiveStreamTranscodeTemplateRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/transcodeCustoms/{template}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param template: 转码模板(Required) */
func (r *DescribeCustomLiveStreamTranscodeTemplateRequest) SetTemplate(template string) {
    r.Template = template
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeCustomLiveStreamTranscodeTemplateRequest) GetRegionId() string {
    return ""
}

type DescribeCustomLiveStreamTranscodeTemplateResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeCustomLiveStreamTranscodeTemplateResult `json:"result"`
}

type DescribeCustomLiveStreamTranscodeTemplateResult struct {
    VideoCodeRate int `json:"videoCodeRate"`
    VideoFrameRate string `json:"videoFrameRate"`
    Width int `json:"width"`
    Height int `json:"height"`
    Template string `json:"template"`
    AudioCodec string `json:"audioCodec"`
    AudioFormat string `json:"audioFormat"`
    AudioSampleRate int `json:"audioSampleRate"`
    AudioChannel int `json:"audioChannel"`
    AudioCodeRate int `json:"audioCodeRate"`
}