// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    live "github.com/jdcloud-api/jdcloud-sdk-go/services/live/models"
    common "github.com/jdcloud-api/jdcloud-sdk-go/services/common/models"
)

type DescribeCustomLiveStreamTranscodeTemplatesRequest struct {

    core.JDCloudRequest

    /* 页码
- 取值范围 [1, 100000]
 (Optional) */
    PageNum *int `json:"pageNum"`

    /* 分页大小
- 取值范围 [10, 100]
 (Optional) */
    PageSize *int `json:"pageSize"`

    /* 转码模板查询过滤条件:
  - name:   template 录制模板自定义名称
  - value:  如果参数为空，则查询全部
  - 如果为空,则表示查询该用下所有自定义的转码模板
 (Optional) */
    Filters []common.Filter `json:"filters"`
}

/*
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeCustomLiveStreamTranscodeTemplatesRequest(
) *DescribeCustomLiveStreamTranscodeTemplatesRequest {

	return &DescribeCustomLiveStreamTranscodeTemplatesRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/transcodeCustoms",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
	}
}

/*
 * param pageNum: 页码
- 取值范围 [1, 100000]
 (Optional)
 * param pageSize: 分页大小
- 取值范围 [10, 100]
 (Optional)
 * param filters: 转码模板查询过滤条件:
  - name:   template 录制模板自定义名称
  - value:  如果参数为空，则查询全部
  - 如果为空,则表示查询该用下所有自定义的转码模板
 (Optional)
 */
func NewDescribeCustomLiveStreamTranscodeTemplatesRequestWithAllParams(
    pageNum *int,
    pageSize *int,
    filters []common.Filter,
) *DescribeCustomLiveStreamTranscodeTemplatesRequest {

    return &DescribeCustomLiveStreamTranscodeTemplatesRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/transcodeCustoms",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        PageNum: pageNum,
        PageSize: pageSize,
        Filters: filters,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeCustomLiveStreamTranscodeTemplatesRequestWithoutParam() *DescribeCustomLiveStreamTranscodeTemplatesRequest {

    return &DescribeCustomLiveStreamTranscodeTemplatesRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/transcodeCustoms",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param pageNum: 页码
- 取值范围 [1, 100000]
(Optional) */
func (r *DescribeCustomLiveStreamTranscodeTemplatesRequest) SetPageNum(pageNum int) {
    r.PageNum = &pageNum
}

/* param pageSize: 分页大小
- 取值范围 [10, 100]
(Optional) */
func (r *DescribeCustomLiveStreamTranscodeTemplatesRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

/* param filters: 转码模板查询过滤条件:
  - name:   template 录制模板自定义名称
  - value:  如果参数为空，则查询全部
  - 如果为空,则表示查询该用下所有自定义的转码模板
(Optional) */
func (r *DescribeCustomLiveStreamTranscodeTemplatesRequest) SetFilters(filters []common.Filter) {
    r.Filters = filters
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeCustomLiveStreamTranscodeTemplatesRequest) GetRegionId() string {
    return ""
}

type DescribeCustomLiveStreamTranscodeTemplatesResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeCustomLiveStreamTranscodeTemplatesResult `json:"result"`
}

type DescribeCustomLiveStreamTranscodeTemplatesResult struct {
    PageNumber int `json:"pageNumber"`
    PageSize int `json:"pageSize"`
    TotalCount int `json:"totalCount"`
    TranscodeTemplates []live.TranscodeInfo `json:"transcodeTemplates"`
}