// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    live "github.com/jdcloud-api/jdcloud-sdk-go/services/live/models"
)

type DescribeLiveFileStorageDataRequest struct {

    core.JDCloudRequest

    /* 查询周期，取值范围：“day,month,year,followTime”，分别表示1天，1月，1年，跟随时间。默认为空，表示day。当传入followTime时，表示按Endtime-StartTime的周期，只返回一个点
 (Optional) */
    Period *string `json:"period"`

    /* 查询起始时间，UTC时间，格式：yyyy-MM-dd'T'HH:mm:ss'Z'
  */
    StartTime string `json:"startTime"`

    /* 查询截至时间，UTC时间，格式：yyyy-MM-dd'T'HH:mm:ss'Z'，为空时默认为当前时间
 (Optional) */
    EndTime *string `json:"endTime"`
}

/*
 * param startTime: 查询起始时间，UTC时间，格式：yyyy-MM-dd'T'HH:mm:ss'Z'
 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeLiveFileStorageDataRequest(
    startTime string,
) *DescribeLiveFileStorageDataRequest {

	return &DescribeLiveFileStorageDataRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/describeLiveFileStorageData",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        StartTime: startTime,
	}
}

/*
 * param period: 查询周期，取值范围：“day,month,year,followTime”，分别表示1天，1月，1年，跟随时间。默认为空，表示day。当传入followTime时，表示按Endtime-StartTime的周期，只返回一个点
 (Optional)
 * param startTime: 查询起始时间，UTC时间，格式：yyyy-MM-dd'T'HH:mm:ss'Z'
 (Required)
 * param endTime: 查询截至时间，UTC时间，格式：yyyy-MM-dd'T'HH:mm:ss'Z'，为空时默认为当前时间
 (Optional)
 */
func NewDescribeLiveFileStorageDataRequestWithAllParams(
    period *string,
    startTime string,
    endTime *string,
) *DescribeLiveFileStorageDataRequest {

    return &DescribeLiveFileStorageDataRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/describeLiveFileStorageData",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        Period: period,
        StartTime: startTime,
        EndTime: endTime,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeLiveFileStorageDataRequestWithoutParam() *DescribeLiveFileStorageDataRequest {

    return &DescribeLiveFileStorageDataRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/describeLiveFileStorageData",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param period: 查询周期，取值范围：“day,month,year,followTime”，分别表示1天，1月，1年，跟随时间。默认为空，表示day。当传入followTime时，表示按Endtime-StartTime的周期，只返回一个点
(Optional) */
func (r *DescribeLiveFileStorageDataRequest) SetPeriod(period string) {
    r.Period = &period
}

/* param startTime: 查询起始时间，UTC时间，格式：yyyy-MM-dd'T'HH:mm:ss'Z'
(Required) */
func (r *DescribeLiveFileStorageDataRequest) SetStartTime(startTime string) {
    r.StartTime = startTime
}

/* param endTime: 查询截至时间，UTC时间，格式：yyyy-MM-dd'T'HH:mm:ss'Z'，为空时默认为当前时间
(Optional) */
func (r *DescribeLiveFileStorageDataRequest) SetEndTime(endTime string) {
    r.EndTime = &endTime
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeLiveFileStorageDataRequest) GetRegionId() string {
    return ""
}

type DescribeLiveFileStorageDataResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeLiveFileStorageDataResult `json:"result"`
}

type DescribeLiveFileStorageDataResult struct {
    DataList []live.FileStorageStatisticResult `json:"dataList"`
}