// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DescribeLiveSnapshotUrlRequest struct {

    core.JDCloudRequest

    /* 截图ID
  */
    ImgId string `json:"imgId"`

    /* 地址有效期，单位：秒，默认：3600，最大支持7天
 (Optional) */
    AuthExpire *int `json:"authExpire"`
}

/*
 * param imgId: 截图ID
 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeLiveSnapshotUrlRequest(
    imgId string,
) *DescribeLiveSnapshotUrlRequest {

	return &DescribeLiveSnapshotUrlRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/snapshots/{imgId}:url",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        ImgId: imgId,
	}
}

/*
 * param imgId: 截图ID
 (Required)
 * param authExpire: 地址有效期，单位：秒，默认：3600，最大支持7天
 (Optional)
 */
func NewDescribeLiveSnapshotUrlRequestWithAllParams(
    imgId string,
    authExpire *int,
) *DescribeLiveSnapshotUrlRequest {

    return &DescribeLiveSnapshotUrlRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/snapshots/{imgId}:url",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        ImgId: imgId,
        AuthExpire: authExpire,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeLiveSnapshotUrlRequestWithoutParam() *DescribeLiveSnapshotUrlRequest {

    return &DescribeLiveSnapshotUrlRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/snapshots/{imgId}:url",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param imgId: 截图ID
(Required) */
func (r *DescribeLiveSnapshotUrlRequest) SetImgId(imgId string) {
    r.ImgId = imgId
}

/* param authExpire: 地址有效期，单位：秒，默认：3600，最大支持7天
(Optional) */
func (r *DescribeLiveSnapshotUrlRequest) SetAuthExpire(authExpire int) {
    r.AuthExpire = &authExpire
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeLiveSnapshotUrlRequest) GetRegionId() string {
    return ""
}

type DescribeLiveSnapshotUrlResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeLiveSnapshotUrlResult `json:"result"`
}

type DescribeLiveSnapshotUrlResult struct {
    ImgId string `json:"imgId"`
    ImgUrl string `json:"imgUrl"`
}