// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    live "github.com/jdcloud-api/jdcloud-sdk-go/services/live/models"
)

type DescribeLiveTimeshiftConfigsRequest struct {

    core.JDCloudRequest

    /* 页码
- 取值范围[1, 100000]
 (Optional) */
    PageNumber *int `json:"pageNumber"`

    /* 分页大小
- 取值范围[10, 100]
 (Optional) */
    PageSize *int `json:"pageSize"`

    /* 直播的播放域名
- 目前仅支持精确匹配
  */
    PlayDomain string `json:"playDomain"`
}

/*
 * param playDomain: 直播的播放域名
- 目前仅支持精确匹配
 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeLiveTimeshiftConfigsRequest(
    playDomain string,
) *DescribeLiveTimeshiftConfigsRequest {

	return &DescribeLiveTimeshiftConfigsRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/liveTimeshift:configs",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        PlayDomain: playDomain,
	}
}

/*
 * param pageNumber: 页码
- 取值范围[1, 100000]
 (Optional)
 * param pageSize: 分页大小
- 取值范围[10, 100]
 (Optional)
 * param playDomain: 直播的播放域名
- 目前仅支持精确匹配
 (Required)
 */
func NewDescribeLiveTimeshiftConfigsRequestWithAllParams(
    pageNumber *int,
    pageSize *int,
    playDomain string,
) *DescribeLiveTimeshiftConfigsRequest {

    return &DescribeLiveTimeshiftConfigsRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/liveTimeshift:configs",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        PageNumber: pageNumber,
        PageSize: pageSize,
        PlayDomain: playDomain,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeLiveTimeshiftConfigsRequestWithoutParam() *DescribeLiveTimeshiftConfigsRequest {

    return &DescribeLiveTimeshiftConfigsRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/liveTimeshift:configs",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param pageNumber: 页码
- 取值范围[1, 100000]
(Optional) */
func (r *DescribeLiveTimeshiftConfigsRequest) SetPageNumber(pageNumber int) {
    r.PageNumber = &pageNumber
}

/* param pageSize: 分页大小
- 取值范围[10, 100]
(Optional) */
func (r *DescribeLiveTimeshiftConfigsRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

/* param playDomain: 直播的播放域名
- 目前仅支持精确匹配
(Required) */
func (r *DescribeLiveTimeshiftConfigsRequest) SetPlayDomain(playDomain string) {
    r.PlayDomain = playDomain
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeLiveTimeshiftConfigsRequest) GetRegionId() string {
    return ""
}

type DescribeLiveTimeshiftConfigsResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeLiveTimeshiftConfigsResult `json:"result"`
}

type DescribeLiveTimeshiftConfigsResult struct {
    PageNumber int `json:"pageNumber"`
    PageSize int `json:"pageSize"`
    TotalCount int `json:"totalCount"`
    TimeshiftConfigs []live.TimeshiftConfig `json:"timeshiftConfigs"`
}