// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    live "github.com/jdcloud-api/jdcloud-sdk-go/services/live/models"
)

type DescribeLiveTranscodeStreamListRequest struct {

    core.JDCloudRequest

    /* 推流域名
  */
    DomainName string `json:"domainName"`

    /* 应用名称
  */
    AppName string `json:"appName"`

    /* 流名称
  */
    StreamName string `json:"streamName"`
}

/*
 * param domainName: 推流域名
 (Required)
 * param appName: 应用名称
 (Required)
 * param streamName: 流名称
 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeLiveTranscodeStreamListRequest(
    domainName string,
    appName string,
    streamName string,
) *DescribeLiveTranscodeStreamListRequest {

	return &DescribeLiveTranscodeStreamListRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/describeLiveTranscodeStreamList",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        DomainName: domainName,
        AppName: appName,
        StreamName: streamName,
	}
}

/*
 * param domainName: 推流域名
 (Required)
 * param appName: 应用名称
 (Required)
 * param streamName: 流名称
 (Required)
 */
func NewDescribeLiveTranscodeStreamListRequestWithAllParams(
    domainName string,
    appName string,
    streamName string,
) *DescribeLiveTranscodeStreamListRequest {

    return &DescribeLiveTranscodeStreamListRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/describeLiveTranscodeStreamList",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        DomainName: domainName,
        AppName: appName,
        StreamName: streamName,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeLiveTranscodeStreamListRequestWithoutParam() *DescribeLiveTranscodeStreamListRequest {

    return &DescribeLiveTranscodeStreamListRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/describeLiveTranscodeStreamList",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param domainName: 推流域名
(Required) */
func (r *DescribeLiveTranscodeStreamListRequest) SetDomainName(domainName string) {
    r.DomainName = domainName
}

/* param appName: 应用名称
(Required) */
func (r *DescribeLiveTranscodeStreamListRequest) SetAppName(appName string) {
    r.AppName = appName
}

/* param streamName: 流名称
(Required) */
func (r *DescribeLiveTranscodeStreamListRequest) SetStreamName(streamName string) {
    r.StreamName = streamName
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeLiveTranscodeStreamListRequest) GetRegionId() string {
    return ""
}

type DescribeLiveTranscodeStreamListResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeLiveTranscodeStreamListResult `json:"result"`
}

type DescribeLiveTranscodeStreamListResult struct {
    DataList []live.LiveTranscodeStreamResult `json:"dataList"`
}