// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type SetLivePlayAuthKeyRequest struct {

    core.JDCloudRequest

    /* 播放域名  */
    PlayDomain string `json:"playDomain"`

    /* 播放鉴权状态
  on: 开启
  off: 关闭
- 当推流鉴权状态on(开启)时,authKey不能为空
 (Optional) */
    AuthStatus *string `json:"authStatus"`

    /* 播放鉴权key
- 取值: 支持大小写字母和数字 长度6-32位
 (Optional) */
    AuthKey *string `json:"authKey"`
}

/*
 * param playDomain: 播放域名 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewSetLivePlayAuthKeyRequest(
    playDomain string,
) *SetLivePlayAuthKeyRequest {

	return &SetLivePlayAuthKeyRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/livePlayAuthKey",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        PlayDomain: playDomain,
	}
}

/*
 * param playDomain: 播放域名 (Required)
 * param authStatus: 播放鉴权状态
  on: 开启
  off: 关闭
- 当推流鉴权状态on(开启)时,authKey不能为空
 (Optional)
 * param authKey: 播放鉴权key
- 取值: 支持大小写字母和数字 长度6-32位
 (Optional)
 */
func NewSetLivePlayAuthKeyRequestWithAllParams(
    playDomain string,
    authStatus *string,
    authKey *string,
) *SetLivePlayAuthKeyRequest {

    return &SetLivePlayAuthKeyRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/livePlayAuthKey",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        PlayDomain: playDomain,
        AuthStatus: authStatus,
        AuthKey: authKey,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewSetLivePlayAuthKeyRequestWithoutParam() *SetLivePlayAuthKeyRequest {

    return &SetLivePlayAuthKeyRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/livePlayAuthKey",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param playDomain: 播放域名(Required) */
func (r *SetLivePlayAuthKeyRequest) SetPlayDomain(playDomain string) {
    r.PlayDomain = playDomain
}

/* param authStatus: 播放鉴权状态
  on: 开启
  off: 关闭
- 当推流鉴权状态on(开启)时,authKey不能为空
(Optional) */
func (r *SetLivePlayAuthKeyRequest) SetAuthStatus(authStatus string) {
    r.AuthStatus = &authStatus
}

/* param authKey: 播放鉴权key
- 取值: 支持大小写字母和数字 长度6-32位
(Optional) */
func (r *SetLivePlayAuthKeyRequest) SetAuthKey(authKey string) {
    r.AuthKey = &authKey
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r SetLivePlayAuthKeyRequest) GetRegionId() string {
    return ""
}

type SetLivePlayAuthKeyResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result SetLivePlayAuthKeyResult `json:"result"`
}

type SetLivePlayAuthKeyResult struct {
}