// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type ModifySecurityIpsRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* Instance ID  */
    InstanceId string `json:"instanceId"`

    /* 修改方式,Add 增加白名单,Delete 删除白名单.  */
    ModifyMode string `json:"modifyMode"`

    /* IP白名单分组下的IP列表，最多45个以逗号隔开，格式如下：0.0.0.0/0，10.23.12.24（IP），或者10.23.12.24/24（CIDR模式，无类域间路由，/24表示了地址中前缀的长度，范围[1，32]）。  */
    SecurityIps string `json:"securityIps"`
}

/*
 * param regionId: Region ID (Required)
 * param instanceId: Instance ID (Required)
 * param modifyMode: 修改方式,Add 增加白名单,Delete 删除白名单. (Required)
 * param securityIps: IP白名单分组下的IP列表，最多45个以逗号隔开，格式如下：0.0.0.0/0，10.23.12.24（IP），或者10.23.12.24/24（CIDR模式，无类域间路由，/24表示了地址中前缀的长度，范围[1，32]）。 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewModifySecurityIpsRequest(
    regionId string,
    instanceId string,
    modifyMode string,
    securityIps string,
) *ModifySecurityIpsRequest {

	return &ModifySecurityIpsRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/instances/{instanceId}/securityIps",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        InstanceId: instanceId,
        ModifyMode: modifyMode,
        SecurityIps: securityIps,
	}
}

/*
 * param regionId: Region ID (Required)
 * param instanceId: Instance ID (Required)
 * param modifyMode: 修改方式,Add 增加白名单,Delete 删除白名单. (Required)
 * param securityIps: IP白名单分组下的IP列表，最多45个以逗号隔开，格式如下：0.0.0.0/0，10.23.12.24（IP），或者10.23.12.24/24（CIDR模式，无类域间路由，/24表示了地址中前缀的长度，范围[1，32]）。 (Required)
 */
func NewModifySecurityIpsRequestWithAllParams(
    regionId string,
    instanceId string,
    modifyMode string,
    securityIps string,
) *ModifySecurityIpsRequest {

    return &ModifySecurityIpsRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}/securityIps",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        InstanceId: instanceId,
        ModifyMode: modifyMode,
        SecurityIps: securityIps,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewModifySecurityIpsRequestWithoutParam() *ModifySecurityIpsRequest {

    return &ModifySecurityIpsRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}/securityIps",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *ModifySecurityIpsRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param instanceId: Instance ID(Required) */
func (r *ModifySecurityIpsRequest) SetInstanceId(instanceId string) {
    r.InstanceId = instanceId
}

/* param modifyMode: 修改方式,Add 增加白名单,Delete 删除白名单.(Required) */
func (r *ModifySecurityIpsRequest) SetModifyMode(modifyMode string) {
    r.ModifyMode = modifyMode
}

/* param securityIps: IP白名单分组下的IP列表，最多45个以逗号隔开，格式如下：0.0.0.0/0，10.23.12.24（IP），或者10.23.12.24/24（CIDR模式，无类域间路由，/24表示了地址中前缀的长度，范围[1，32]）。(Required) */
func (r *ModifySecurityIpsRequest) SetSecurityIps(securityIps string) {
    r.SecurityIps = securityIps
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ModifySecurityIpsRequest) GetRegionId() string {
    return r.RegionId
}

type ModifySecurityIpsResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ModifySecurityIpsResult `json:"result"`
}

type ModifySecurityIpsResult struct {
}