// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DeleteAlarmsRequest struct {

    core.JDCloudRequest

    /* 地域 Id  */
    RegionId string `json:"regionId"`

    /* 待删除的规则id，用竖线分隔  */
    Ids string `json:"ids"`
}

/*
 * param regionId: 地域 Id (Required)
 * param ids: 待删除的规则id，用竖线分隔 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDeleteAlarmsRequest(
    regionId string,
    ids string,
) *DeleteAlarmsRequest {

	return &DeleteAlarmsRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/alarms",
			Method:  "DELETE",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Ids: ids,
	}
}

/*
 * param regionId: 地域 Id (Required)
 * param ids: 待删除的规则id，用竖线分隔 (Required)
 */
func NewDeleteAlarmsRequestWithAllParams(
    regionId string,
    ids string,
) *DeleteAlarmsRequest {

    return &DeleteAlarmsRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/alarms",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Ids: ids,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDeleteAlarmsRequestWithoutParam() *DeleteAlarmsRequest {

    return &DeleteAlarmsRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/alarms",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域 Id(Required) */
func (r *DeleteAlarmsRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param ids: 待删除的规则id，用竖线分隔(Required) */
func (r *DeleteAlarmsRequest) SetIds(ids string) {
    r.Ids = ids
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DeleteAlarmsRequest) GetRegionId() string {
    return r.RegionId
}

type DeleteAlarmsResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DeleteAlarmsResult `json:"result"`
}

type DeleteAlarmsResult struct {
}