// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DisableAlarmRequest struct {

    core.JDCloudRequest

    /* region  */
    RegionId string `json:"regionId"`

    /* 规则 id  */
    AlarmId string `json:"alarmId"`
}

/*
 * param regionId: region (Required)
 * param alarmId: 规则 id (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDisableAlarmRequest(
    regionId string,
    alarmId string,
) *DisableAlarmRequest {

	return &DisableAlarmRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/alarms/{alarmId}/disable",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        AlarmId: alarmId,
	}
}

/*
 * param regionId: region (Required)
 * param alarmId: 规则 id (Required)
 */
func NewDisableAlarmRequestWithAllParams(
    regionId string,
    alarmId string,
) *DisableAlarmRequest {

    return &DisableAlarmRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/alarms/{alarmId}/disable",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        AlarmId: alarmId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDisableAlarmRequestWithoutParam() *DisableAlarmRequest {

    return &DisableAlarmRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/alarms/{alarmId}/disable",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: region(Required) */
func (r *DisableAlarmRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param alarmId: 规则 id(Required) */
func (r *DisableAlarmRequest) SetAlarmId(alarmId string) {
    r.AlarmId = alarmId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DisableAlarmRequest) GetRegionId() string {
    return r.RegionId
}

type DisableAlarmResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DisableAlarmResult `json:"result"`
}

type DisableAlarmResult struct {
}