// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type SetStyleDelimiterRequest struct {

    core.JDCloudRequest

    /* 区域ID  */
    RegionId string `json:"regionId"`

    /* Bucket名称  */
    BucketName string `json:"bucketName"`

    /* 图片样式分隔符配置（JSON数组）；支持的分隔符包含：["-", "_", "/", "!"]  */
    Delimiters []string `json:"delimiters"`
}

/*
 * param regionId: 区域ID (Required)
 * param bucketName: Bucket名称 (Required)
 * param delimiters: 图片样式分隔符配置（JSON数组）；支持的分隔符包含：["-", "_", "/", "!"] (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewSetStyleDelimiterRequest(
    regionId string,
    bucketName string,
    delimiters []string,
) *SetStyleDelimiterRequest {

	return &SetStyleDelimiterRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/buckets/{bucketName}/styleDelimiter/",
			Method:  "PUT",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        BucketName: bucketName,
        Delimiters: delimiters,
	}
}

/*
 * param regionId: 区域ID (Required)
 * param bucketName: Bucket名称 (Required)
 * param delimiters: 图片样式分隔符配置（JSON数组）；支持的分隔符包含：["-", "_", "/", "!"] (Required)
 */
func NewSetStyleDelimiterRequestWithAllParams(
    regionId string,
    bucketName string,
    delimiters []string,
) *SetStyleDelimiterRequest {

    return &SetStyleDelimiterRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/buckets/{bucketName}/styleDelimiter/",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        BucketName: bucketName,
        Delimiters: delimiters,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewSetStyleDelimiterRequestWithoutParam() *SetStyleDelimiterRequest {

    return &SetStyleDelimiterRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/buckets/{bucketName}/styleDelimiter/",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 区域ID(Required) */
func (r *SetStyleDelimiterRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param bucketName: Bucket名称(Required) */
func (r *SetStyleDelimiterRequest) SetBucketName(bucketName string) {
    r.BucketName = bucketName
}

/* param delimiters: 图片样式分隔符配置（JSON数组）；支持的分隔符包含：["-", "_", "/", "!"](Required) */
func (r *SetStyleDelimiterRequest) SetDelimiters(delimiters []string) {
    r.Delimiters = delimiters
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r SetStyleDelimiterRequest) GetRegionId() string {
    return r.RegionId
}

type SetStyleDelimiterResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result SetStyleDelimiterResult `json:"result"`
}

type SetStyleDelimiterResult struct {
}