// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type ModifyContainerAttributeRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* Container ID  */
    ContainerId string `json:"containerId"`

    /* 容器名称 (Optional) */
    Name *string `json:"name"`

    /* 容器描述；和description必须要指定一个 (Optional) */
    Description *string `json:"description"`
}

/*
 * param regionId: Region ID (Required)
 * param containerId: Container ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewModifyContainerAttributeRequest(
    regionId string,
    containerId string,
) *ModifyContainerAttributeRequest {

	return &ModifyContainerAttributeRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/containers/{containerId}:modifyContainerAttribute",
			Method:  "PATCH",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        ContainerId: containerId,
	}
}

/*
 * param regionId: Region ID (Required)
 * param containerId: Container ID (Required)
 * param name: 容器名称 (Optional)
 * param description: 容器描述；和description必须要指定一个 (Optional)
 */
func NewModifyContainerAttributeRequestWithAllParams(
    regionId string,
    containerId string,
    name *string,
    description *string,
) *ModifyContainerAttributeRequest {

    return &ModifyContainerAttributeRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/containers/{containerId}:modifyContainerAttribute",
            Method:  "PATCH",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        ContainerId: containerId,
        Name: name,
        Description: description,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewModifyContainerAttributeRequestWithoutParam() *ModifyContainerAttributeRequest {

    return &ModifyContainerAttributeRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/containers/{containerId}:modifyContainerAttribute",
            Method:  "PATCH",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *ModifyContainerAttributeRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param containerId: Container ID(Required) */
func (r *ModifyContainerAttributeRequest) SetContainerId(containerId string) {
    r.ContainerId = containerId
}

/* param name: 容器名称(Optional) */
func (r *ModifyContainerAttributeRequest) SetName(name string) {
    r.Name = &name
}

/* param description: 容器描述；和description必须要指定一个(Optional) */
func (r *ModifyContainerAttributeRequest) SetDescription(description string) {
    r.Description = &description
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ModifyContainerAttributeRequest) GetRegionId() string {
    return r.RegionId
}

type ModifyContainerAttributeResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ModifyContainerAttributeResult `json:"result"`
}

type ModifyContainerAttributeResult struct {
}