// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    ossopenapi "github.com/jdcloud-api/jdcloud-sdk-go/services/ossopenapi/models"
)

type PutBackSourceConfigurationRequest struct {

    core.JDCloudRequest

    /* 区域ID  */
    RegionId string `json:"regionId"`

    /* Bucket名称  */
    BucketName string `json:"bucketName"`

    /* 回源配置规则 (Optional) */
    BackSourceRules []ossopenapi.BackSourceRule `json:"backSourceRules"`
}

/*
 * param regionId: 区域ID (Required)
 * param bucketName: Bucket名称 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewPutBackSourceConfigurationRequest(
    regionId string,
    bucketName string,
) *PutBackSourceConfigurationRequest {

	return &PutBackSourceConfigurationRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/buckets/{bucketName}/backSource",
			Method:  "PUT",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        BucketName: bucketName,
	}
}

/*
 * param regionId: 区域ID (Required)
 * param bucketName: Bucket名称 (Required)
 * param backSourceRules: 回源配置规则 (Optional)
 */
func NewPutBackSourceConfigurationRequestWithAllParams(
    regionId string,
    bucketName string,
    backSourceRules []ossopenapi.BackSourceRule,
) *PutBackSourceConfigurationRequest {

    return &PutBackSourceConfigurationRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/buckets/{bucketName}/backSource",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        BucketName: bucketName,
        BackSourceRules: backSourceRules,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewPutBackSourceConfigurationRequestWithoutParam() *PutBackSourceConfigurationRequest {

    return &PutBackSourceConfigurationRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/buckets/{bucketName}/backSource",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 区域ID(Required) */
func (r *PutBackSourceConfigurationRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param bucketName: Bucket名称(Required) */
func (r *PutBackSourceConfigurationRequest) SetBucketName(bucketName string) {
    r.BucketName = bucketName
}

/* param backSourceRules: 回源配置规则(Optional) */
func (r *PutBackSourceConfigurationRequest) SetBackSourceRules(backSourceRules []ossopenapi.BackSourceRule) {
    r.BackSourceRules = backSourceRules
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r PutBackSourceConfigurationRequest) GetRegionId() string {
    return r.RegionId
}

type PutBackSourceConfigurationResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result PutBackSourceConfigurationResult `json:"result"`
}

type PutBackSourceConfigurationResult struct {
}