// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package client

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    ossopenapi "github.com/jdcloud-api/jdcloud-sdk-go/services/ossopenapi/apis"
    "encoding/json"
    "errors"
)

type OssopenapiClient struct {
    core.JDCloudClient
}

func NewOssopenapiClient(credential *core.Credential) *OssopenapiClient {
    if credential == nil {
        return nil
    }

    config := core.NewConfig()
    config.SetEndpoint("ossopenapi.jdcloud-api.com")

    return &OssopenapiClient{
        core.JDCloudClient{
            Credential:  *credential,
            Config:      *config,
            ServiceName: "ossopenapi",
            Revision:    "0.4.5",
            Logger:      core.NewDefaultLogger(core.LogInfo),
        }}
}

func (c *OssopenapiClient) SetConfig(config *core.Config) {
    c.Config = *config
}

func (c *OssopenapiClient) SetLogger(logger core.Logger) {
    c.Logger = logger
}

/* 获取回源配置 */
func (c *OssopenapiClient) GetBackSourceConfiguration(request *ossopenapi.GetBackSourceConfigurationRequest) (*ossopenapi.GetBackSourceConfigurationResponse, error) {
    if request == nil {
        return nil, errors.New("Request object is nil. ")
    }
    resp, err := c.Send(request, c.ServiceName)
    if err != nil {
        return nil, err
    }

    jdResp := &ossopenapi.GetBackSourceConfigurationResponse{}
    err = json.Unmarshal(resp, jdResp)
    if err != nil {
        c.Logger.Log(core.LogError, "Unmarshal json failed, resp: %s", string(resp))
        return nil, err
    }

    return jdResp, err
}

/* 添加修改回源配置 */
func (c *OssopenapiClient) PutBackSourceConfiguration(request *ossopenapi.PutBackSourceConfigurationRequest) (*ossopenapi.PutBackSourceConfigurationResponse, error) {
    if request == nil {
        return nil, errors.New("Request object is nil. ")
    }
    resp, err := c.Send(request, c.ServiceName)
    if err != nil {
        return nil, err
    }

    jdResp := &ossopenapi.PutBackSourceConfigurationResponse{}
    err = json.Unmarshal(resp, jdResp)
    if err != nil {
        c.Logger.Log(core.LogError, "Unmarshal json failed, resp: %s", string(resp))
        return nil, err
    }

    return jdResp, err
}

/* 删除回源配置 */
func (c *OssopenapiClient) DeleteBackSourceConfiguration(request *ossopenapi.DeleteBackSourceConfigurationRequest) (*ossopenapi.DeleteBackSourceConfigurationResponse, error) {
    if request == nil {
        return nil, errors.New("Request object is nil. ")
    }
    resp, err := c.Send(request, c.ServiceName)
    if err != nil {
        return nil, err
    }

    jdResp := &ossopenapi.DeleteBackSourceConfigurationResponse{}
    err = json.Unmarshal(resp, jdResp)
    if err != nil {
        c.Logger.Log(core.LogError, "Unmarshal json failed, resp: %s", string(resp))
        return nil, err
    }

    return jdResp, err
}

