// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    partner "github.com/jdcloud-api/jdcloud-sdk-go/services/partner/models"
)

type QueryMyCustomerListRequest struct {

    core.JDCloudRequest

    /*   */
    RegionId string `json:"regionId"`

    /* 客户pin（客户账户） (Optional) */
    CustomerPin *string `json:"customerPin"`

    /* 客户昵称 (Optional) */
    AliasName *string `json:"aliasName"`

    /* 关联开始时间（格式：yyyy-MM-dd HH:mm:ss） (Optional) */
    StartRelTime *string `json:"startRelTime"`

    /* 关联结束时间（格式：yyyy-MM-dd HH:mm:ss） (Optional) */
    EndRelTime *string `json:"endRelTime"`

    /* 当前页序号 (Optional) */
    PageIndex *int `json:"pageIndex"`

    /* 当前条数 (Optional) */
    PageSize *int `json:"pageSize"`
}

/*
 * param regionId:  (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewQueryMyCustomerListRequest(
    regionId string,
) *QueryMyCustomerListRequest {

	return &QueryMyCustomerListRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/customerManage/queryMyCustomerList",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
	}
}

/*
 * param regionId:  (Required)
 * param customerPin: 客户pin（客户账户） (Optional)
 * param aliasName: 客户昵称 (Optional)
 * param startRelTime: 关联开始时间（格式：yyyy-MM-dd HH:mm:ss） (Optional)
 * param endRelTime: 关联结束时间（格式：yyyy-MM-dd HH:mm:ss） (Optional)
 * param pageIndex: 当前页序号 (Optional)
 * param pageSize: 当前条数 (Optional)
 */
func NewQueryMyCustomerListRequestWithAllParams(
    regionId string,
    customerPin *string,
    aliasName *string,
    startRelTime *string,
    endRelTime *string,
    pageIndex *int,
    pageSize *int,
) *QueryMyCustomerListRequest {

    return &QueryMyCustomerListRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/customerManage/queryMyCustomerList",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        CustomerPin: customerPin,
        AliasName: aliasName,
        StartRelTime: startRelTime,
        EndRelTime: endRelTime,
        PageIndex: pageIndex,
        PageSize: pageSize,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewQueryMyCustomerListRequestWithoutParam() *QueryMyCustomerListRequest {

    return &QueryMyCustomerListRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/customerManage/queryMyCustomerList",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: (Required) */
func (r *QueryMyCustomerListRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param customerPin: 客户pin（客户账户）(Optional) */
func (r *QueryMyCustomerListRequest) SetCustomerPin(customerPin string) {
    r.CustomerPin = &customerPin
}

/* param aliasName: 客户昵称(Optional) */
func (r *QueryMyCustomerListRequest) SetAliasName(aliasName string) {
    r.AliasName = &aliasName
}

/* param startRelTime: 关联开始时间（格式：yyyy-MM-dd HH:mm:ss）(Optional) */
func (r *QueryMyCustomerListRequest) SetStartRelTime(startRelTime string) {
    r.StartRelTime = &startRelTime
}

/* param endRelTime: 关联结束时间（格式：yyyy-MM-dd HH:mm:ss）(Optional) */
func (r *QueryMyCustomerListRequest) SetEndRelTime(endRelTime string) {
    r.EndRelTime = &endRelTime
}

/* param pageIndex: 当前页序号(Optional) */
func (r *QueryMyCustomerListRequest) SetPageIndex(pageIndex int) {
    r.PageIndex = &pageIndex
}

/* param pageSize: 当前条数(Optional) */
func (r *QueryMyCustomerListRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r QueryMyCustomerListRequest) GetRegionId() string {
    return r.RegionId
}

type QueryMyCustomerListResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result QueryMyCustomerListResult `json:"result"`
}

type QueryMyCustomerListResult struct {
    Pagination partner.Pagination `json:"pagination"`
    Result []partner.Customer `json:"result"`
}