// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package models


type OrderDetail struct {

    /* 订单详情列表 (Optional) */
    OrderItemDetails []OrderItemDetail `json:"orderItemDetails"`

    /* 子订单列表 (Optional) */
    ChildOrderDetailList []OrderDetail `json:"childOrderDetailList"`

    /* 订单编号 (Optional) */
    OrderNumber string `json:"orderNumber"`

    /* 订单状态:已支付 (Optional) */
    Status string `json:"status"`

    /* 订单类型 (Optional) */
    OrderType string `json:"orderType"`

    /* 订单计费类型：按配置、包年包月、按用量 (Optional) */
    ChargeMode string `json:"chargeMode"`

    /* 产品线 (Optional) */
    AppName string `json:"appName"`

    /* 产品名称(产品类型) (Optional) */
    ServiceName string `json:"serviceName"`

    /* 付费方式 (Optional) */
    PayType string `json:"payType"`

    /* 自营类型：1-自营，2-非自营，3-二者并存 (Optional) */
    SelfSupportType string `json:"selfSupportType"`

    /* 站点类型 0：主站,1：国际站,2：云市场 (Optional) */
    SiteType string `json:"siteType"`

    /* 下单时间 (Optional) */
    CreateTime string `json:"createTime"`

    /* 支付时间 (Optional) */
    PayTime string `json:"payTime"`

    /* 应付价格是否被修改过：0-未修改，1-已修改 (Optional) */
    IsActualFeeModified string `json:"isActualFeeModified"`

    /* 订单总额（元） (Optional) */
    TotalFee int `json:"totalFee"`

    /* 应付总额（元） (Optional) */
    ActualFee int `json:"actualFee"`

    /* 优惠总额（元） (Optional) */
    DiscountFee int `json:"discountFee"`

    /* 已支付总额（元） (Optional) */
    PaidFee int `json:"paidFee"`

    /* 代金券金额（元） (Optional) */
    FavorableFee int `json:"favorableFee"`

    /* 代金券Json (Optional) */
    FavorableFeeJson string `json:"favorableFeeJson"`

    /* 现金支付 (Optional) */
    MoneyPay int `json:"moneyPay"`

    /* 余额支付 (Optional) */
    BalancePay int `json:"balancePay"`

    /* 支付确认页地址 (Optional) */
    PayUrl string `json:"payUrl"`

    /* 用户pin (Optional) */
    Pin string `json:"pin"`

    /* 备注 (Optional) */
    Remark string `json:"remark"`

    /* 自动取消时间 (Optional) */
    ExpirationTime string `json:"expirationTime"`

    /* 已退款金额 (Optional) */
    RefundFee int `json:"refundFee"`

    /* 订单类型：新购、续费、升降配 (Optional) */
    OrderTypeInfo int `json:"orderTypeInfo"`

    /* 订单计费类型：按配置、包年包月、按用量actualFee (Optional) */
    ChargeModeInfo int `json:"chargeModeInfo"`

    /* 订单状态：未支付、已支付、处理中、已取消 (Optional) */
    StatusInfo int `json:"statusInfo"`

    /* 自营类型：1-自营，2-非自营，3-二者并存 (Optional) */
    SelfSupportTypeInfo int `json:"selfSupportTypeInfo"`

    /* 现金支付方式（企业、个人网银、京东支付、微信、线下汇款） (Optional) */
    PaymentChannel int `json:"paymentChannel"`

    /* 修改时间 (Optional) */
    UpdatedTime string `json:"updatedTime"`

    /* 支付单号 (Optional) */
    PaymentNumber string `json:"paymentNumber"`

    /* 付款人 (Optional) */
    Payer string `json:"payer"`

    /* 申请人 (Optional) */
    Proposer string `json:"proposer"`

    /* 应用code (Optional) */
    AppCode string `json:"appCode"`
}
