// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DeletePodRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* Pod ID  */
    PodId string `json:"podId"`
}

/*
 * param regionId: Region ID (Required)
 * param podId: Pod ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDeletePodRequest(
    regionId string,
    podId string,
) *DeletePodRequest {

	return &DeletePodRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/pods/{podId}",
			Method:  "DELETE",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        PodId: podId,
	}
}

/*
 * param regionId: Region ID (Required)
 * param podId: Pod ID (Required)
 */
func NewDeletePodRequestWithAllParams(
    regionId string,
    podId string,
) *DeletePodRequest {

    return &DeletePodRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/pods/{podId}",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        PodId: podId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDeletePodRequestWithoutParam() *DeletePodRequest {

    return &DeletePodRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/pods/{podId}",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *DeletePodRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param podId: Pod ID(Required) */
func (r *DeletePodRequest) SetPodId(podId string) {
    r.PodId = podId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DeletePodRequest) GetRegionId() string {
    return r.RegionId
}

type DeletePodResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DeletePodResult `json:"result"`
}

type DeletePodResult struct {
}