// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    portal "github.com/jdcloud-api/jdcloud-sdk-go/services/portal/models"
)

type DescribeProductRequest struct {

    core.JDCloudRequest

    /* Region ID （cn-north-1：华北-北京）  */
    RegionId string `json:"regionId"`

    /* 产品url  */
    Url string `json:"url"`

    /* 中文cn 英文en  */
    Lang string `json:"lang"`

    /* 外部使用ak；  */
    Ak string `json:"ak"`
}

/*
 * param regionId: Region ID （cn-north-1：华北-北京） (Required)
 * param url: 产品url (Required)
 * param lang: 中文cn 英文en (Required)
 * param ak: 外部使用ak； (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeProductRequest(
    regionId string,
    url string,
    lang string,
    ak string,
) *DescribeProductRequest {

	return &DescribeProductRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/product",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Url: url,
        Lang: lang,
        Ak: ak,
	}
}

/*
 * param regionId: Region ID （cn-north-1：华北-北京） (Required)
 * param url: 产品url (Required)
 * param lang: 中文cn 英文en (Required)
 * param ak: 外部使用ak； (Required)
 */
func NewDescribeProductRequestWithAllParams(
    regionId string,
    url string,
    lang string,
    ak string,
) *DescribeProductRequest {

    return &DescribeProductRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/product",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Url: url,
        Lang: lang,
        Ak: ak,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeProductRequestWithoutParam() *DescribeProductRequest {

    return &DescribeProductRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/product",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID （cn-north-1：华北-北京）(Required) */
func (r *DescribeProductRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param url: 产品url(Required) */
func (r *DescribeProductRequest) SetUrl(url string) {
    r.Url = url
}

/* param lang: 中文cn 英文en(Required) */
func (r *DescribeProductRequest) SetLang(lang string) {
    r.Lang = lang
}

/* param ak: 外部使用ak；(Required) */
func (r *DescribeProductRequest) SetAk(ak string) {
    r.Ak = ak
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeProductRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeProductResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeProductResult `json:"result"`
}

type DescribeProductResult struct {
    Result portal.Product `json:"result"`
}