// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    portal "github.com/jdcloud-api/jdcloud-sdk-go/services/portal/models"
)

type DescribeProductsByIdRequest struct {

    core.JDCloudRequest

    /* Region ID （cn-north-1：华北-北京）  */
    RegionId string `json:"regionId"`

    /* 语言类型；中文cn；英文en；  */
    Id int `json:"id"`

    /* 外部使用ak；  */
    Ak string `json:"ak"`
}

/*
 * param regionId: Region ID （cn-north-1：华北-北京） (Required)
 * param id: 语言类型；中文cn；英文en； (Required)
 * param ak: 外部使用ak； (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeProductsByIdRequest(
    regionId string,
    id int,
    ak string,
) *DescribeProductsByIdRequest {

	return &DescribeProductsByIdRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/getProductsById",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Id: id,
        Ak: ak,
	}
}

/*
 * param regionId: Region ID （cn-north-1：华北-北京） (Required)
 * param id: 语言类型；中文cn；英文en； (Required)
 * param ak: 外部使用ak； (Required)
 */
func NewDescribeProductsByIdRequestWithAllParams(
    regionId string,
    id int,
    ak string,
) *DescribeProductsByIdRequest {

    return &DescribeProductsByIdRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/getProductsById",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Id: id,
        Ak: ak,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeProductsByIdRequestWithoutParam() *DescribeProductsByIdRequest {

    return &DescribeProductsByIdRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/getProductsById",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID （cn-north-1：华北-北京）(Required) */
func (r *DescribeProductsByIdRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param id: 语言类型；中文cn；英文en；(Required) */
func (r *DescribeProductsByIdRequest) SetId(id int) {
    r.Id = id
}

/* param ak: 外部使用ak；(Required) */
func (r *DescribeProductsByIdRequest) SetAk(ak string) {
    r.Ak = ak
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeProductsByIdRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeProductsByIdResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeProductsByIdResult `json:"result"`
}

type DescribeProductsByIdResult struct {
    Result []portal.Navigation `json:"result"`
}