// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    rds "github.com/jdcloud-api/jdcloud-sdk-go/services/rds/models"
)

type ModifyParametersRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* Instance ID  */
    InstanceId string `json:"instanceId"`

    /* 修改的实例参数  */
    Parameters []rds.Parameter `json:"parameters"`
}

/*
 * param regionId: Region ID (Required)
 * param instanceId: Instance ID (Required)
 * param parameters: 修改的实例参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewModifyParametersRequest(
    regionId string,
    instanceId string,
    parameters []rds.Parameter,
) *ModifyParametersRequest {

	return &ModifyParametersRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/instances/{instanceId}/parameters",
			Method:  "PUT",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        InstanceId: instanceId,
        Parameters: parameters,
	}
}

/*
 * param regionId: Region ID (Required)
 * param instanceId: Instance ID (Required)
 * param parameters: 修改的实例参数 (Required)
 */
func NewModifyParametersRequestWithAllParams(
    regionId string,
    instanceId string,
    parameters []rds.Parameter,
) *ModifyParametersRequest {

    return &ModifyParametersRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}/parameters",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        InstanceId: instanceId,
        Parameters: parameters,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewModifyParametersRequestWithoutParam() *ModifyParametersRequest {

    return &ModifyParametersRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instances/{instanceId}/parameters",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *ModifyParametersRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param instanceId: Instance ID(Required) */
func (r *ModifyParametersRequest) SetInstanceId(instanceId string) {
    r.InstanceId = instanceId
}

/* param parameters: 修改的实例参数(Required) */
func (r *ModifyParametersRequest) SetParameters(parameters []rds.Parameter) {
    r.Parameters = parameters
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ModifyParametersRequest) GetRegionId() string {
    return r.RegionId
}

type ModifyParametersResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ModifyParametersResult `json:"result"`
}

type ModifyParametersResult struct {
}