// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package models


type Backup struct {

    /* 备份ID (Optional) */
    BackupId string `json:"backupId"`

    /* 备份名称，最长支持64个英文字符或等长的中文字符 (Optional) */
    BackupName string `json:"backupName"`

    /* 备份所属实例ID (Optional) */
    InstanceId string `json:"instanceId"`

    /* 备份状态，请查看[枚举参数定义](../Enum-Definitions/Enum-Definitions.md) (Optional) */
    BackupStatus string `json:"backupStatus"`

    /* 备份开始时间，格式为：YYYY-MM-DD HH:mm:ss (Optional) */
    BackupStartTime string `json:"backupStartTime"`

    /* 备份结束时间，格式为：YYYY-MM-DD HH:mm:ss<br>- **SQL Server支持**<br>- **MySQL不支持** (Optional) */
    BackupEndTime string `json:"backupEndTime"`

    /* 备份类型，全量备份或增量备份，请查看[枚举参数定义](../Enum-Definitions/Enum-Definitions.md)<br>- **SQL Server支持**<br>- **MySQL不支持** (Optional) */
    BackupType string `json:"backupType"`

    /* 备份模式，系统自动备份或手动备份，请查看[枚举参数定义](../Enum-Definitions/Enum-Definitions.md) (Optional) */
    BackupMode string `json:"backupMode"`

    /* 备份粒度，实例备份或者多库备份，请查看[枚举参数定义](../Enum-Definitions/Enum-Definitions.md)<br>- **SQL Server支持**<br>- **MySQL不支持** (Optional) */
    BackupUnit string `json:"backupUnit"`

    /* 备份文件列表<br>- **SQL Server支持**,备份可以有多个文件，文件名的命名规则为:<br>（1）全备：数据库名+.bak<br>（2）增量：数据库名+.diff<br>- **MySQL不支持** (Optional) */
    BackupFiles []string `json:"backupFiles"`

    /* 整个备份集大小，单位：Byte (Optional) */
    BackupSizeByte int `json:"backupSizeByte"`
}
