// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package models


type MissingIndexResult struct {

    /* 数据库名 (Optional) */
    Db string `json:"db"`

    /* 表名 (Optional) */
    Table string `json:"table"`

    /* 构成相等谓词的列的逗号分隔列表，谓词的形式如下：<br>table.column =constant_value (Optional) */
    EqualityColumns string `json:"equalityColumns"`

    /* 用于查询的涵盖列的逗号分隔列表,即创建索引的SQL语句中，Include后的字段 (Optional) */
    InequalityColumns string `json:"inequalityColumns"`

    /* 构成不等谓词的列的逗号分隔列表，例如以下形式的谓词：<br>table.column > constant_value<br>“=”之外的任何比较运算符都表示不相等。 (Optional) */
    IncludedColumns string `json:"includedColumns"`

    /* 实现此缺失索引后，用户查询可能获得的平均百分比收益。 该值表示如果实现此缺失索引，则查询成本将按此百分比平均下降。 (Optional) */
    AvgUserImpact float32 `json:"avgUserImpact"`

    /* 由可能使用了组中建议索引的用户查询所导致的扫描次数。 (Optional) */
    UserScans int `json:"userScans"`

    /* 由可能使用了组中建议索引的用户查询所导致的搜索次数。 (Optional) */
    UserSeeks int `json:"userSeeks"`
}
