// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    redis "github.com/jdcloud-api/jdcloud-sdk-go/services/redis/models"
)

type DescribeInstanceClassRequest struct {

    core.JDCloudRequest

    /* 缓存Redis实例所在区域的Region ID。目前有华北-北京、华南-广州、华东-上海三个区域，Region ID分别为cn-north-1、cn-south-1、cn-east-2  */
    RegionId string `json:"regionId"`

    /* 缓存Redis的版本号：目前有2.8和4.0，默认为2.8 (Optional) */
    RedisVersion *string `json:"redisVersion"`
}

/*
 * param regionId: 缓存Redis实例所在区域的Region ID。目前有华北-北京、华南-广州、华东-上海三个区域，Region ID分别为cn-north-1、cn-south-1、cn-east-2 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeInstanceClassRequest(
    regionId string,
) *DescribeInstanceClassRequest {

	return &DescribeInstanceClassRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/instanceClass",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
	}
}

/*
 * param regionId: 缓存Redis实例所在区域的Region ID。目前有华北-北京、华南-广州、华东-上海三个区域，Region ID分别为cn-north-1、cn-south-1、cn-east-2 (Required)
 * param redisVersion: 缓存Redis的版本号：目前有2.8和4.0，默认为2.8 (Optional)
 */
func NewDescribeInstanceClassRequestWithAllParams(
    regionId string,
    redisVersion *string,
) *DescribeInstanceClassRequest {

    return &DescribeInstanceClassRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instanceClass",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        RedisVersion: redisVersion,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeInstanceClassRequestWithoutParam() *DescribeInstanceClassRequest {

    return &DescribeInstanceClassRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/instanceClass",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 缓存Redis实例所在区域的Region ID。目前有华北-北京、华南-广州、华东-上海三个区域，Region ID分别为cn-north-1、cn-south-1、cn-east-2(Required) */
func (r *DescribeInstanceClassRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param redisVersion: 缓存Redis的版本号：目前有2.8和4.0，默认为2.8(Optional) */
func (r *DescribeInstanceClassRequest) SetRedisVersion(redisVersion string) {
    r.RedisVersion = &redisVersion
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeInstanceClassRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeInstanceClassResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeInstanceClassResult `json:"result"`
}

type DescribeInstanceClassResult struct {
    InstanceClasses []redis.InstanceClass `json:"instanceClasses"`
    TotalCount int `json:"totalCount"`
}