// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    rms "github.com/jdcloud-api/jdcloud-sdk-go/services/rms/models"
)

type QuerySendStatusRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 获取发送状态请求参数  */
    QuerySendStatusSpec *rms.QuerySendStatusSpec `json:"querySendStatusSpec"`
}

/*
 * param regionId: Region ID (Required)
 * param querySendStatusSpec: 获取发送状态请求参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewQuerySendStatusRequest(
    regionId string,
    querySendStatusSpec *rms.QuerySendStatusSpec,
) *QuerySendStatusRequest {

	return &QuerySendStatusRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/querySendStatus",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        QuerySendStatusSpec: querySendStatusSpec,
	}
}

/*
 * param regionId: Region ID (Required)
 * param querySendStatusSpec: 获取发送状态请求参数 (Required)
 */
func NewQuerySendStatusRequestWithAllParams(
    regionId string,
    querySendStatusSpec *rms.QuerySendStatusSpec,
) *QuerySendStatusRequest {

    return &QuerySendStatusRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/querySendStatus",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        QuerySendStatusSpec: querySendStatusSpec,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewQuerySendStatusRequestWithoutParam() *QuerySendStatusRequest {

    return &QuerySendStatusRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/querySendStatus",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *QuerySendStatusRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param querySendStatusSpec: 获取发送状态请求参数(Required) */
func (r *QuerySendStatusRequest) SetQuerySendStatusSpec(querySendStatusSpec *rms.QuerySendStatusSpec) {
    r.QuerySendStatusSpec = querySendStatusSpec
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r QuerySendStatusRequest) GetRegionId() string {
    return r.RegionId
}

type QuerySendStatusResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result QuerySendStatusResult `json:"result"`
}

type QuerySendStatusResult struct {
    Data []rms.QuerySendStatus `json:"data"`
}