// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    rms "github.com/jdcloud-api/jdcloud-sdk-go/services/rms/models"
)

type QueryTemplateListRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* appId参数 (Optional) */
    AppId *string `json:"appId"`

    /* searchKey参数 (Optional) */
    SearchKey *string `json:"searchKey"`

    /* pageNum参数 (Optional) */
    PageNum *string `json:"pageNum"`

    /* pageLimit参数 (Optional) */
    PageLimit *string `json:"pageLimit"`

    /* status参数 (Optional) */
    Status *string `json:"status"`

    /* title参数 (Optional) */
    Title *string `json:"title"`

    /* startTime参数 (Optional) */
    StartTime *string `json:"startTime"`

    /* endTime参数 (Optional) */
    EndTime *string `json:"endTime"`
}

/*
 * param regionId: Region ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewQueryTemplateListRequest(
    regionId string,
) *QueryTemplateListRequest {

	return &QueryTemplateListRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/queryTemplateList",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
	}
}

/*
 * param regionId: Region ID (Required)
 * param appId: appId参数 (Optional)
 * param searchKey: searchKey参数 (Optional)
 * param pageNum: pageNum参数 (Optional)
 * param pageLimit: pageLimit参数 (Optional)
 * param status: status参数 (Optional)
 * param title: title参数 (Optional)
 * param startTime: startTime参数 (Optional)
 * param endTime: endTime参数 (Optional)
 */
func NewQueryTemplateListRequestWithAllParams(
    regionId string,
    appId *string,
    searchKey *string,
    pageNum *string,
    pageLimit *string,
    status *string,
    title *string,
    startTime *string,
    endTime *string,
) *QueryTemplateListRequest {

    return &QueryTemplateListRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/queryTemplateList",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        AppId: appId,
        SearchKey: searchKey,
        PageNum: pageNum,
        PageLimit: pageLimit,
        Status: status,
        Title: title,
        StartTime: startTime,
        EndTime: endTime,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewQueryTemplateListRequestWithoutParam() *QueryTemplateListRequest {

    return &QueryTemplateListRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/queryTemplateList",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *QueryTemplateListRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param appId: appId参数(Optional) */
func (r *QueryTemplateListRequest) SetAppId(appId string) {
    r.AppId = &appId
}

/* param searchKey: searchKey参数(Optional) */
func (r *QueryTemplateListRequest) SetSearchKey(searchKey string) {
    r.SearchKey = &searchKey
}

/* param pageNum: pageNum参数(Optional) */
func (r *QueryTemplateListRequest) SetPageNum(pageNum string) {
    r.PageNum = &pageNum
}

/* param pageLimit: pageLimit参数(Optional) */
func (r *QueryTemplateListRequest) SetPageLimit(pageLimit string) {
    r.PageLimit = &pageLimit
}

/* param status: status参数(Optional) */
func (r *QueryTemplateListRequest) SetStatus(status string) {
    r.Status = &status
}

/* param title: title参数(Optional) */
func (r *QueryTemplateListRequest) SetTitle(title string) {
    r.Title = &title
}

/* param startTime: startTime参数(Optional) */
func (r *QueryTemplateListRequest) SetStartTime(startTime string) {
    r.StartTime = &startTime
}

/* param endTime: endTime参数(Optional) */
func (r *QueryTemplateListRequest) SetEndTime(endTime string) {
    r.EndTime = &endTime
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r QueryTemplateListRequest) GetRegionId() string {
    return r.RegionId
}

type QueryTemplateListResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result QueryTemplateListResult `json:"result"`
}

type QueryTemplateListResult struct {
    Data []rms.RespQueryTemplateListData `json:"data"`
    Message string `json:"message"`
    TotalElements string `json:"totalElements"`
    Status string `json:"status"`
}