// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    rms "github.com/jdcloud-api/jdcloud-sdk-go/services/rms/models"
)

type SendBatchMsgRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 指定短信Id群发短信请求参数  */
    SendBatchMsgSpec *rms.SendBatchMsgSpec `json:"sendBatchMsgSpec"`
}

/*
 * param regionId: Region ID (Required)
 * param sendBatchMsgSpec: 指定短信Id群发短信请求参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewSendBatchMsgRequest(
    regionId string,
    sendBatchMsgSpec *rms.SendBatchMsgSpec,
) *SendBatchMsgRequest {

	return &SendBatchMsgRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/sendBatchMsg",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        SendBatchMsgSpec: sendBatchMsgSpec,
	}
}

/*
 * param regionId: Region ID (Required)
 * param sendBatchMsgSpec: 指定短信Id群发短信请求参数 (Required)
 */
func NewSendBatchMsgRequestWithAllParams(
    regionId string,
    sendBatchMsgSpec *rms.SendBatchMsgSpec,
) *SendBatchMsgRequest {

    return &SendBatchMsgRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/sendBatchMsg",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        SendBatchMsgSpec: sendBatchMsgSpec,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewSendBatchMsgRequestWithoutParam() *SendBatchMsgRequest {

    return &SendBatchMsgRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/sendBatchMsg",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *SendBatchMsgRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param sendBatchMsgSpec: 指定短信Id群发短信请求参数(Required) */
func (r *SendBatchMsgRequest) SetSendBatchMsgSpec(sendBatchMsgSpec *rms.SendBatchMsgSpec) {
    r.SendBatchMsgSpec = sendBatchMsgSpec
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r SendBatchMsgRequest) GetRegionId() string {
    return r.RegionId
}

type SendBatchMsgResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result SendBatchMsgResult `json:"result"`
}

type SendBatchMsgResult struct {
    Data rms.SendBatchMsg `json:"data"`
}