// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    sms "github.com/jdcloud-api/jdcloud-sdk-go/services/sms/models"
)

type AggSendStatusRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 发送状态统计参数  */
    AggSendStatusSpec *sms.AggSendStatusSpec `json:"aggSendStatusSpec"`
}

/*
 * param regionId: Region ID (Required)
 * param aggSendStatusSpec: 发送状态统计参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewAggSendStatusRequest(
    regionId string,
    aggSendStatusSpec *sms.AggSendStatusSpec,
) *AggSendStatusRequest {

	return &AggSendStatusRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/aggSendStatus",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        AggSendStatusSpec: aggSendStatusSpec,
	}
}

/*
 * param regionId: Region ID (Required)
 * param aggSendStatusSpec: 发送状态统计参数 (Required)
 */
func NewAggSendStatusRequestWithAllParams(
    regionId string,
    aggSendStatusSpec *sms.AggSendStatusSpec,
) *AggSendStatusRequest {

    return &AggSendStatusRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/aggSendStatus",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        AggSendStatusSpec: aggSendStatusSpec,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewAggSendStatusRequestWithoutParam() *AggSendStatusRequest {

    return &AggSendStatusRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/aggSendStatus",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *AggSendStatusRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param aggSendStatusSpec: 发送状态统计参数(Required) */
func (r *AggSendStatusRequest) SetAggSendStatusSpec(aggSendStatusSpec *sms.AggSendStatusSpec) {
    r.AggSendStatusSpec = aggSendStatusSpec
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r AggSendStatusRequest) GetRegionId() string {
    return r.RegionId
}

type AggSendStatusResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result AggSendStatusResult `json:"result"`
}

type AggSendStatusResult struct {
    Data []sms.AggSendStatus `json:"data"`
}