// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type EditSdkSmsSignRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* signId参数 (Optional) */
    SignId *string `json:"signId"`

    /* name参数 (Optional) */
    Name *string `json:"name"`

    /* type参数 (Optional) */
    Type *string `json:"type"`

    /* purpose参数 (Optional) */
    Purpose *string `json:"purpose"`

    /* signCardType参数 (Optional) */
    SignCardType *string `json:"signCardType"`

    /* signPic参数 (Optional) */
    SignPic *string `json:"signPic"`

    /* thirdPartyPic参数 (Optional) */
    ThirdPartyPic *string `json:"thirdPartyPic"`

    /* description参数 (Optional) */
    Description *string `json:"description"`
}

/*
 * param regionId: Region ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewEditSdkSmsSignRequest(
    regionId string,
) *EditSdkSmsSignRequest {

	return &EditSdkSmsSignRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/editSdkSmsSign",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
	}
}

/*
 * param regionId: Region ID (Required)
 * param signId: signId参数 (Optional)
 * param name: name参数 (Optional)
 * param type_: type参数 (Optional)
 * param purpose: purpose参数 (Optional)
 * param signCardType: signCardType参数 (Optional)
 * param signPic: signPic参数 (Optional)
 * param thirdPartyPic: thirdPartyPic参数 (Optional)
 * param description: description参数 (Optional)
 */
func NewEditSdkSmsSignRequestWithAllParams(
    regionId string,
    signId *string,
    name *string,
    type_ *string,
    purpose *string,
    signCardType *string,
    signPic *string,
    thirdPartyPic *string,
    description *string,
) *EditSdkSmsSignRequest {

    return &EditSdkSmsSignRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/editSdkSmsSign",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        SignId: signId,
        Name: name,
        Type: type_,
        Purpose: purpose,
        SignCardType: signCardType,
        SignPic: signPic,
        ThirdPartyPic: thirdPartyPic,
        Description: description,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewEditSdkSmsSignRequestWithoutParam() *EditSdkSmsSignRequest {

    return &EditSdkSmsSignRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/editSdkSmsSign",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *EditSdkSmsSignRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param signId: signId参数(Optional) */
func (r *EditSdkSmsSignRequest) SetSignId(signId string) {
    r.SignId = &signId
}

/* param name: name参数(Optional) */
func (r *EditSdkSmsSignRequest) SetName(name string) {
    r.Name = &name
}

/* param type_: type参数(Optional) */
func (r *EditSdkSmsSignRequest) SetType(type_ string) {
    r.Type = &type_
}

/* param purpose: purpose参数(Optional) */
func (r *EditSdkSmsSignRequest) SetPurpose(purpose string) {
    r.Purpose = &purpose
}

/* param signCardType: signCardType参数(Optional) */
func (r *EditSdkSmsSignRequest) SetSignCardType(signCardType string) {
    r.SignCardType = &signCardType
}

/* param signPic: signPic参数(Optional) */
func (r *EditSdkSmsSignRequest) SetSignPic(signPic string) {
    r.SignPic = &signPic
}

/* param thirdPartyPic: thirdPartyPic参数(Optional) */
func (r *EditSdkSmsSignRequest) SetThirdPartyPic(thirdPartyPic string) {
    r.ThirdPartyPic = &thirdPartyPic
}

/* param description: description参数(Optional) */
func (r *EditSdkSmsSignRequest) SetDescription(description string) {
    r.Description = &description
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r EditSdkSmsSignRequest) GetRegionId() string {
    return r.RegionId
}

type EditSdkSmsSignResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result EditSdkSmsSignResult `json:"result"`
}

type EditSdkSmsSignResult struct {
    Message string `json:"message"`
    Status string `json:"status"`
}