// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    sms "github.com/jdcloud-api/jdcloud-sdk-go/services/sms/models"
)

type PullMoMsgByMobileRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 拉取单个手机的回复短信请求参数  */
    PullMoMsgByMobileSpec *sms.PullMoMsgByMobileSpec `json:"pullMoMsgByMobileSpec"`
}

/*
 * param regionId: Region ID (Required)
 * param pullMoMsgByMobileSpec: 拉取单个手机的回复短信请求参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewPullMoMsgByMobileRequest(
    regionId string,
    pullMoMsgByMobileSpec *sms.PullMoMsgByMobileSpec,
) *PullMoMsgByMobileRequest {

	return &PullMoMsgByMobileRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/pullMoMsgByMobile",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        PullMoMsgByMobileSpec: pullMoMsgByMobileSpec,
	}
}

/*
 * param regionId: Region ID (Required)
 * param pullMoMsgByMobileSpec: 拉取单个手机的回复短信请求参数 (Required)
 */
func NewPullMoMsgByMobileRequestWithAllParams(
    regionId string,
    pullMoMsgByMobileSpec *sms.PullMoMsgByMobileSpec,
) *PullMoMsgByMobileRequest {

    return &PullMoMsgByMobileRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/pullMoMsgByMobile",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        PullMoMsgByMobileSpec: pullMoMsgByMobileSpec,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewPullMoMsgByMobileRequestWithoutParam() *PullMoMsgByMobileRequest {

    return &PullMoMsgByMobileRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/pullMoMsgByMobile",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *PullMoMsgByMobileRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param pullMoMsgByMobileSpec: 拉取单个手机的回复短信请求参数(Required) */
func (r *PullMoMsgByMobileRequest) SetPullMoMsgByMobileSpec(pullMoMsgByMobileSpec *sms.PullMoMsgByMobileSpec) {
    r.PullMoMsgByMobileSpec = pullMoMsgByMobileSpec
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r PullMoMsgByMobileRequest) GetRegionId() string {
    return r.RegionId
}

type PullMoMsgByMobileResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result PullMoMsgByMobileResult `json:"result"`
}

type PullMoMsgByMobileResult struct {
    Data []sms.PullMoMsgByMobile `json:"data"`
}