// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    sms "github.com/jdcloud-api/jdcloud-sdk-go/services/sms/models"
)

type QuerySdkSmsSignStatusRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* signId参数 (Optional) */
    SignId *string `json:"signId"`
}

/*
 * param regionId: Region ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewQuerySdkSmsSignStatusRequest(
    regionId string,
) *QuerySdkSmsSignStatusRequest {

	return &QuerySdkSmsSignStatusRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/querySdkSmsSignStatus",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
	}
}

/*
 * param regionId: Region ID (Required)
 * param signId: signId参数 (Optional)
 */
func NewQuerySdkSmsSignStatusRequestWithAllParams(
    regionId string,
    signId *string,
) *QuerySdkSmsSignStatusRequest {

    return &QuerySdkSmsSignStatusRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/querySdkSmsSignStatus",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        SignId: signId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewQuerySdkSmsSignStatusRequestWithoutParam() *QuerySdkSmsSignStatusRequest {

    return &QuerySdkSmsSignStatusRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/querySdkSmsSignStatus",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *QuerySdkSmsSignStatusRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param signId: signId参数(Optional) */
func (r *QuerySdkSmsSignStatusRequest) SetSignId(signId string) {
    r.SignId = &signId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r QuerySdkSmsSignStatusRequest) GetRegionId() string {
    return r.RegionId
}

type QuerySdkSmsSignStatusResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result QuerySdkSmsSignStatusResult `json:"result"`
}

type QuerySdkSmsSignStatusResult struct {
    Data []sms.RespQuerySdkSmsSignStatusData `json:"data"`
    Message string `json:"message"`
    Status string `json:"status"`
}