// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    sms "github.com/jdcloud-api/jdcloud-sdk-go/services/sms/models"
)

type SendSingleSmsRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 指定模板单发短信请求参数  */
    SendSingleSmsSpec *sms.SendSingleSmsSpec `json:"sendSingleSmsSpec"`
}

/*
 * param regionId: Region ID (Required)
 * param sendSingleSmsSpec: 指定模板单发短信请求参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewSendSingleSmsRequest(
    regionId string,
    sendSingleSmsSpec *sms.SendSingleSmsSpec,
) *SendSingleSmsRequest {

	return &SendSingleSmsRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/sendSingleSms",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        SendSingleSmsSpec: sendSingleSmsSpec,
	}
}

/*
 * param regionId: Region ID (Required)
 * param sendSingleSmsSpec: 指定模板单发短信请求参数 (Required)
 */
func NewSendSingleSmsRequestWithAllParams(
    regionId string,
    sendSingleSmsSpec *sms.SendSingleSmsSpec,
) *SendSingleSmsRequest {

    return &SendSingleSmsRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/sendSingleSms",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        SendSingleSmsSpec: sendSingleSmsSpec,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewSendSingleSmsRequestWithoutParam() *SendSingleSmsRequest {

    return &SendSingleSmsRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/sendSingleSms",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *SendSingleSmsRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param sendSingleSmsSpec: 指定模板单发短信请求参数(Required) */
func (r *SendSingleSmsRequest) SetSendSingleSmsSpec(sendSingleSmsSpec *sms.SendSingleSmsSpec) {
    r.SendSingleSmsSpec = sendSingleSmsSpec
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r SendSingleSmsRequest) GetRegionId() string {
    return r.RegionId
}

type SendSingleSmsResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result SendSingleSmsResult `json:"result"`
}

type SendSingleSmsResult struct {
    Data []sms.SendSingleSms `json:"data"`
}