// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    sop "github.com/jdcloud-api/jdcloud-sdk-go/services/sop/models"
)

type GetSecurityTokenRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 获取SecurityToken参数  */
    GetSecurityTokenInfo *sop.GetSecurityTokenInfo `json:"getSecurityTokenInfo"`
}

/*
 * param regionId: Region ID (Required)
 * param getSecurityTokenInfo: 获取SecurityToken参数 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewGetSecurityTokenRequest(
    regionId string,
    getSecurityTokenInfo *sop.GetSecurityTokenInfo,
) *GetSecurityTokenRequest {

	return &GetSecurityTokenRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/securityToken:getSecurityToken",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        GetSecurityTokenInfo: getSecurityTokenInfo,
	}
}

/*
 * param regionId: Region ID (Required)
 * param getSecurityTokenInfo: 获取SecurityToken参数 (Required)
 */
func NewGetSecurityTokenRequestWithAllParams(
    regionId string,
    getSecurityTokenInfo *sop.GetSecurityTokenInfo,
) *GetSecurityTokenRequest {

    return &GetSecurityTokenRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/securityToken:getSecurityToken",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        GetSecurityTokenInfo: getSecurityTokenInfo,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewGetSecurityTokenRequestWithoutParam() *GetSecurityTokenRequest {

    return &GetSecurityTokenRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/securityToken:getSecurityToken",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *GetSecurityTokenRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param getSecurityTokenInfo: 获取SecurityToken参数(Required) */
func (r *GetSecurityTokenRequest) SetGetSecurityTokenInfo(getSecurityTokenInfo *sop.GetSecurityTokenInfo) {
    r.GetSecurityTokenInfo = getSecurityTokenInfo
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r GetSecurityTokenRequest) GetRegionId() string {
    return r.RegionId
}

type GetSecurityTokenResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result GetSecurityTokenResult `json:"result"`
}

type GetSecurityTokenResult struct {
    SecurityToken string `json:"securityToken"`
}