// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DeleteCertsRequest struct {

    core.JDCloudRequest

    /* 证书 Id  */
    CertId string `json:"certId"`
}

/*
 * param certId: 证书 Id (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDeleteCertsRequest(
    certId string,
) *DeleteCertsRequest {

	return &DeleteCertsRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/sslCert/{certId}",
			Method:  "DELETE",
			Header:  nil,
			Version: "v1",
		},
        CertId: certId,
	}
}

/*
 * param certId: 证书 Id (Required)
 */
func NewDeleteCertsRequestWithAllParams(
    certId string,
) *DeleteCertsRequest {

    return &DeleteCertsRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/sslCert/{certId}",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
        CertId: certId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDeleteCertsRequestWithoutParam() *DeleteCertsRequest {

    return &DeleteCertsRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/sslCert/{certId}",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param certId: 证书 Id(Required) */
func (r *DeleteCertsRequest) SetCertId(certId string) {
    r.CertId = certId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DeleteCertsRequest) GetRegionId() string {
    return ""
}

type DeleteCertsResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DeleteCertsResult `json:"result"`
}

type DeleteCertsResult struct {
    Code int `json:"code"`
    Message string `json:"message"`
}