// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type UploadCertRequest struct {

    core.JDCloudRequest

    /* 证书名称  */
    CertName string `json:"certName"`

    /* 私钥  */
    KeyFile string `json:"keyFile"`

    /* 证书  */
    CertFile string `json:"certFile"`

    /* 证书别名 (Optional) */
    AliasName *string `json:"aliasName"`
}

/*
 * param certName: 证书名称 (Required)
 * param keyFile: 私钥 (Required)
 * param certFile: 证书 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewUploadCertRequest(
    certName string,
    keyFile string,
    certFile string,
) *UploadCertRequest {

	return &UploadCertRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/sslCert:upload",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        CertName: certName,
        KeyFile: keyFile,
        CertFile: certFile,
	}
}

/*
 * param certName: 证书名称 (Required)
 * param keyFile: 私钥 (Required)
 * param certFile: 证书 (Required)
 * param aliasName: 证书别名 (Optional)
 */
func NewUploadCertRequestWithAllParams(
    certName string,
    keyFile string,
    certFile string,
    aliasName *string,
) *UploadCertRequest {

    return &UploadCertRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/sslCert:upload",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        CertName: certName,
        KeyFile: keyFile,
        CertFile: certFile,
        AliasName: aliasName,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewUploadCertRequestWithoutParam() *UploadCertRequest {

    return &UploadCertRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/sslCert:upload",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param certName: 证书名称(Required) */
func (r *UploadCertRequest) SetCertName(certName string) {
    r.CertName = certName
}

/* param keyFile: 私钥(Required) */
func (r *UploadCertRequest) SetKeyFile(keyFile string) {
    r.KeyFile = keyFile
}

/* param certFile: 证书(Required) */
func (r *UploadCertRequest) SetCertFile(certFile string) {
    r.CertFile = certFile
}

/* param aliasName: 证书别名(Optional) */
func (r *UploadCertRequest) SetAliasName(aliasName string) {
    r.AliasName = &aliasName
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r UploadCertRequest) GetRegionId() string {
    return ""
}

type UploadCertResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result UploadCertResult `json:"result"`
}

type UploadCertResult struct {
    CertId string `json:"certId"`
    Digest string `json:"digest"`
}