// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    streambus "github.com/jdcloud-api/jdcloud-sdk-go/services/streambus/models"
)

type AddTopicRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* 示例：{"topicModel":{"topic":{"archived":0,"id":"","name":"create","remark":"备注","shardNum":1,"partitionNum":2,"lifecycle":3}}}  */
    TopicModel *streambus.TopicModel `json:"topicModel"`
}

/*
 * param regionId: 地域ID (Required)
 * param topicModel: 示例：{"topicModel":{"topic":{"archived":0,"id":"","name":"create","remark":"备注","shardNum":1,"partitionNum":2,"lifecycle":3}}} (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewAddTopicRequest(
    regionId string,
    topicModel *streambus.TopicModel,
) *AddTopicRequest {

	return &AddTopicRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/topic",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        TopicModel: topicModel,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param topicModel: 示例：{"topicModel":{"topic":{"archived":0,"id":"","name":"create","remark":"备注","shardNum":1,"partitionNum":2,"lifecycle":3}}} (Required)
 */
func NewAddTopicRequestWithAllParams(
    regionId string,
    topicModel *streambus.TopicModel,
) *AddTopicRequest {

    return &AddTopicRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/topic",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        TopicModel: topicModel,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewAddTopicRequestWithoutParam() *AddTopicRequest {

    return &AddTopicRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/topic",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *AddTopicRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param topicModel: 示例：{"topicModel":{"topic":{"archived":0,"id":"","name":"create","remark":"备注","shardNum":1,"partitionNum":2,"lifecycle":3}}}(Required) */
func (r *AddTopicRequest) SetTopicModel(topicModel *streambus.TopicModel) {
    r.TopicModel = topicModel
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r AddTopicRequest) GetRegionId() string {
    return r.RegionId
}

type AddTopicResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result AddTopicResult `json:"result"`
}

type AddTopicResult struct {
    Status bool `json:"status"`
    Message string `json:"message"`
}