// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DeleteConsumerGroupRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* 主题ID  */
    TopicId int `json:"topicId"`

    /* 消费组ID  */
    ConsumerGroupId int `json:"consumerGroupId"`
}

/*
 * param regionId: Region ID (Required)
 * param topicId: 主题ID (Required)
 * param consumerGroupId: 消费组ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDeleteConsumerGroupRequest(
    regionId string,
    topicId int,
    consumerGroupId int,
) *DeleteConsumerGroupRequest {

	return &DeleteConsumerGroupRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/consumerGroup",
			Method:  "DELETE",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        TopicId: topicId,
        ConsumerGroupId: consumerGroupId,
	}
}

/*
 * param regionId: Region ID (Required)
 * param topicId: 主题ID (Required)
 * param consumerGroupId: 消费组ID (Required)
 */
func NewDeleteConsumerGroupRequestWithAllParams(
    regionId string,
    topicId int,
    consumerGroupId int,
) *DeleteConsumerGroupRequest {

    return &DeleteConsumerGroupRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/consumerGroup",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        TopicId: topicId,
        ConsumerGroupId: consumerGroupId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDeleteConsumerGroupRequestWithoutParam() *DeleteConsumerGroupRequest {

    return &DeleteConsumerGroupRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/consumerGroup",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *DeleteConsumerGroupRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param topicId: 主题ID(Required) */
func (r *DeleteConsumerGroupRequest) SetTopicId(topicId int) {
    r.TopicId = topicId
}

/* param consumerGroupId: 消费组ID(Required) */
func (r *DeleteConsumerGroupRequest) SetConsumerGroupId(consumerGroupId int) {
    r.ConsumerGroupId = consumerGroupId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DeleteConsumerGroupRequest) GetRegionId() string {
    return r.RegionId
}

type DeleteConsumerGroupResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DeleteConsumerGroupResult `json:"result"`
}

type DeleteConsumerGroupResult struct {
    Message string `json:"message"`
    Status bool `json:"status"`
}