// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type DeleteStorageRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* storageId  */
    StorageId int `json:"storageId"`
}

/*
 * param regionId: Region ID (Required)
 * param storageId: storageId (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDeleteStorageRequest(
    regionId string,
    storageId int,
) *DeleteStorageRequest {

	return &DeleteStorageRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/storage",
			Method:  "DELETE",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        StorageId: storageId,
	}
}

/*
 * param regionId: Region ID (Required)
 * param storageId: storageId (Required)
 */
func NewDeleteStorageRequestWithAllParams(
    regionId string,
    storageId int,
) *DeleteStorageRequest {

    return &DeleteStorageRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/storage",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        StorageId: storageId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDeleteStorageRequestWithoutParam() *DeleteStorageRequest {

    return &DeleteStorageRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/storage",
            Method:  "DELETE",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *DeleteStorageRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param storageId: storageId(Required) */
func (r *DeleteStorageRequest) SetStorageId(storageId int) {
    r.StorageId = storageId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DeleteStorageRequest) GetRegionId() string {
    return r.RegionId
}

type DeleteStorageResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DeleteStorageResult `json:"result"`
}

type DeleteStorageResult struct {
    Message string `json:"message"`
}