// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    streamcomputer "github.com/jdcloud-api/jdcloud-sdk-go/services/streamcomputer/models"
)

type DescribeJobRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /*   */
    JobId int `json:"jobId"`

    /*   */
    NamespaceId int `json:"namespaceId"`
}

/*
 * param regionId: Region ID (Required)
 * param jobId:  (Required)
 * param namespaceId:  (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewDescribeJobRequest(
    regionId string,
    jobId int,
    namespaceId int,
) *DescribeJobRequest {

	return &DescribeJobRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/job",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        JobId: jobId,
        NamespaceId: namespaceId,
	}
}

/*
 * param regionId: Region ID (Required)
 * param jobId:  (Required)
 * param namespaceId:  (Required)
 */
func NewDescribeJobRequestWithAllParams(
    regionId string,
    jobId int,
    namespaceId int,
) *DescribeJobRequest {

    return &DescribeJobRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/job",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        JobId: jobId,
        NamespaceId: namespaceId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewDescribeJobRequestWithoutParam() *DescribeJobRequest {

    return &DescribeJobRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/job",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *DescribeJobRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param jobId: (Required) */
func (r *DescribeJobRequest) SetJobId(jobId int) {
    r.JobId = jobId
}

/* param namespaceId: (Required) */
func (r *DescribeJobRequest) SetNamespaceId(namespaceId int) {
    r.NamespaceId = namespaceId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r DescribeJobRequest) GetRegionId() string {
    return r.RegionId
}

type DescribeJobResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result DescribeJobResult `json:"result"`
}

type DescribeJobResult struct {
    JobStr streamcomputer.JobStr `json:"jobStr"`
}