// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    streamcomputer "github.com/jdcloud-api/jdcloud-sdk-go/services/streamcomputer/models"
)

type GetJobListRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /*   */
    NamespaceId string `json:"namespaceId"`
}

/*
 * param regionId: Region ID (Required)
 * param namespaceId:  (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewGetJobListRequest(
    regionId string,
    namespaceId string,
) *GetJobListRequest {

	return &GetJobListRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/jobList",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        NamespaceId: namespaceId,
	}
}

/*
 * param regionId: Region ID (Required)
 * param namespaceId:  (Required)
 */
func NewGetJobListRequestWithAllParams(
    regionId string,
    namespaceId string,
) *GetJobListRequest {

    return &GetJobListRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/jobList",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        NamespaceId: namespaceId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewGetJobListRequestWithoutParam() *GetJobListRequest {

    return &GetJobListRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/jobList",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *GetJobListRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param namespaceId: (Required) */
func (r *GetJobListRequest) SetNamespaceId(namespaceId string) {
    r.NamespaceId = namespaceId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r GetJobListRequest) GetRegionId() string {
    return r.RegionId
}

type GetJobListResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result GetJobListResult `json:"result"`
}

type GetJobListResult struct {
    Data []streamcomputer.JobStr `json:"data"`
}