// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    streamcomputer "github.com/jdcloud-api/jdcloud-sdk-go/services/streamcomputer/models"
)

type GetStorageListRequest struct {

    core.JDCloudRequest

    /* Region ID  */
    RegionId string `json:"regionId"`

    /* storage类型  */
    StorageType string `json:"storageType"`

    /* namespaceId  */
    NamespaceId string `json:"namespaceId"`
}

/*
 * param regionId: Region ID (Required)
 * param storageType: storage类型 (Required)
 * param namespaceId: namespaceId (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewGetStorageListRequest(
    regionId string,
    storageType string,
    namespaceId string,
) *GetStorageListRequest {

	return &GetStorageListRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/storageList",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        StorageType: storageType,
        NamespaceId: namespaceId,
	}
}

/*
 * param regionId: Region ID (Required)
 * param storageType: storage类型 (Required)
 * param namespaceId: namespaceId (Required)
 */
func NewGetStorageListRequestWithAllParams(
    regionId string,
    storageType string,
    namespaceId string,
) *GetStorageListRequest {

    return &GetStorageListRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/storageList",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        StorageType: storageType,
        NamespaceId: namespaceId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewGetStorageListRequestWithoutParam() *GetStorageListRequest {

    return &GetStorageListRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/storageList",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: Region ID(Required) */
func (r *GetStorageListRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param storageType: storage类型(Required) */
func (r *GetStorageListRequest) SetStorageType(storageType string) {
    r.StorageType = storageType
}

/* param namespaceId: namespaceId(Required) */
func (r *GetStorageListRequest) SetNamespaceId(namespaceId string) {
    r.NamespaceId = namespaceId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r GetStorageListRequest) GetRegionId() string {
    return r.RegionId
}

type GetStorageListResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result GetStorageListResult `json:"result"`
}

type GetStorageListResult struct {
    StorageList []streamcomputer.Storage `json:"storageList"`
}