// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type BatchDeleteVideosRequest struct {

    core.JDCloudRequest

    /*  (Optional) */
    VideoIds []string `json:"videoIds"`
}

/*
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewBatchDeleteVideosRequest(
) *BatchDeleteVideosRequest {

	return &BatchDeleteVideosRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/videos:batchDelete",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
	}
}

/*
 * param videoIds:  (Optional)
 */
func NewBatchDeleteVideosRequestWithAllParams(
    videoIds []string,
) *BatchDeleteVideosRequest {

    return &BatchDeleteVideosRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/videos:batchDelete",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        VideoIds: videoIds,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewBatchDeleteVideosRequestWithoutParam() *BatchDeleteVideosRequest {

    return &BatchDeleteVideosRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/videos:batchDelete",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param videoIds: (Optional) */
func (r *BatchDeleteVideosRequest) SetVideoIds(videoIds []string) {
    r.VideoIds = videoIds
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r BatchDeleteVideosRequest) GetRegionId() string {
    return ""
}

type BatchDeleteVideosResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result BatchDeleteVideosResult `json:"result"`
}

type BatchDeleteVideosResult struct {
    DeletedVideoIds []string `json:"deletedVideoIds"`
    NotFoundVideoIds []string `json:"notFoundVideoIds"`
}