// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type CreateCategoryRequest struct {

    core.JDCloudRequest

    /* 分类名称 (Optional) */
    Name *string `json:"name"`

    /* 分类级别 (Optional) */
    Level *int `json:"level"`

    /* 父分类ID (Optional) */
    ParentId *int64 `json:"parentId"`

    /* 分类描述信息 (Optional) */
    Description *string `json:"description"`
}

/*
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewCreateCategoryRequest(
) *CreateCategoryRequest {

	return &CreateCategoryRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/categories",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
	}
}

/*
 * param name: 分类名称 (Optional)
 * param level: 分类级别 (Optional)
 * param parentId: 父分类ID (Optional)
 * param description: 分类描述信息 (Optional)
 */
func NewCreateCategoryRequestWithAllParams(
    name *string,
    level *int,
    parentId *int64,
    description *string,
) *CreateCategoryRequest {

    return &CreateCategoryRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/categories",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        Name: name,
        Level: level,
        ParentId: parentId,
        Description: description,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewCreateCategoryRequestWithoutParam() *CreateCategoryRequest {

    return &CreateCategoryRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/categories",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param name: 分类名称(Optional) */
func (r *CreateCategoryRequest) SetName(name string) {
    r.Name = &name
}

/* param level: 分类级别(Optional) */
func (r *CreateCategoryRequest) SetLevel(level int) {
    r.Level = &level
}

/* param parentId: 父分类ID(Optional) */
func (r *CreateCategoryRequest) SetParentId(parentId int64) {
    r.ParentId = &parentId
}

/* param description: 分类描述信息(Optional) */
func (r *CreateCategoryRequest) SetDescription(description string) {
    r.Description = &description
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r CreateCategoryRequest) GetRegionId() string {
    return ""
}

type CreateCategoryResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result CreateCategoryResult `json:"result"`
}

type CreateCategoryResult struct {
    Id int64 `json:"id"`
    Name string `json:"name"`
    Level int `json:"level"`
    ParentId int64 `json:"parentId"`
    Description string `json:"description"`
    CreateTime string `json:"createTime"`
    UpdateTime string `json:"updateTime"`
}