// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    vod "github.com/jdcloud-api/jdcloud-sdk-go/services/vod/models"
)

type GetTranscodeTemplateRequest struct {

    core.JDCloudRequest

    /* 模板ID  */
    TemplateId int `json:"templateId"`
}

/*
 * param templateId: 模板ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewGetTranscodeTemplateRequest(
    templateId int,
) *GetTranscodeTemplateRequest {

	return &GetTranscodeTemplateRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/transcodeTemplates/{templateId}",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
        TemplateId: templateId,
	}
}

/*
 * param templateId: 模板ID (Required)
 */
func NewGetTranscodeTemplateRequestWithAllParams(
    templateId int,
) *GetTranscodeTemplateRequest {

    return &GetTranscodeTemplateRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/transcodeTemplates/{templateId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        TemplateId: templateId,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewGetTranscodeTemplateRequestWithoutParam() *GetTranscodeTemplateRequest {

    return &GetTranscodeTemplateRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/transcodeTemplates/{templateId}",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param templateId: 模板ID(Required) */
func (r *GetTranscodeTemplateRequest) SetTemplateId(templateId int) {
    r.TemplateId = templateId
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r GetTranscodeTemplateRequest) GetRegionId() string {
    return ""
}

type GetTranscodeTemplateResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result GetTranscodeTemplateResult `json:"result"`
}

type GetTranscodeTemplateResult struct {
    Id int64 `json:"id"`
    Name string `json:"name"`
    Video vod.Video `json:"video"`
    Audio vod.Audio `json:"audio"`
    Encapsulation vod.Encapsulation `json:"encapsulation"`
    Definition string `json:"definition"`
    Source string `json:"source"`
    CreateTime string `json:"createTime"`
    UpdateTime string `json:"updateTime"`
}