// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    vod "github.com/jdcloud-api/jdcloud-sdk-go/services/vod/models"
)

type ListDomainsRequest struct {

    core.JDCloudRequest

    /* 页码；默认值为1 (Optional) */
    PageNumber *int `json:"pageNumber"`

    /* 分页大小；默认值为10；取值范围[10, 100] (Optional) */
    PageSize *int `json:"pageSize"`

    /*  (Optional) */
    Sorts []vod.Sort `json:"sorts"`
}

/*
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewListDomainsRequest(
) *ListDomainsRequest {

	return &ListDomainsRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/domains",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
	}
}

/*
 * param pageNumber: 页码；默认值为1 (Optional)
 * param pageSize: 分页大小；默认值为10；取值范围[10, 100] (Optional)
 * param sorts:  (Optional)
 */
func NewListDomainsRequestWithAllParams(
    pageNumber *int,
    pageSize *int,
    sorts []vod.Sort,
) *ListDomainsRequest {

    return &ListDomainsRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/domains",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        PageNumber: pageNumber,
        PageSize: pageSize,
        Sorts: sorts,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewListDomainsRequestWithoutParam() *ListDomainsRequest {

    return &ListDomainsRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/domains",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param pageNumber: 页码；默认值为1(Optional) */
func (r *ListDomainsRequest) SetPageNumber(pageNumber int) {
    r.PageNumber = &pageNumber
}

/* param pageSize: 分页大小；默认值为10；取值范围[10, 100](Optional) */
func (r *ListDomainsRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

/* param sorts: (Optional) */
func (r *ListDomainsRequest) SetSorts(sorts []vod.Sort) {
    r.Sorts = sorts
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ListDomainsRequest) GetRegionId() string {
    return ""
}

type ListDomainsResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ListDomainsResult `json:"result"`
}

type ListDomainsResult struct {
}