// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    vod "github.com/jdcloud-api/jdcloud-sdk-go/services/vod/models"
)

type ListVideosRequest struct {

    core.JDCloudRequest

    /* 页码；默认值为1 (Optional) */
    PageNumber *int `json:"pageNumber"`

    /* 分页大小；默认值为10；取值范围[10, 100] (Optional) */
    PageSize *int `json:"pageSize"`

    /*  (Optional) */
    Filters []vod.Filter `json:"filters"`

    /*  (Optional) */
    Sorts []vod.Sort `json:"sorts"`
}

/*
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewListVideosRequest(
) *ListVideosRequest {

	return &ListVideosRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/videos",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
	}
}

/*
 * param pageNumber: 页码；默认值为1 (Optional)
 * param pageSize: 分页大小；默认值为10；取值范围[10, 100] (Optional)
 * param filters:  (Optional)
 * param sorts:  (Optional)
 */
func NewListVideosRequestWithAllParams(
    pageNumber *int,
    pageSize *int,
    filters []vod.Filter,
    sorts []vod.Sort,
) *ListVideosRequest {

    return &ListVideosRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/videos",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        PageNumber: pageNumber,
        PageSize: pageSize,
        Filters: filters,
        Sorts: sorts,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewListVideosRequestWithoutParam() *ListVideosRequest {

    return &ListVideosRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/videos",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param pageNumber: 页码；默认值为1(Optional) */
func (r *ListVideosRequest) SetPageNumber(pageNumber int) {
    r.PageNumber = &pageNumber
}

/* param pageSize: 分页大小；默认值为10；取值范围[10, 100](Optional) */
func (r *ListVideosRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

/* param filters: (Optional) */
func (r *ListVideosRequest) SetFilters(filters []vod.Filter) {
    r.Filters = filters
}

/* param sorts: (Optional) */
func (r *ListVideosRequest) SetSorts(sorts []vod.Sort) {
    r.Sorts = sorts
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ListVideosRequest) GetRegionId() string {
    return ""
}

type ListVideosResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ListVideosResult `json:"result"`
}

type ListVideosResult struct {
}