// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type ListWatermarksRequest struct {

    core.JDCloudRequest

    /* 页码；默认值为1 (Optional) */
    PageNumber *int `json:"pageNumber"`

    /* 分页大小；默认值为10；取值范围[10, 100] (Optional) */
    PageSize *int `json:"pageSize"`
}

/*
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewListWatermarksRequest(
) *ListWatermarksRequest {

	return &ListWatermarksRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/watermarks",
			Method:  "GET",
			Header:  nil,
			Version: "v1",
		},
	}
}

/*
 * param pageNumber: 页码；默认值为1 (Optional)
 * param pageSize: 分页大小；默认值为10；取值范围[10, 100] (Optional)
 */
func NewListWatermarksRequestWithAllParams(
    pageNumber *int,
    pageSize *int,
) *ListWatermarksRequest {

    return &ListWatermarksRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/watermarks",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
        PageNumber: pageNumber,
        PageSize: pageSize,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewListWatermarksRequestWithoutParam() *ListWatermarksRequest {

    return &ListWatermarksRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/watermarks",
            Method:  "GET",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param pageNumber: 页码；默认值为1(Optional) */
func (r *ListWatermarksRequest) SetPageNumber(pageNumber int) {
    r.PageNumber = &pageNumber
}

/* param pageSize: 分页大小；默认值为10；取值范围[10, 100](Optional) */
func (r *ListWatermarksRequest) SetPageSize(pageSize int) {
    r.PageSize = &pageSize
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ListWatermarksRequest) GetRegionId() string {
    return ""
}

type ListWatermarksResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ListWatermarksResult `json:"result"`
}

type ListWatermarksResult struct {
}