// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    vod "github.com/jdcloud-api/jdcloud-sdk-go/services/vod/models"
)

type UpdateTranscodeTemplateRequest struct {

    core.JDCloudRequest

    /* 模板ID  */
    TemplateId int `json:"templateId"`

    /* 模板ID (Optional) */
    Id *int64 `json:"id"`

    /* 模板名称 (Optional) */
    Name *string `json:"name"`

    /* 视频参数 (Optional) */
    Video *vod.Video `json:"video"`

    /* 音频参数 (Optional) */
    Audio *vod.Audio `json:"audio"`

    /* 封装配置 (Optional) */
    Encapsulation *vod.Encapsulation `json:"encapsulation"`

    /* 清晰度规格 (Optional) */
    Definition *string `json:"definition"`
}

/*
 * param templateId: 模板ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewUpdateTranscodeTemplateRequest(
    templateId int,
) *UpdateTranscodeTemplateRequest {

	return &UpdateTranscodeTemplateRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/transcodeTemplates/{templateId}",
			Method:  "PUT",
			Header:  nil,
			Version: "v1",
		},
        TemplateId: templateId,
	}
}

/*
 * param templateId: 模板ID (Required)
 * param id: 模板ID (Optional)
 * param name: 模板名称 (Optional)
 * param video: 视频参数 (Optional)
 * param audio: 音频参数 (Optional)
 * param encapsulation: 封装配置 (Optional)
 * param definition: 清晰度规格 (Optional)
 */
func NewUpdateTranscodeTemplateRequestWithAllParams(
    templateId int,
    id *int64,
    name *string,
    video *vod.Video,
    audio *vod.Audio,
    encapsulation *vod.Encapsulation,
    definition *string,
) *UpdateTranscodeTemplateRequest {

    return &UpdateTranscodeTemplateRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/transcodeTemplates/{templateId}",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
        TemplateId: templateId,
        Id: id,
        Name: name,
        Video: video,
        Audio: audio,
        Encapsulation: encapsulation,
        Definition: definition,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewUpdateTranscodeTemplateRequestWithoutParam() *UpdateTranscodeTemplateRequest {

    return &UpdateTranscodeTemplateRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/transcodeTemplates/{templateId}",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param templateId: 模板ID(Required) */
func (r *UpdateTranscodeTemplateRequest) SetTemplateId(templateId int) {
    r.TemplateId = templateId
}

/* param id: 模板ID(Optional) */
func (r *UpdateTranscodeTemplateRequest) SetId(id int64) {
    r.Id = &id
}

/* param name: 模板名称(Optional) */
func (r *UpdateTranscodeTemplateRequest) SetName(name string) {
    r.Name = &name
}

/* param video: 视频参数(Optional) */
func (r *UpdateTranscodeTemplateRequest) SetVideo(video *vod.Video) {
    r.Video = video
}

/* param audio: 音频参数(Optional) */
func (r *UpdateTranscodeTemplateRequest) SetAudio(audio *vod.Audio) {
    r.Audio = audio
}

/* param encapsulation: 封装配置(Optional) */
func (r *UpdateTranscodeTemplateRequest) SetEncapsulation(encapsulation *vod.Encapsulation) {
    r.Encapsulation = encapsulation
}

/* param definition: 清晰度规格(Optional) */
func (r *UpdateTranscodeTemplateRequest) SetDefinition(definition string) {
    r.Definition = &definition
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r UpdateTranscodeTemplateRequest) GetRegionId() string {
    return ""
}

type UpdateTranscodeTemplateResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result UpdateTranscodeTemplateResult `json:"result"`
}

type UpdateTranscodeTemplateResult struct {
    Id int64 `json:"id"`
    Name string `json:"name"`
    Video vod.Video `json:"video"`
    Audio vod.Audio `json:"audio"`
    Encapsulation vod.Encapsulation `json:"encapsulation"`
    Definition string `json:"definition"`
    Source string `json:"source"`
    CreateTime string `json:"createTime"`
    UpdateTime string `json:"updateTime"`
}