// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
    vod "github.com/jdcloud-api/jdcloud-sdk-go/services/vod/models"
)

type UpdateVideoRequest struct {

    core.JDCloudRequest

    /* 视频ID  */
    VideoId string `json:"videoId"`

    /* 视频ID (Optional) */
    Id *string `json:"id"`

    /* 视频名称 (Optional) */
    Name *string `json:"name"`

    /* 分类ID (Optional) */
    CategoryId *int64 `json:"categoryId"`

    /* 标签 (Optional) */
    Tags []string `json:"tags"`

    /* 封面地址 (Optional) */
    CoverUrl *string `json:"coverUrl"`

    /* 视频描述 (Optional) */
    Description *string `json:"description"`
}

/*
 * param videoId: 视频ID (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewUpdateVideoRequest(
    videoId string,
) *UpdateVideoRequest {

	return &UpdateVideoRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/videos/{videoId}",
			Method:  "PUT",
			Header:  nil,
			Version: "v1",
		},
        VideoId: videoId,
	}
}

/*
 * param videoId: 视频ID (Required)
 * param id: 视频ID (Optional)
 * param name: 视频名称 (Optional)
 * param categoryId: 分类ID (Optional)
 * param tags: 标签 (Optional)
 * param coverUrl: 封面地址 (Optional)
 * param description: 视频描述 (Optional)
 */
func NewUpdateVideoRequestWithAllParams(
    videoId string,
    id *string,
    name *string,
    categoryId *int64,
    tags []string,
    coverUrl *string,
    description *string,
) *UpdateVideoRequest {

    return &UpdateVideoRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/videos/{videoId}",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
        VideoId: videoId,
        Id: id,
        Name: name,
        CategoryId: categoryId,
        Tags: tags,
        CoverUrl: coverUrl,
        Description: description,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewUpdateVideoRequestWithoutParam() *UpdateVideoRequest {

    return &UpdateVideoRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/videos/{videoId}",
            Method:  "PUT",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param videoId: 视频ID(Required) */
func (r *UpdateVideoRequest) SetVideoId(videoId string) {
    r.VideoId = videoId
}

/* param id: 视频ID(Optional) */
func (r *UpdateVideoRequest) SetId(id string) {
    r.Id = &id
}

/* param name: 视频名称(Optional) */
func (r *UpdateVideoRequest) SetName(name string) {
    r.Name = &name
}

/* param categoryId: 分类ID(Optional) */
func (r *UpdateVideoRequest) SetCategoryId(categoryId int64) {
    r.CategoryId = &categoryId
}

/* param tags: 标签(Optional) */
func (r *UpdateVideoRequest) SetTags(tags []string) {
    r.Tags = tags
}

/* param coverUrl: 封面地址(Optional) */
func (r *UpdateVideoRequest) SetCoverUrl(coverUrl string) {
    r.CoverUrl = &coverUrl
}

/* param description: 视频描述(Optional) */
func (r *UpdateVideoRequest) SetDescription(description string) {
    r.Description = &description
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r UpdateVideoRequest) GetRegionId() string {
    return ""
}

type UpdateVideoResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result UpdateVideoResult `json:"result"`
}

type UpdateVideoResult struct {
    Id string `json:"id"`
    Name string `json:"name"`
    Description string `json:"description"`
    CoverUrl string `json:"coverUrl"`
    Status string `json:"status"`
    FileSize int64 `json:"fileSize"`
    Checksum string `json:"checksum"`
    Duration int64 `json:"duration"`
    Tags []string `json:"tags"`
    CategoryId int64 `json:"categoryId"`
    CategoryName string `json:"categoryName"`
    Snapshots []vod.Snapshot `json:"snapshots"`
    CreateTime string `json:"createTime"`
    UpdateTime string `json:"updateTime"`
}