// Copyright 2018 JDCLOUD.COM
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// NOTE: This class is auto generated by the jdcloud code generator program.

package apis

import (
    "github.com/jdcloud-api/jdcloud-sdk-go/core"
)

type ExecutePySparkQueryRequest struct {

    core.JDCloudRequest

    /* 地域ID  */
    RegionId string `json:"regionId"`

    /* PySpark脚本  */
    Script string `json:"script"`

    /* 用户名称  */
    UserName string `json:"userName"`

    /* 实例名称  */
    InstanceName string `json:"instanceName"`

    /* 实例拥有者名称 (Optional) */
    InstanceOwnerName *string `json:"instanceOwnerName"`

    /* 脚本类型名称 (Optional) */
    ScriptType *string `json:"scriptType"`
}

/*
 * param regionId: 地域ID (Required)
 * param script: PySpark脚本 (Required)
 * param userName: 用户名称 (Required)
 * param instanceName: 实例名称 (Required)
 *
 * @Deprecated, not compatible when mandatory parameters changed
 */
func NewExecutePySparkQueryRequest(
    regionId string,
    script string,
    userName string,
    instanceName string,
) *ExecutePySparkQueryRequest {

	return &ExecutePySparkQueryRequest{
        JDCloudRequest: core.JDCloudRequest{
			URL:     "/regions/{regionId}/dwQuery:executePySparkQuery",
			Method:  "POST",
			Header:  nil,
			Version: "v1",
		},
        RegionId: regionId,
        Script: script,
        UserName: userName,
        InstanceName: instanceName,
	}
}

/*
 * param regionId: 地域ID (Required)
 * param script: PySpark脚本 (Required)
 * param userName: 用户名称 (Required)
 * param instanceName: 实例名称 (Required)
 * param instanceOwnerName: 实例拥有者名称 (Optional)
 * param scriptType: 脚本类型名称 (Optional)
 */
func NewExecutePySparkQueryRequestWithAllParams(
    regionId string,
    script string,
    userName string,
    instanceName string,
    instanceOwnerName *string,
    scriptType *string,
) *ExecutePySparkQueryRequest {

    return &ExecutePySparkQueryRequest{
        JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/dwQuery:executePySparkQuery",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
        RegionId: regionId,
        Script: script,
        UserName: userName,
        InstanceName: instanceName,
        InstanceOwnerName: instanceOwnerName,
        ScriptType: scriptType,
    }
}

/* This constructor has better compatible ability when API parameters changed */
func NewExecutePySparkQueryRequestWithoutParam() *ExecutePySparkQueryRequest {

    return &ExecutePySparkQueryRequest{
            JDCloudRequest: core.JDCloudRequest{
            URL:     "/regions/{regionId}/dwQuery:executePySparkQuery",
            Method:  "POST",
            Header:  nil,
            Version: "v1",
        },
    }
}

/* param regionId: 地域ID(Required) */
func (r *ExecutePySparkQueryRequest) SetRegionId(regionId string) {
    r.RegionId = regionId
}

/* param script: PySpark脚本(Required) */
func (r *ExecutePySparkQueryRequest) SetScript(script string) {
    r.Script = script
}

/* param userName: 用户名称(Required) */
func (r *ExecutePySparkQueryRequest) SetUserName(userName string) {
    r.UserName = userName
}

/* param instanceName: 实例名称(Required) */
func (r *ExecutePySparkQueryRequest) SetInstanceName(instanceName string) {
    r.InstanceName = instanceName
}

/* param instanceOwnerName: 实例拥有者名称(Optional) */
func (r *ExecutePySparkQueryRequest) SetInstanceOwnerName(instanceOwnerName string) {
    r.InstanceOwnerName = &instanceOwnerName
}

/* param scriptType: 脚本类型名称(Optional) */
func (r *ExecutePySparkQueryRequest) SetScriptType(scriptType string) {
    r.ScriptType = &scriptType
}

// GetRegionId returns path parameter 'regionId' if exist,
// otherwise return empty string
func (r ExecutePySparkQueryRequest) GetRegionId() string {
    return r.RegionId
}

type ExecutePySparkQueryResponse struct {
    RequestID string `json:"requestId"`
    Error core.ErrorResponse `json:"error"`
    Result ExecutePySparkQueryResult `json:"result"`
}

type ExecutePySparkQueryResult struct {
    Status bool `json:"status"`
    Message string `json:"message"`
    Data int `json:"data"`
}